﻿using System;
using System.Collections.Generic;
using System.Text;
using Ice.Net.Ecommerce.CacheProvider;

namespace Ice.Net.Ecommerce.BusinessObjects.Common
{
	public class OnlineDemoSkin
	{
		public string SkinDirectory = "";

		public OnlineDemoSkin()
		{
		}

		public OnlineDemoSkin(string skinDirectory)
		{
			this.SkinDirectory = skinDirectory;
		}
	}

	public class OnlineDemoSkinHelper
	{
		private static bool mIsOnlineDemo = System.Configuration.ConfigurationManager.AppSettings["OnlineDemo"] == "true";
		private static bool mIsOnlineDemoAdmin = System.Configuration.ConfigurationManager.AppSettings["OnlineDemoAdmin"] == "true";

		public static bool IsOnlineDemo
		{
			get { return mIsOnlineDemo; }
		}

		public static bool IsOnlineDemoAdmin
		{
			get { return mIsOnlineDemoAdmin; }
		}

		public static bool SetSkinDirectory(string skinDirectory)
		{
			// remove items from Application Cache
			VISTACARTHelper.CleanApplicationStore();

			OnlineDemoSkin dskin = new OnlineDemoSkin(skinDirectory);
			return CookieStore.Save(dskin);
		}

		public static string GetCurrentSkinDirectory()
		{
			OnlineDemoSkin demoSkin = CookieStore.Retrieve<OnlineDemoSkin>();
			if (demoSkin != null)
			{
				return demoSkin.SkinDirectory;
			}
			else
			{
				return VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.SkinDirectory;
			}
		}
	}
}
