﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;
using System.Linq;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class Country
	{
		#region Public properties

		private StateCollection mStates = null;

		public StateCollection GetStateCollection()
		{
			if (mStates == null)
			{
				mStates = new StateCollection();
				mStates.AddRange(StateCollection.LoadByCountryID(this.CountryID, false));
			}
			return mStates;
		}

		private Tax mTax = null;

		public Tax GetTax()
		{
			if (mTax == null)
			{
				mTax = new Tax();
				mTax.LoadFromDB(this.TaxID);
			}
			return mTax;
		}

		public string TaxName
		{
			get { return this.GetTax().Name; }
		}

		#endregion

		#region Database methods

		public static Country LoadBySymbol(string symbol)
		{
			return new Query().Where(db.Country.Symbol, symbol).ToList<Country>().FirstOrDefault();
		}

		public static Country LoadBySymbolShort(string symbolShort)
		{
			return new Query().Where(db.Country.SymbolShort, symbolShort).ToList<Country>().FirstOrDefault();
		}

		public static Country LoadByName(string name)
		{
			return new Query().Where(db.Country.Name, name).ToList<Country>().FirstOrDefault();
		}

		#endregion

		#region Database methods overrides
		// Database methods

		/// <summary>
		/// Delete this and it's StateCollection
		/// </summary>
		/// <returns></returns>
		public override bool DeleteFromDB()
		{
			// delete states first
			StateCollection states = new StateCollection();
			states.DeleteByCountryID(this.CountryID);
			// delete this
			return base.DeleteFromDB();
		}

		#endregion

	}

}
