﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class Message
	{
		public enum NameEnum
		{
			CartIsEmpty = 1,
			Select = 2,
			Remove = 3,
			Subtotal = 4,
			Price = 5,
			Quantity = 6,
			Product = 7,
			Size = 8,
			Empty = 9,
			Tax = 10,
			Shipping = 11,
			TaxIncluded = 12,
			Checkout = 13,
			LoginFirst = 14,
			AccountLocked = 15,
			SelectShippingType = 16,
			SelectPaymentType = 17,
			InvalidLogin = 18,
			InvalidEmail = 19,
			EmailNotFound = 20,
			EmailAlreadyExist = 21,
			EmailAdded = 22,
			ServerInternalError = 23,
			UserAlreadySingedIn = 24,
			WrongUser = 25,
			MinUsernameLength = 26,
			MinPasswordLength = 27,
			EmailBelongToAnotherAccount = 28,
			SavedSucessfully = 29,
			AccountCreated = 30,
			UsernameTaken = 31,
			YourPassword = 32,
			UsernameAndPasswordSentTo = 33,
			Username = 34,
			Password = 35,
			SelectAttributes = 37,
			UserInfoNote = 38,
			Recalculate = 39,
			PaymentType = 40,
			Reserved = 41,
			Number = 42,
			Date = 43,
			Total = 44,
			Status = 45,
			Payment = 46,
			NoPreviousOrders = 47,
			OrderNumber = 48,
			OutOfStock = 49,
			AgreeWithTerms = 50,
			PayNow = 51,
			Processing = 52,
			InvalidPayementType = 53,
			MissingRequiredFields = 54,
			WhatIsThis= 55,
			BillingAddress = 56,
			ShippingAddress = 57,
			YourOrder = 58,
			GuestCheckoutWarning = 59,
			Forward = 60,
			Back = 61,
			SearchResult = 62,
			Categories = 63,
			Language = 64,
			Currency = 65,
			Search = 66,
			ShoppingCart = 67

		}

		#region Static methods

		/// <summary>
		/// Get content in language
		/// </summary>
		/// <param name="name"></param>
		/// <returns></returns>
		public static string GetContent(NameEnum name)
		{
			return GetContent((int)name);
		}

		/// <summary>
		/// Get content in language
		/// </summary>
		/// <param name="messageID"></param>
		/// <returns></returns>
		public static string GetContent(int messageID)
		{
			Message dc = new Message();
			if (dc.LoadFromDB(messageID) && dc.IsActive)
			{
				return dc.Content;
			}
			else
			{
				return "";
			}
		}

		#endregion

		#region Database methods overrides

		#endregion

		#region Public static methods

		public static Message LoadMessage(NameEnum messageName)
		{
			return LoadMessage((int)messageName);
		}

		public static Message LoadMessage(int messageID)
		{
			Message message = new Message();
			message.LoadFromDB(messageID);
			return message;
		}

		#endregion
	}

}
