﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class OrderDetail
	{
		#region Database methods
		// Database methods

		#endregion

		private Product mProduct = null;

		public Product GetProduct()
		{
			if (mProduct == null)
			{
				mProduct = new Product();
				mProduct.LoadFromDB(this.ProductID);
			}
			return mProduct;
		}

		public bool RecalculateRedundantValues()
		{
			this.RedundantSalePrice = this.GetProduct().GetCalculatedSalePrice();
			this.RedundantSupplyPrice = this.GetProduct().SupplyPrice;
			this.RedundantTaxPrice = this.GetProduct().GetCalculatedTaxAmount();
			this.RedundantWeight = this.GetProduct().Weight;
			return true;
		}

		public bool RecalculateRedundantValues(CampaignHelper campaignHelper)
		{
			this.RedundantSalePrice = campaignHelper.GetSalePrice(this.GetProduct());
			this.RedundantSupplyPrice = this.GetProduct().SupplyPrice;
			this.RedundantTaxPrice = campaignHelper.GetTaxAmount(this.GetProduct());
			this.RedundantWeight = this.GetProduct().Weight;
			return true;
		}

		/// <summary>
		/// Create instance from productID
		/// </summary>
		/// <param name="productID"></param>
		public OrderDetail(int? productID, int? quantity, string attributes)
		{
			Product product = new Product();
			if (product.LoadFromDB(productID) && product.IsActive)
			{
				this.ProductID = productID;
				this.Quantity = quantity.GetValueOrDefault();
				this.Attributes = attributes;
				////RecalculateRedundantValues(); // we'll recalculate at ShoppingCart.Save()
			}
		}

	}

}
