﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Collections;

namespace Ice.Net.Ecommerce.CacheProvider
{
	internal class ApplicationStore
	{
		const string mAppStoreKey = "GAppStoreKey";
		private static object mLock = new object();

		private static Hashtable GetHashtable()
		{
			Hashtable ht = HttpRuntime.Cache[mAppStoreKey] as Hashtable;
			if (ht == null)
			{
				ht = new Hashtable();
				HttpRuntime.Cache[mAppStoreKey] = ht;
			}
			return ht;
		}

		/// <summary>
		/// Remove all cached items from Application
		/// </summary>
		public static void RemoveAll()
		{
			HttpContext.Current.Application[mAppStoreKey] = null;
		}

		/// <summary>
		/// Save object to session
		/// </summary>
		/// <param name="obj"></param>
		/// <returns></returns>
		public static void Save(Object obj)
		{
			Save(obj, obj.GetType().FullName);
		}

		public static void Save(Object obj, string key)
		{
			lock (mLock)
			{
				GetHashtable()[key] = obj;
			}
		}

		public static void Delete(Type type)
		{
			Delete(type.FullName);
		}

		public static void Delete(string key)
		{
			lock (mLock)
			{
				GetHashtable().Remove(key);
			}
		}

		public static T Retrieve<T>()
		{
			return RetrieveByName<T>(typeof(T).FullName);
		}

		public static T RetrieveByName<T>(string key)
		{
			Object obj;
			lock (mLock)
			{
				obj = GetHashtable()[key];
			}

			if (obj != null)
			{
				return (T)obj;
			}
			else
			{
				return default(T);
			}
		}
	}
}