﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;

namespace Ice.Net.Ecommerce.CacheProvider
{
	internal class SessionStore
	{
		/// <summary>
		/// Remove all cached objects from Session
		/// </summary>
		public static void RemoveAll()
		{
			HttpContext.Current.Session.RemoveAll();
		}

		/// <summary>
		/// Save object to session
		/// </summary>
		/// <param name="obj"></param>
		/// <returns></returns>
		public static void Save(Object obj)
		{
			Save(obj, obj.GetType().FullName);
		}

		public static void Save(Object obj, string sessionKey)
		{
			HttpContext.Current.Session[sessionKey] = obj;
		}

		public static void Delete(Type type)
		{
			Delete(type.FullName);
		}

		public static void Delete(string sessionKey)
		{
			HttpContext.Current.Session.Remove(sessionKey);
		}

		public static T Retrieve<T>()
		{
			return RetrieveByName<T>(typeof(T).FullName);
		}

		public static T RetrieveByName<T>(string sessionKey)
		{
			Object obj = HttpContext.Current.Session[sessionKey];
			if (obj != null)
			{
				return (T)obj;
			}
			else
			{
				return default(T);
			}
		}
	}
}
