﻿using System;
using System.Collections.Generic;
using System.Text;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;

namespace Ice.Net.Ecommerce.PaymentGateways
{
	public class CreditCardInfo
	{
		public string CCNumber = "";
		public string CVVCode = "";
		public string ExpMonth = "";
		
		/// <summary>
		/// Year format YYYY (example: 2008)
		/// </summary>
		public string ExpYear = "";
		public int PaymentTypeID = 0;

		/// <summary>
		/// Year format YY (example: 08)
		/// </summary>
		public string ExpYearShort
		{
			get { return (this.ExpYear ?? "").Length > 2 ? this.ExpYear.Substring(2) : this.ExpYear; }
		}

		public CreditCardInfo()
		{
		}

		public static string GetFormHtml(int paymentTypeID)
		{
			// fields from CreditCardInfo class

			return String.Format(@"<table cellpadding='0' cellspacing='5px' align='center'>\
<tr><td>Credit Card Number</td><td><input class='requiredField' type='text' name='CCNumber' maxlength='20' /></td><td><span class='requiredFieldMark'>*</span></td></tr>\
<tr><td>CVV Code</td><td><input type='text' name='CVVCode' maxlength='5' /></td><td><a href='#' onclick='Ice.GCart.ShowCVVExplanation(); return false;');'>{3}</a></td></tr>\
<tr><td>Expiration Date</td><td>\
<select name='ExpMonth' style='width:60px;'><option value='01'>01</option><option value='02'>02</option>  <option value='03'>03</option>  <option value='04'>04</option>  <option value='05'>05</option>  <option value='06'>06</option>  <option value='07'>07</option>  <option value='08'>08</option>  <option value='09'>09</option>  <option value='10'>10</option>  <option value='11'>11</option>  <option value='12'>12</option></select>&nbsp;\
<select name='ExpYear' style='width:80px'>  <option value='2007'>2007</option>  <option value='2008'>2008</option>  <option value='2009'>2009</option>  <option value='2010'>2010</option>  <option value='2011'>2011</option>  <option value='2012'>2012</option>  <option value='2013'>2013</option>  <option value='2014'>2014</option>  <option value='2015'>2015</option>  <option value='2016'>2016</option>  <option value='2017'>2017</option>  <option value='2018'>2018</option>  <option value='2019'>2019</option>  <option value='2020'>2020</option>  <option value='2021'>2021</option>  <option value='2022'>2022</option>  <option value='2023'>2023</option>  <option value='2024'>2024</option>  <option value='2025'>2025</option>  <option value='2026'>2026</option>  <option value='2027'>2027</option>  <option value='2028'>2028</option>  <option value='2029'>2029</option>  <option value='2030'>2030</option>  </select>\
<input type='hidden' value='{0}' name='PaymentTypeID' />\
</td><td><span class='requiredFieldMark'>*</span></td></tr>\
<tr><td></td><td><input type='button' value='{1}' onclick='Ice.GCart.ConfirmCCNumber(this, \""{2}\"");'/></td><td></td></tr>\
</table>",
		 paymentTypeID,
		 Message.GetContent(Message.NameEnum.PayNow) + "!",
		 Message.GetContent(Message.NameEnum.Processing) + "...",
		 Message.GetContent(Message.NameEnum.WhatIsThis));

		}
	}
}
