﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;

namespace Ice.Net.Ecommerce.PaymentGateways
{
	#region NameValuePair class

	////internal class NameValuePair
	////{
	////    public string Name = "";
	////    public string Value = "";

	////    public NameValuePair(string name, string value)
	////    {
	////        this.Name = name;
	////        this.Value = value;
	////    }

	////    public override string ToString()
	////    {
	////        return this.Name + "=" + this.Value;
	////    }
	////}

	#endregion

	#region NameValuePairCollection class

	internal class NameValuePairCollection : System.Collections.Hashtable
	{
		static string restr = "(?<name>[^\\/\\<\\>\\?\\&\\=\\\"\\'\\ ]{1,})\\=(?<value>[^\\/\\<\\>\\?\\&\\=\\\"\\'\\ ]{0,})";

		public NameValuePairCollection()
		{
		}

		public NameValuePairCollection(string url)
		{
			ParseQueryStringParameters(url);
		}

		static Regex re = new Regex(restr, RegexOptions.Singleline);

		private int ParseQueryStringParameters(string url)
		{
			
			MatchCollection mcoll = re.Matches(url);
			foreach (Match m in mcoll)
			{
				base[m.Groups["name"].Value] = m.Groups["value"].Value;
			}
			return this.Count;
		}

		private string HtmlEncodeForGet(string str)
		{
			return HttpUtility.UrlEncode(HtmlEncodeForInput(str).Replace(" ", "_"));
		}

		private string HtmlEncodeForInput(string str)
		{
			return str.Replace("\"", "'").Replace("\n", " ").Replace("\r", "");
		}

		public string ToFormGETString()
		{
			StringBuilder sb = new StringBuilder();
			int count = 0;
			foreach (object key in this.Keys)
			{
				if (count++ > 0)
				{
					sb.Append("&");
				}
				sb.Append(HtmlEncodeForGet(key + "") + "=" + HtmlEncodeForGet(base[key] + ""));

			}
			return sb.ToString();
		}

		public string ToFormPOSTInputs()
		{
			StringBuilder sb = new StringBuilder();
			foreach (object key in base.Keys)
			{
				sb.Append(String.Format("<input type=\"hidden\" name=\"{0}\" value=\"{1}\" />\r\n", HtmlEncodeForInput(key + ""), HtmlEncodeForInput(base[key] + "")));
			}
			return sb.ToString();
		}

		public override string ToString()
		{			StringBuilder sb = new StringBuilder();
			int count = this.Count;
			foreach (object key in base.Keys)
			{
				sb.Append(key + "=" + base[key]);
				if (--count > 0)
				{
					sb.Append("&");
				}
			}
			return sb.ToString();
		}
	}
	#endregion
}
