﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal class PGChronoPay : BasePG
	{
		public override bool AIMMethod
		{
			get { return false;}
		}

		public override PGNameEnum PGNameEnum
		{
			get { return PGNameEnum._ChronoPay; }
		}

		public override PGResult GetFormWithParameters(Order order)
		{
			return new PGResult(null, this.GetForm(order), null);
		}

		public override PGStatus GetReceivedStatus(HttpContext context)
		{
			return this.DecodeData(context);
		}
		public override PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order)
		{
			return null;
		}


		#region Control Panel HTML

		public override string GetControlPanelHtml()
		{
			return string.Format(@"
<!--CHRONOPAY CONTROL PANEL-->
<table cellpadding='0px' cellspacing='5px' >
<tr><td >Name</td><td><input type='text' name='Name' style='width:255px;'/></td></tr>
<tr><td >Active</td><td><input type='checkbox' name='IsActive' /></td></tr>
<tr><td >Demo</td><td><input type='checkbox' name='IsDemo' /></td></tr>
<tr><td >Diagnostic</td><td><input type='checkbox' name='IsDiagnostic' /></td></tr>
<tr><td >Product ID</td><td><input name='MerchantId' type='text' style='width:256px;' /></td></tr>
<tr><td >Product Name</td><td><input name='MerchantKey' type='text' style='width:255px;' /></td></tr>
<tr><td >Language</td><td>
<select name='LanguageCode'>
<option value='EN'>English</option>
<option value='RU'>Russian</option>
<option value='NL'>Dutch</option>
<option value='DE'>German</option>
</select>
</td></tr>
<tr><td >Description<br/></td><td><textarea id='chronoDescription'  name='Description' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>
<tr><td >Long Description<br/></td><td><textarea id='chronoLongDescription' name='LongDescription' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>

<tr><td colspan='2' style='text-align:center;height:80px;background-image:url({0}admin/pglogo/chronopay.gif); background-repeat:no-repeat; background-position:center center'>&nbsp;</td></tr>
<tr><td colspan='2' style='text-align:center; height:20px'><a href='http://www.ChronoPay.com' target='_blank'><b> http://www.ChronoPay.com </b></a></td></tr>
<tr><td></td><td><div style='display:none'>
<!--quick help content-->
<b>Product ID</b> your ChronoPay Product ID (XXXXXX-XXXX-XXXX). <br/> <b>Product Name</b> product creation name.<br/><b>Language</b> (EN, RU, NL) payment gateway interface language.<br/><b>Diagnostic Mode</b> any callback from active payment gateway will be logged into <em>[ticks].txt</em> file saved into App_Data directory, directory must have write permissions. <br/>Callback URL is generated automatically ({0}).<br/><br/>Log into your ChronoPay account and setup product parameter <br/><b>Access URL:</b> {0}{1} <br /> (Where to redirect the user after sucessful payment).
</div><div align='right'><a href='#' onclick='QoDesk.PaymentTypeEditor.ShowQuickHelp(this);'><b>Quick Help</b></a></div>
</td></tr>
</table>
",
	mSiteRoot,
	OrderCompletePage
);

		}

		#endregion


		// checkout page is checkoutconfirm.aspx and returning url after purchase is the same page
		// callback url is chronopaycallback.aspx

		// test account ProductID: 003325-0020-0001

		// USER DEPENDING PARAMETERS
		private static string mTransactionUrl = "https://secure.chronopay.com/index_shop.cgi";
		
		//	private string ProductID;  // "XXXXXX-XXXX-XXXX";	//Login name
		//	private string ProductName; // product name
		//	private string Language = ""; // EN
		//	private bool IsActive = false;
		//	protected string GatewayName = "";

		//***************************
		private static string mChronoIP = "69.20.58.35";
		private static string mChronoIP1 = "207.97.201.192";

		private static string mCallBackType = "P"; //POST , always use POST
		private static string mSiteRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot;
		private static string mCallBackUrl = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot + OrderCompletePage; // OrderComplete.aspx
		private static string mDeclineUrl = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // redirect user on unsucessfull transaction
		////string mProductID = ""; // vendor shop id
		////string mProductName = ""; // vendor shop name
		////string mLanguage = ""; // gateway language


		// separate dollars from cents and place dot between them
		// ChronoPay requires format: dollars.cents, some languages places "," between !!!!
		private string GetAmountToPay(decimal amount)
		{
			string strtotal = amount.ToString("n2");
			string dollars = strtotal.Substring(0, strtotal.Length - 3);
			string cents = strtotal.Substring(strtotal.Length - 2);
			dollars = dollars.Replace(",", ""); // remove , if any left
			dollars = dollars.Replace(".", ""); // remove . if any
			strtotal = dollars + "." + cents;
			return strtotal;
		}

		private string GetForm(Order order)
		{
			return (String.Format(@"<form method='post' action='{0}' >{1}</form>", mTransactionUrl, GetTransactionFormBody(order)));
		}

#if TRIAL
		private string GetTransactionFormBody(Order order)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}

		private PGStatus DecodeData(HttpContext context)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}
#else
		private string GetTransactionFormBody(Order order)
		{
			NameValuePairCollection nv = new NameValuePairCollection();

			nv.Add("product_id", base.PaymentType.MerchantId); // shop id
			nv.Add("product_name", base.PaymentType.MerchantKey); // shop name
			nv.Add("product_price", GetAmountToPay(order.RedundantTotalToPay));
			nv.Add("language", base.PaymentType.LanguageCode);
			nv.Add("cb_url", mCallBackUrl);
			nv.Add("cb_type", mCallBackType);
			nv.Add("decline_url", mDeclineUrl);
			nv.Add("cs1", order.OrderID + ""); // OrderID
			//nv.Add("cs2", this.ID + "");	// PaymentTypeID
			//nv.Add("cs3", "cs3value");

			// address
			Address billingAddress = new Address();
			if (billingAddress.LoadFromDB(order.BillingAddressID))
			{
				nv.Add("f_name", billingAddress.FirstName);
				nv.Add("s_name", billingAddress.LastName);
				nv.Add("street", billingAddress.Address1 + " " + billingAddress.Address2);
				nv.Add("city", billingAddress.City);
				nv.Add("zip", billingAddress.Zip);
				nv.Add("phone", billingAddress.PhoneNo);
				nv.Add("email", billingAddress.Email);
				nv.Add("country", billingAddress.GetCountry().Symbol);
				nv.Add("state", billingAddress.GetState().Symbol);


			}
			return nv.ToFormPOSTInputs();
		}

		#region Form data example

		/*
		 * RECEIVED DATA FROM PAYMENT GATEWAY:
 <form action="gateway/ChronoPayCallBack.aspx" method="post"> 
 <input type="hidden" name="transaction_type" value="onetime" />
 <input type="hidden" name="customer_id" value="003325-000000068" />
 <input type="hidden" name="site_id" value="003325-0020" />
 <input type="hidden" name="product_id" value="003325-0020-0001" />
 <input type="hidden" name="date" value="" />
 <input type="hidden" name="time" value="" />
 <input type="hidden" name="transaction_id" value="" />
 <input type="hidden" name="email" value="email@gmx.net" />
 <input type="hidden" name="country" value="US" />
 <input type="hidden" name="name" value="MARTIN LAWRENCE" />
 <input type="hidden" name="country" value="US" />
 <input type="hidden" name="name" value="MARTIN LAWRENCE" />
 <input type="hidden" name="city" value="Los" />
 <input type="hidden" name="street" value="St. Avenia 8" />
 <input type="hidden" name="phone" value="" />
 <input type="hidden" name="state" value="XX" />
 <input type="hidden" name="zip" value="10000" />
 <input type="hidden" name="language" value="EN" />
 <input type="hidden" name="cs1" value="2531" />
 <input type="hidden" name="cs2" value="" />
 <input type="hidden" name="cs3" value="" />
 <input type="hidden" name="username" value="" />
 <input type="hidden" name="password" value="" />
 <input type="hidden" name="total" value="25.32" />
 <input type="hidden" name="currency" value="USD" />
 <input type="hidden" name="f_name" value="MARTIN" />
 <input type="hidden" name="s_name" value="MARTIN" />
 <input type="submit" value="ChronoPay Click Here To Finalize Your Order" />
 </form>
*/
		/* CALLBACK DATA FROM CHRONO PAY
			transaction_type: 	 onetime
			customer_id: 	 003325-000000068
			site_id: 	003325-0020
			product_id: 	 003325-0020-0001
			date: 	 
			time: 	 
			transaction_id: 	 
			email: 	 email@gmx.net
			country: 	 US
			name: 	 MARTIN LAWRENCE
			city: 	 Los
			street: 	 St. Avenia 8
			phone: 	 
			state: 	 XX
			zip: 	 10000
			language: 	 EN
			cs1: 	 2531           // we pass in OrderID from our database
			cs2: 	 some value   // pass in PaymentTypeID
			cs3: 	 some val2
			username: 	 
			password: 	 
			total: 	 
			currency: 	 USD
			f_name: 	 MARTIN
			s_name: 	 MARTIN
		 */
		#endregion

		// REQUIRED KEYS IN POST FROM CHRONOPAY 
		private static string[] requiredKeys = { "customer_id", "site_id", "product_id", "transaction_id", "total", "f_name" };

		private PGStatus DecodeData(HttpContext context)
		{
			if (base.PaymentType.IsActive != true)
			{
				return null;
			}

			// test received parameters to be sure that web request came from ChronoPay
			foreach (string key in requiredKeys)
			{
				if (context.Request.Form[key] == null)
				{
					// request doesn't have all the parameters, request is not valid request
					return null;
				}
			}

			// request came from ChronoPay, read all parameters
			PGStatus pgstatus = new PGStatus(base.PaymentType);

			// the only validation is IP where the request came from (ChronoID)
			if ((context.Request.UserHostAddress == mChronoIP) || (context.Request.UserHostAddress == mChronoIP1))
			{
				int orderId = -1;
				int.TryParse(context.Request.Form["cs1"] + "", out orderId);

				decimal total = -1;
				decimal.TryParse(context.Request.Form["total"] + "", out total);

				if (orderId > 0 && total > 0)
				{
					// transaction is valid
					pgstatus.IsSignatureOK = true;
					pgstatus.TransactionId = context.Request.Form["customer_id"];
					if (base.PaymentType.IsDemo)
					{
						pgstatus.TransactionId = "DEMO_" + pgstatus.TransactionId;
					}
					pgstatus.OrderID = orderId;
					pgstatus.TotalPaid = total;
				}
			}
			return pgstatus;	
		}

#endif

	}
}
