﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using Ice.Net.Ecommerce.PaymentGateways.PG;
using Ice.Net.Ecommerce.Web;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal class PGPayPal : BasePG
	{
		public override bool AIMMethod
		{
			get { return false; }
		}

		public override PGNameEnum PGNameEnum
		{
			get { return PGNameEnum._PayPal; }
		}

		public override PGResult GetFormWithParameters(Order order)
		{
			return new PGResult(null, this.GetForm(order), null);
		}

		public override PGStatus GetReceivedStatus(HttpContext context)
		{
			return this.DecodeData(context);
		}
		public override PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order)
		{
			return null;
		}


		#region Control Panel HTML

		public override string GetControlPanelHtml()
		{
			return string.Format(@"
<!--PAYPAL CONTROL PANEL-->
<table cellpadding='1px' cellspacing='5px' >
<tr><td >Name</td><td><input type='text' name='Name' style='width:255px;'/></td></tr>
<tr><td >Active</td><td><input type='checkbox' name='IsActive' /></td></tr>
<tr><td >Demo</td><td><input type='checkbox' name='IsDemo' /></td></tr>
<tr><td >Diagnostic</td><td><input type='checkbox' name='IsDiagnostic' /></td></tr>
<tr><td >Seller Email</td><td><input name='MerchantId' type='text' style='width:256px;' /></td></tr>
<tr><td >Payment For</td><td><input name='CartTitle' type='text' style='width:256px;' /></td></tr>

<tr><td >Description<br/></td><td><textarea id='textareaPTDescription' name='Description' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>
<tr><td >Long Description<br/></td><td><textarea id='textareaPTLongDescription' name='LongDescription' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>

<tr><td colspan='2' style='text-align:center;height:80px;background-image:url({0}admin/pglogo/paypal.gif); background-repeat:no-repeat; background-position:center center'>&nbsp;</td></tr>
<tr><td colspan='2' style='text-align:center; height:20px'><a href='http://www.PayPal.com' target='_blank'><b> http://www.PayPal.com </b></a></td></tr>
<tr><td></td><td><div style='display:none'>
<!--quick help content-->
<div>
<b>PayPal-Supported Currencies and Currency ISO Codes (XXX)</b><br/>
AUD Australian Dollar <br/>
CAD Canadian Dollar<br/>
CHF Swiss Franc<br/>
CZK Czech Koruna<br/>
DKK Danish Krone<br/>
EUR Euro<br/>
GBP Pound Sterling<br/>
HKD Hong Kong Dollar<br/>
HUF Hungarian Forint<br/>
JPY Japanese Yen<br/>
NOK Norwegian Krone<br/>
NZD New Zealand Dollar<br/>
PLN Polish Zloty<br/>
SEK Swedish Krona<br/>
SGD Singapore Dollar<br/>
USD U.S. Dollar<br/>
Code Currency<br/>
AUD Australian Dollar<br/>
CAD Canadian Dollar<br/>
CHF Swiss Franc<br/>
CZK Czech Koruna<br/>
DKK Danish Krone<br/>
EUR Euro<br/>
GBP Pound Sterling<br/>
HKD Hong Kong Dollar<br/>
HUF Hungarian Forint<br/>
JPY Japanese Yen<br/>
NOK Norwegian Krone<br/>
NZD New Zealand Dollar<br/>
PLN Polish Zloty<br/>
SEK Swedish Krona<br/>
SGD Singapore Dollar<br/>
USD U.S. Dollar<br/>
</div>

</div><div align='right'><a href='#' onclick='QoDesk.PaymentTypeEditor.ShowQuickHelp(this);'><b>Quick Help</b></a></div>
</td></tr>
</table>

", mSiteRoot);
		}

		#endregion


		// USER DEPENDING PARAMTERS
		private static string mTransactionUrl = "https://www.paypal.com/cgi-bin/webscr";
		private static string mDemoTransactionUrl = "https://www.sandbox.paypal.com/cgi-bin/webscr"; // test account
		private static string mPayPalIpnIP = "66.135.197.164";

		private static string mSiteRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot;

		private string GetTransactionURL()
		{
			if (base.PaymentType.IsDemo)
			{
				return mDemoTransactionUrl;
			}
			else
			{
				return mTransactionUrl;
			}
		}

		// separate dollars from cents and place dot between them
		// PayPal requires format: dollars.cents, some languages places comma between !!!!
		private string GetAmountToPay(decimal amount)
		{
			string strtotal = amount.ToString("n2");
			string dollars = strtotal.Substring(0, strtotal.Length - 3);
			string cents = strtotal.Substring(strtotal.Length - 2);
			dollars = dollars.Replace(",", ""); // remove , if any left
			dollars = dollars.Replace(".", ""); // remove . if any
			strtotal = dollars + "." + cents;
			return strtotal;
		}

		private string GetForm(Order order)
		{
			return (String.Format(@"<form method='post' action='{0}'>{1}</form>", GetTransactionURL(), GetTransactionFormBody(order)));
		}

#if TRIAL
		private string GetTransactionFormBody(Order order)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}

		private PGStatus DecodeData(HttpContext context)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}
#else
		private string GetTransactionFormBody(Order order)
		{
			NameValuePairCollection nv = new NameValuePairCollection();

			nv.Add("business", base.PaymentType.MerchantId); // merchant paypal email
			nv.Add("cmd", "_xclick");
			nv.Add("amount", GetAmountToPay(order.RedundantTotalToPay));
			nv.Add("item_name", base.PaymentType.CartTitle); // Payment For: ... the name for complete shopping cart
			nv.Add("item_number", order.OrderID + ""); // OrderID
			//nv.Add("no_shipping", 1);
			nv.Add("currency_code", BusinessObjects.Common.VISTACARTHelper.AppDefaults.Currency.ISOCode); // currency code, USD, EUR...
			nv.Add("upload", "1"); // indicates the use of 3rd party shopping cart
			//nv.Add("on0", mCart.OrderID + "");
			//nv.Add("on1", mCart.OrderID + "");
			//nv.Add("os0", mCart.OrderID + "");
			//nv.Add("os1", mCart.OrderID + "");
			nv.Add("no_shipping", "0"); // don't ask for shipping address
			nv.Add("no_note", "0"); // don't ask customer to enter note

			nv.Add("notify_url", mSiteRoot + OrderCompletePage); // OrderComplete.aspx;// IPN callback, don't have to set it up in your account at all.
			nv.Add("shopping_url", mSiteRoot);// where to return the customer when he clicks 'continue shopping'
			nv.Add("cancel_return", mSiteRoot); // url where to return customer if payment is canceled
			nv.Add("return", mSiteRoot + OrderCompletePage); // OrderComplete.aspx // url where to return the customer after the payment is done
			nv.Add("rm", "POST"); // The customer's browser is redirected to the return URL by the POST method, and all transaction variables are also posted. 

			// address
			Address billingAddress = new Address();
			if (billingAddress.LoadFromDB(order.BillingAddressID))
			{
				nv.Add("first_name", billingAddress.FirstName);
				nv.Add("last_name", billingAddress.LastName);
				nv.Add("address1", billingAddress.Address1 + " " + billingAddress.Address2);
				nv.Add("city", billingAddress.City);
				nv.Add("zip", billingAddress.Zip);
				nv.Add("phone", billingAddress.PhoneNo);
				nv.Add("email", billingAddress.Email);
				nv.Add("country", billingAddress.GetCountry().SymbolShort); // paypal requires 2 letters country code
				nv.Add("state", billingAddress.GetState().Symbol);
			}
			return nv.ToFormPOSTInputs();
		}

		#region received parameters example

		/*
 * 
IPN on, PDT off
 THIS FORM SUBMITS WHEN THE CUSTOMER CLICKS 'RETURN TO MERCHANT WEBSITE':
<form method="post" id="merchantReturn" name="merchant_return" action="http://localhost:1776/default2.aspx">
<input type="hidden" id="" name="payment_date" value="09:19:25 May 12, 2007 PDT">
<input type="hidden" id="" name="txn_type" value="web_accept">
<input type="hidden" id="" name="last_name" value="Test">
<input type="hidden" id="" name="residence_country" value="HR">
<input type="hidden" id="" name="item_name" value="Ice.Net.Net Online Store">
<input type="hidden" id="" name="payment_gross" value="0.95">
<input type="hidden" id="" name="mc_currency" value="USD">
<input type="hidden" id="" name="business" value="imf2004@gmx.net">
<input type="hidden" id="" name="payment_type" value="instant">
<input type="hidden" id="" name="verify_sign" value="Az1-INaKF.SORI6ohm0Aq3960K17AkwOyGVHoEZF57FARB4Bp0gQ2K-w">
<input type="hidden" id="" name="payer_status" value="unverified">
<input type="hidden" id="" name="test_ipn" value="1">
<input type="hidden" id="" name="tax" value="0.00">
<input type="hidden" id="" name="payer_email" value="buyer2004@gmx.net">
<input type="hidden" id="" name="txn_id" value="37T62180EK802602B">
<input type="hidden" id="" name="quantity" value="1">
<input type="hidden" id="" name="receiver_email" value="seller2004@gmx.net">
<input type="hidden" id="" name="first_name" value="Personal">
<input type="hidden" id="" name="payer_id" value="WPWETWBUS4LT2">
<input type="hidden" id="" name="receiver_id" value="PHEMGHRY5U7FU">
<input type="hidden" id="" name="item_number" value="82">
<input type="hidden" id="" name="payment_status" value="Completed">
<input type="hidden" id="" name="payment_fee" value="0.34">
<input type="hidden" id="" name="mc_fee" value="0.34">
<input type="hidden" id="" name="shipping" value="0.00">
<input type="hidden" id="" name="mc_gross" value="0.95">
<input type="hidden" id="" name="custom" value="">
<input type="hidden" id="" name="charset" value="windows-1252">
<input type="hidden" id="" name="notify_version" value="2.1">
<input type="submit" id="merchantReturn" name="merchant_return_link" value="Return to MMIceTest.net">
</form>
 */
		/*
		 *PARAMETERS RECEIVED FROM IPN CALLBACK PARAMETERS:
		FROM KEYS
		payment_date: 	 10:38:27 May 12, 2007 PDT
		txn_type: 	 web_accept
		last_name: 	 Test
		residence_country: 	 HR
		item_name: 	 Ice.Net.Net Online Store
		payment_gross: 	 0.95
		mc_currency: 	 USD
		business: 	 seller2004@gmx.net
		payment_type: 	 instant
		verify_sign: 	 AnOlbatIj140iv-p9ouQ3IscYnmXAcmi.iD40AqH8TcUP8.GCDCF5aAk
		payer_status: 	 unverified
		test_ipn: 	 1
		tax: 	 0.00
		payer_email: 	 bulldog2004@gmx.net
		txn_id: 	 7ST11847JG521273L
		quantity: 	 1
		receiver_email: 	 seller2004@gmx.net
		first_name: 	 Personal
		payer_id: 	 WPWETWBUS4LT2
		receiver_id: 	 PHEMGHRY5U7FU
		item_number: 	 82
		payment_status: 	 Completed
		payment_fee: 	 0.34
		mc_fee: 	 0.34
		shipping: 	 0.00
		mc_gross: 	 0.95
		custom: 	 
		charset: 	 windows-1252
		notify_version: 	 2.1

		FROM IP:
		User host IP: 	 66.135.197.164 (PAY PALL IPN IP)
 
		*/

		#endregion

		// REQUIRED KEYS IN POST FROM PAYPAL 
		private static string[] requiredKeys = { "txn_type", "payment_gross", "business", "verify_sign", "txn_id" };


		private PGStatus DecodeData(HttpContext context)
		{
			if (base.PaymentType.IsActive != true)
			{
				return null;
			}

			// test received parameters to be sure that web request came from PayPal
			foreach (string key in requiredKeys)
			{
				if (context.Request.Form[key] == null)
				{
					// request doesn't have all the parameters, request is not valid request
					return null;
				}
			}

			// request came from PayPal, read all parameters
			PGStatus pgstatus = new PGStatus(base.PaymentType);

			// get data
			int.TryParse(context.Request.Form["item_number"] + "", out pgstatus.OrderID);

			pgstatus.TransactionId = context.Request.Form["txn_id"] + "";
			if (base.PaymentType.IsDemo)
			{
				pgstatus.TransactionId = "DEMO_" + pgstatus.TransactionId;
			}
			decimal.TryParse(context.Request.Form["payment_gross"] + "", out pgstatus.TotalPaid);

			//	if (context.Request.UserHostAddress == mPayPalIpnIP) // if request came from PayPal IP
			{
				// verify received data, if ok set SignitureValid
				GHttpResponseStatus response = GHttpRequest.MakePostRequest(GetTransactionURL(), "cmd=_notify-validate&" + context.Request.Form);

				if (response.StatusCode == System.Net.HttpStatusCode.OK)
				{
					if (response.ResponseText.Contains("VERIFIED"))
					{
						pgstatus.IsSignatureOK = true;
					}
					else
					{
						pgstatus.IsSignatureOK = false;
					}
				}
			}

			return pgstatus;

		}

#endif

	}
}











