﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text.RegularExpressions;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal class PGPayWayHR : BasePG
	{
		public override bool AIMMethod
		{
			get { return false; }
		}
		public override PGNameEnum PGNameEnum
		{
			get { return PGNameEnum._PayWayHR; }
		}

		public override PGResult GetFormWithParameters(Order order)
		{
			return new PGResult(null, this.GetForm(order), null);
		}

		public override PGStatus GetReceivedStatus(HttpContext context)
		{
			return this.DecodeData(context);
		}
		public override PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order)
		{
			return null;
		}

		#region Control Panel HTML

		public override string GetControlPanelHtml()
		{
			return String.Format(@"

<!-- PayWay CONTROL PANEL-->
<table cellpadding='0px' cellspacing='5px' >
<tr><td >Name</td><td><input type='text' name='Name' style='width:255px;'/></td></tr>
<tr><td >Active</td><td><input type='checkbox' name='IsActive' /></td></tr>
<tr><td >Demo</td><td><input type='checkbox' name='IsDemo' /></td></tr>
<tr><td >Diagnostic</td><td><input type='checkbox' name='IsDiagnostic' /></td></tr>
<tr><td >Store ID</td><td><input name='MerchantId' type='text' style='width:256px;' /></td></tr>
<tr><td >Key</td><td><input name='MerchantKey' type='text' style='width:255px;' /></td></tr>
<tr><td >Cart Title</td><td><input name='CartTitle' type='text' style='width:255px;' /></td></tr>
<tr><td >Description<br/></td><td><textarea id='textareaPTDescription'  name='Description' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>
<tr><td >Long Description<br/></td><td><textarea id='textareaPTLongDescription' name='LongDescription' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>

<tr><td colspan='2' style='text-align:center; height:20px'><a href='http://www.t-com.hr/poslovni/internet/etrgovina/pay_way.asp' target='_blank'><b> T-com PayWay </b></a></td></tr>
<tr><td></td><td><div style='display:none'>
<!--quick help content-->
PayWay settings<br/>
</div><div align='right'><a href='#' onclick='QoDesk.PaymentTypeEditor.ShowQuickHelp(this);'><b>Quick Help</b></a></div>
</td></tr>
</table>
"
 )	;

		}

		#endregion

		// WONDER PAY WAY
		/*
		 * lipe odvojiti ZAREZOM, tisuce tockom (mora tako radi izracuna hasha)
		 * slova u hashu moraju biti UperCase
		 * usera se nakon placanja posalje na ReturnURL s poslanim parametrom "oid" + parametri koje pay way servis doda
		 * http://localhost:1645/order_complete.aspx?pwoid=12&tid=42348&sig=9222099666142A11AAD97C63CBCE6F06&card=American%20Express
		 * return url: ... order_complete.aspx
		 *
		 * 		
		 <!-- T-COM PAY WAY PAYMENT GATEWAY SETTINGS FOR WONDER-->
		<add key="pwTransactUrl" value="https://pgw.t-com.hr/payment.aspx"/>
		<add key="pwShopID" value="...."/>
		<add key="pwSecretWord" value="..."/>
		<add key="pwReturnURL" value="http://www.wonder.hr/"/>
		<add key="pwCancelURL" value="http://www.wonder.hr/"/>
		*/


		//******************************************
		//  T-COM PAY WAY PAYMENT GATEWAY SETTINGS FOR WONDER
		private static string mTransactionUrl = "https://pgw.t-com.hr/payment.aspx";
		private static string mSiteRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // example: http://www.iceasp.net/
		private static string mReturnUrl = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot + OrderCompletePage; // OrderComplete.aspx
		private static string mCancelURL = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // redirect user on unsucessfull transaction
		// base.PaymentType.MerchantId // shop id
		// base.PaymentType.MerchantKey // key

		/// <summary>
		/// odvoji lipe od kuna ZAREZOM, a tisuce odvojiti tockom (mora tako radi izracuna MD5 hasha)
		/// </summary>
		/// <param name="amount"></param>
		/// <returns></returns>
		private string GetAmountToPay(decimal amount)
		{
			string strtot = amount.ToString("n2");
			strtot = strtot.Replace(".", "");
			strtot = strtot.Replace(",", "");
			string kune = strtot.Substring(0, strtot.Length - 2);
			string lipe = strtot.Substring(strtot.Length - 2);
			//odvoji tisuce tockom
			int index = kune.Length - 3;
			while (index > 0)
			{
				//stavi tocku na trenutnom indexu
				string first = kune.Substring(0, index);
				string last = kune.Substring(index);
				kune = first + "." + last;
				index = index - 3;
			}
			kune = kune + "," + lipe;
			return kune;
		}

		private string GetTransactionURL()
		{
			return mTransactionUrl;
		}

		private string GetForm(Order order)
		{
			return (String.Format("<form method=\"post\" action=\"{0}\">\r\n{1}</form>", GetTransactionURL(), GetTransactionFormBody(order)));
		}

#if TRIAL
		private string GetTransactionFormBody(Order order)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}

		private PGStatus DecodeData(HttpContext context)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}
#else

		private string GetTransactionFormBody(Order order)
		{
			NameValuePairCollection nv = new NameValuePairCollection();
			string totalToPayString = GetAmountToPay(order.RedundantTotalToPay);

			nv.Add("ShopID", base.PaymentType.MerchantId);
			nv.Add("ShoppingCartID", order.OrderID + "");
			nv.Add("TotalAmount", totalToPayString);
			nv.Add("ReturnURL", mReturnUrl + "?pwoid=" + order.OrderID); // moramo poslati order id, pgw ce samo dodati sig, tid i card paramtere
			nv.Add("CancelURL", mCancelURL);
			nv.Add("Lang", "HR");
			//nv.Add("Curr", "");

			// MD5 SIGNITURE
			nv.Add("Signature", this.GetMD5hash(
				base.PaymentType.MerchantId + 
				base.PaymentType.MerchantKey + 
				order.OrderID + 
				base.PaymentType.MerchantKey + 
				totalToPayString + 
				base.PaymentType.MerchantKey));

			// address
			Address billingAddress = new Address();
			if (billingAddress.LoadFromDB(order.BillingAddressID))
			{

				nv.Add("CustomerFirstname", (billingAddress.FirstName));
				nv.Add("CustomerSurname", (billingAddress.LastName));
				nv.Add("CustomerAddress", (billingAddress.Address1 + " " + billingAddress.Address2));
				nv.Add("CustomerCity", (billingAddress.City));
				nv.Add("CustomerZIP", (billingAddress.Zip));
				nv.Add("CustomerCountry", billingAddress.GetCountry().Symbol);
				nv.Add("CustomerPhone", (billingAddress.PhoneNo));
				nv.Add("CustomerEmail", (billingAddress.Email));
			}

			return nv.ToFormPOSTInputs();
		}

		public string GetMD5hash(string input)
		{
			return System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(input, "md5").ToUpper();
		}


		// ORDER COMPLETE
		private PGStatus DecodeData(HttpContext context)
		{
			if (base.PaymentType.IsActive != true)
			{
				return null;
			}

			// return url:  http://localhost:1645/order_complete.aspx?pwoid=12&tid=42348&sig=9222099666142A11AAD97C63CBCE6F06&card=American%20Express

			string httpMethod = context.Request.HttpMethod.ToUpper();

			if (httpMethod != "GET")
			{
				return null;
			}

			//*****************************************************************************
			// premalo je parametara u postu, ne mozemo biti sigurni da je zaista callback dosao od t-com-a
			// mozemo jos provjeriti IP s kojega je dosao callback
			//*****************************************************************************

			int orderNo = 0;

			if (int.TryParse(context.Request.QueryString["pwoid"], out orderNo) && orderNo > 0)
			{
				Order order = new Order();
				if (order.LoadFromDB(orderNo))
				{
					PGStatus pgstatus = new PGStatus(base.PaymentType);
					pgstatus.OrderID = orderNo;

					string transId = (context.Request.QueryString["tid"] + "");
					string sig = (context.Request.QueryString["sig"] + "").ToUpper();

					string calcsig = this.GetMD5hash(
						base.PaymentType.MerchantId +
						base.PaymentType.MerchantKey +
						orderNo +
						base.PaymentType.MerchantKey +
						GetAmountToPay(order.RedundantTotalToPay) +
						base.PaymentType.MerchantKey +
						transId +
						base.PaymentType.MerchantKey);

					if(calcsig == sig)
					{
						pgstatus.TransactionId = transId;
						pgstatus.IsSignatureOK = true;
					}

				}
			}

			// invalid data
			return null;

		}
		
#endif

	}
}
