﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text.RegularExpressions;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal class PGRaiffeisenHR : BasePG
	{
		public override bool AIMMethod
		{
			get { return false; }
		}
		public override PGNameEnum PGNameEnum
		{
			get { return PGNameEnum._RaiffeisenHR; }
		}

		public override PGResult GetFormWithParameters(Order order)
		{
			return new PGResult(null, this.GetForm(order), null);
		}

		public override PGStatus GetReceivedStatus(HttpContext context)
		{
			return this.DecodeData(context);
		}
		public override PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order)
		{
			return null;
		}

		#region Control Panel HTML

		public override string GetControlPanelHtml()
		{
			return String.Format(@"

<!--RBA CONTROL PANEL-->
<table cellpadding='0px' cellspacing='5px' >
<tr><td >Name</td><td><input type='text' name='Name' style='width:255px;'/></td></tr>
<tr><td >Active</td><td><input type='checkbox' name='IsActive' /></td></tr>
<tr><td >Demo</td><td><input type='checkbox' name='IsDemo' /></td></tr>
<tr><td >Diagnostic</td><td><input type='checkbox' name='IsDiagnostic' /></td></tr>
<tr><td >MerchantID</td><td><input name='MerchantId' type='text' style='width:256px;' /></td></tr>
<tr><td >TerminalID</td><td><input name='MerchantKey' type='text' style='width:255px;' /></td></tr>
<tr><td >Cart Title</td><td><input name='CartTitle' type='text' style='width:255px;' /></td></tr>

<tr><td>Currency</td><td>
<select style='width:100px' name='CurrencyISOCode'>
<option value='191'>HRK</option>
<option value='980'>UAH (test)</option>
</select>
</td></tr>

<tr><td >Language</td><td>
<select style='width:100px' name='LanguageCode'>
<option value='hr'>hr</option>
<option value='en'>en</option>
</select>
</td></tr>

<tr><td >Cert. Password</td><td><input name='Password' type='text' style='width:255px;' /></td></tr>


<tr><td >Description<br/></td><td><textarea id='textareaPTDescription'  name='Description' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>
<tr><td >Long Description<br/></td><td><textarea id='textareaPTLongDescription' name='LongDescription' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>

<tr><td colspan='2' style='text-align:center; height:20px'><a href='http://www.rba.hr' target='_blank'><b> www.rba.hr </b></a></td></tr>
<tr><td></td><td><div style='display:none'>
<!--quick help content-->
<b>Callback URL</b> {0}{1} <br /> 
<b>Return URL </b> {0}{1} <br /> 
<br/>
Certificates has to be placed into directory: App_Data/rba/
<br/>
and has to be named as follows:
<br/>
Merchant certificate, RSA 1024 bit (private key): App_Data/rba/<b>{1}</b>
<br/>
RBA certificate (public key): App_Data/rba/<b>{3}</b>
<br/>
<br/>
Cert. Password: password for {2} certificate file
<br/>
</div><div align='right'><a href='#' onclick='QoDesk.PaymentTypeEditor.ShowQuickHelp(this);'><b>Quick Help</b></a></div>
</td></tr>
</table>
",
	mSiteRoot,
	OrderCompletePage,
	mMerchantCert,
	mRbaCert
);

		}

		#endregion
		//base.PaymentType.MerchantId; // MerchantID
		//base.PaymentType.MerchantKey; // TerminalID
		//base.PaymentType.CartTitle; // PurchaseDesc
		//base.PaymentType.CurrencyISOCode; // 980=test, 191 = kune
		//base.PaymentType.LanguageCode; // hr, en
		//base.PaymentType.Password; // merchant's certificate password
		//base.PaymentType.CartDescription; // contains certificates in format: merchant=merchantCert.p12 & rba=rbaCert.crt
		
		/* REQUEST TO PAYMENT GATEWAY
		 * 
		<form action="https://secure.upc.ua/ecgtest/enter" method="post">
			<input name="Version" type="text" value="1" />
			<input name="MerchantID" type="text" value="1752084" />
			<input name="TerminalID" type="text" value="E7879884" />
			<input name="TotalAmount" type="text" value="1125" />
			<input name="Currency" type="text" value="980" />
			<input name="locale" type="text" value="en" />
			<input name="SD" type="text" value="" />
			<input name="OrderID" type="text" value="125" />
			<input name="PurchaseTime" type="text" value="070706113500" />
			<input name="PurchaseDesc" type="text" value="nekiopis" />
			<input name="Signature" type="text" value="fdasgas" />
			<input id="Submit1" type="submit" value="submit" />
		</form>
		*/

		// USER DEPENDING PARAMETERS
		private static string mDemoTransactionUrl = "https://secure.rba.hr/ecgtesthr/enter";
		private static string mTransactionUrl = "https://secure.rba.hr/rba/enter";

		private static string mAppPhysicalRoot = BusinessObjects.Common.ApplicationUtility.ApplicationPhysicalRoot;
		private static string mSiteRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // example: http://www.iceasp.net/
		private static string mCallBackUrl = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot + OrderCompletePage; // OrderComplete.aspx
		private static string mDeclineUrl = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // redirect user on unsucessfull transaction
	
		private static string mMerchantCert = "merchant.pfx";
		private static string mRbaCert = "rba.cer";

		//base.PaymentType.MerchantId; // MerchantID
		//base.PaymentType.MerchantKey; // TerminalID
		//base.PaymentType.CartTitle; // PurchaseDesc
		//base.PaymentType.CurrencyISOCode; // 980=test, 191=kune
		//base.PaymentType.LanguageCode; // hr, en
		//base.PaymentType.Password; // merchant's certificate password
		//base.PaymentType.CartDescription; // contains certificates in format: merchant=merchantCert.pfx & rba=rbaCert.cer
		
		// certificates has to be placed into App_Data\cert\   directory
		
		static string mSessionData = ""; // session data, leave empty


		/// <summary>
		/// RBA requires format in small units (lipe, centi)
		/// </summary>
		/// <param name="amount"></param>
		/// <returns></returns>
		private string GetAmountToPay(decimal amount)
		{
			string strtotal = amount.ToString("n2");
			strtotal = strtotal.Replace(",", ""); // remove , if any left
			strtotal = strtotal.Replace(".", ""); // remove . if any
			return strtotal;
		}

		/// <summary>
		/// date time yyMMddHHmmss
		/// </summary>
		/// <returns></returns>
		private string GetDateTimeFormated()
		{
			DateTime dt = DateTime.Now;
			string datetime = dt.Year.ToString().Substring(2) +
				dt.Month.ToString("00") +
				dt.Day.ToString("00") +
				dt.Hour.ToString("00") +
				dt.Minute.ToString("00") +
				dt.Second.ToString("00");
			return datetime;
		}

		private string GetTransactionURL()
		{
			if (base.PaymentType.IsDemo)
			{
				return mDemoTransactionUrl;
			}
			else
			{
				return mTransactionUrl;
			}
		}

		private string GetForm(Order order)
		{
			return (String.Format("<form method=\"post\" action=\"{0}\">\r\n{1}</form>", GetTransactionURL(), GetTransactionFormBody(order)));
		}

#if TRIAL
		private string GetTransactionFormBody(Order order)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}

		private PGStatus DecodeData(HttpContext context)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}
#else

		private string GetTransactionFormBody(Order order)
		{
			NameValuePairCollection nv = new NameValuePairCollection();

			string dateTime = GetDateTimeFormated();
			string totalToPay = GetAmountToPay(order.RedundantTotalToPay);

			nv.Add("Version", "1");
			nv.Add("MerchantID", base.PaymentType.MerchantId);
			nv.Add("TerminalID", base.PaymentType.MerchantKey);
			nv.Add("TotalAmount", totalToPay );
			nv.Add("Currency", base.PaymentType.CurrencyISOCode); // 980 = kune
			nv.Add("locale", base.PaymentType.LanguageCode); // hr, en
			nv.Add("SD", mSessionData); // session data
			nv.Add("OrderID", order.OrderID + ""); // OrderID
			nv.Add("PurchaseTime", dateTime );
			nv.Add("PurchaseDesc", base.PaymentType.CartTitle);
			nv.Add("Signature", CreateMerchantSignature(order, dateTime, totalToPay, mSessionData));

			return nv.ToFormPOSTInputs();
		}

		private PGRBA_CertHelper GetRBACertHelper()
		{
			string merchantCert = mAppPhysicalRoot + "App_Data\\rba\\" + mMerchantCert;
			string rbaCert = mAppPhysicalRoot + "App_Data\\rba\\" + mRbaCert;

			PGRBA_CertHelper certHelper = new PGRBA_CertHelper(rbaCert, merchantCert, base.PaymentType.Password);
			return certHelper;
		}

		private string CreateMerchantSignature(Order order, string dateTime, string totalToPay, string sessionData)
		{
			PGRBA_CertHelper certHelper = GetRBACertHelper();

			string dataStr = certHelper.BuildOurDataString(
				base.PaymentType.MerchantId,
				base.PaymentType.MerchantKey,
				dateTime,
				order.OrderID + "",
				base.PaymentType.CurrencyISOCode,
				totalToPay,
				sessionData);

			string signature = certHelper.CreateSignature(dataStr);
			return signature;
		}

		//*************************************************************************
		// ORDER COMPLETE
		//*************************************************************************

		/* RESPONSE FROM PG
 * 
	MerchantID	1752084
	TerminalID	E7879884
	TranCode	000
	Currency	980
	AltCurrency	
	ApprovalCode	075903
	OrderID	10
	Signature	VbpAuzm1ozIF1uoRI8UmXNDRZcD5Ti8L2Y3dq9UUH09dMjkpfmv+yQCKf+10uDMdA5aMSAs0R19TWPiIR7XaGlr7Z0RDbhAla4yHyfbAva85IXmFwy9GpCZPzT6Zp6iYPIczQpn3DLjYJp/EZ7S/g4EXXyFTsqEAZHk2EmK6RYc=
	PurchaseTime	070706154529
	TotalAmount	8012
	AltTotalAmount	
	ProxyPan	499999******0011
	SD	
	XID	07070616-012875
	Rrn	070616002068
	Delay	
	locale	en
	Email	alarm3@ipt.hr
*/
		// REQUIRED KEYS IN POST FROM RBA PG 
		private static string[] requiredKeys = { "MerchantID", "TerminalID", "TotalAmount", "PurchaseTime", "Signature" };

		private PGStatus DecodeData(HttpContext context)
		{
			if (base.PaymentType.IsActive != true)
			{
				return null;
			}

			// test received parameters to be sure that web request came from ChronoPay
			foreach (string key in requiredKeys)
			{
				if (context.Request.Form[key] == null)
				{
					// request doesn't have all the parameters, request is not valid request
					return null;
				}
			}

			// provjera potpisa
			string MerchantID = context.Request.Form["MerchantID"] + "";
			string TerminalID = context.Request.Form["TerminalID"] + "";
			string PurchaseTime = context.Request.Form["PurchaseTime"] + "";
			string OrderID = context.Request.Form["OrderID"] + "";
			string Currency = context.Request.Form["Currency"] + "";
			string TotalAmount = context.Request.Form["TotalAmount"] + "";
			string SD = context.Request.Form["SD"] + "";

			string XID = context.Request.Form["XID"] + "";
			string ApprovalCode = context.Request.Form["ApprovalCode"] + "";
			string Rrn = context.Request.Form["Rrn"] + "";
			string ProxyPan = context.Request.Form["ProxyPan"] + "";
			string TranCode = context.Request.Form["TranCode"] + "";
			string Signature = context.Request.Form["Signature"] + "";

			// check is signature valid
			PGRBA_CertHelper certHelper = GetRBACertHelper();
			string receivedDataString = certHelper.BuildReceivedDataString(MerchantID, TerminalID, PurchaseTime, OrderID, XID, Currency, TotalAmount, SD, TranCode, ApprovalCode);
			bool isSignatureValid = certHelper.IsSignatureValid(receivedDataString, Signature);

			if (isSignatureValid == true && TranCode == "000") // 000 == uspjesno autorizirano
			{
				// signature is valid, update order status to approved
				decimal totalPaid = 0;
				if (decimal.TryParse(TotalAmount, out totalPaid))
				{
					// amount is in small units (lipe, centi)
					totalPaid = totalPaid / 100;
				}

				int longOrderID = 0;
				if (int.TryParse(OrderID, out longOrderID))
				{
					if (longOrderID > 0)
					{
						PGStatus pgstatus = new PGStatus(base.PaymentType);
						// transaction is valid
						pgstatus.IsSignatureOK = true;
						pgstatus.TransactionId = "TranCode:" + TranCode + ", Rrn:" + Rrn + ", XID:" + XID;
						if (base.PaymentType.IsDemo)
						{
							pgstatus.TransactionId = "DEMO_" + pgstatus.TransactionId;
						}
						pgstatus.OrderID = longOrderID;
						pgstatus.TotalPaid = totalPaid;

						return pgstatus;
					}
				}
			}
				
			// signature is not valid
			return null;
		
		}

#endif
	}
}
