﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text.RegularExpressions;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal class PGWebtehHR : BasePG
	{
		public override bool AIMMethod
		{
			get { return false; }
		}
		public override PGNameEnum PGNameEnum
		{
			get { return PGNameEnum._WebtehHR; }
		}

		public override PGResult GetFormWithParameters(Order order)
		{
			return new PGResult(null, this.GetForm(order), null);
		}

		public override PGStatus GetReceivedStatus(HttpContext context)
		{
			return this.DecodeData(context);
		}
		public override PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order)
		{
			return null;
		}

		#region Control Panel HTML

		public override string GetControlPanelHtml()
		{
			return String.Format(@"

<!--WEBPAY CONTROL PANEL-->
<table cellpadding='0px' cellspacing='5px' >
<tr><td >Name</td><td><input type='text' name='Name' style='width:255px;'/></td></tr>
<tr><td >Active</td><td><input type='checkbox' name='IsActive' /></td></tr>
<tr><td >Demo</td><td><input type='checkbox' name='IsDemo' /></td></tr>
<tr><td >Diagnostic</td><td><input type='checkbox' name='IsDiagnostic' /></td></tr>
<tr><td >Store ID</td><td><input name='MerchantId' type='text' style='width:256px;' /></td></tr>
<tr><td >Key</td><td><input name='MerchantKey' type='text' style='width:255px;' /></td></tr>
<tr><td >Cart Title</td><td><input name='CartTitle' type='text' style='width:255px;' /></td></tr>

<tr><td >Language</td><td>
<select style='width:50px' name='LanguageCode'>
<option value='hr'>hr</option>
<option value='en'>en</option>
</select>
</td></tr>

<tr><td >Description<br/></td><td><textarea id='textareaPTDescription'  name='Description' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>
<tr><td >Long Description<br/></td><td><textarea id='textareaPTLongDescription' name='LongDescription' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>

<tr><td colspan='2' style='text-align:center;height:60px;background-image:url({0}admin/pglogo/webteh.png); background-repeat:no-repeat; background-position:center center'>&nbsp;</td></tr>
<tr><td colspan='2' style='text-align:center; height:20px'><a href='http://www.webteh.hr' target='_blank'><b> http://www.webteh.hr </b></a></td></tr>
<tr><td></td><td><div style='display:none'>
<!--quick help content-->
Log into your webteh.hr account and setup parameters:<br/> 
<b>postback url </b> {0}{1} <br /> 
<b>success url</b> {0}{1} <br /> 
<b>cancel url</b> {0} <br /> 
</div><div align='right'><a href='#' onclick='QoDesk.PaymentTypeEditor.ShowQuickHelp(this);'><b>Quick Help</b></a></div>
</td></tr>
</table>
",
	mSiteRoot,
	OrderCompletePage

 );

		}

		#endregion

		/*
		 * dokumentacija: http://www.webteh.hr/dokumentacija/webpay/webpay-form/webpay-form#section-9
		 */

		/* vazne napomene:
		 * stavi "method"="form":
		 * hash parametar koji se salje gatewayu racuna se kao SHA1(key + order_number + amount).ToLower(); // MUST BE LOWER CASE LETTERS!!!!
		 * gateway vrati 2 parametra hash i order_number na postback URL u form-i (callback, user ne vidi ovo, FORM - post metodom)
		 * postback url:
		 * 
		 * has parametar koji gateway vrati nema TotalToPay: SHA1(key + order_number); (lowercase)
		 * gateway osim hasha, vrati i order_number koji je bio poslan
		 * .../order_complete.aspx
		 * usera se preusmjerava sa web pay stranica na success url ili cancel url
		 * sucess url: ... order_complete.aspx
		 * povratak na sucess url:
		 * http://www.domena.hr/order_complete.aspx?language=hr&order_number=24
		 * cancel url:
		 * http://www.domena.hr
		 *
			na web pay serveru podesiti:
			postback url : www.domena.hr/order_complete.aspx
			success url:	www.domena.hr/order_complete.aspx -> poslati na ?chekcout=4&oid=...
			cancel url: www.domena.hr
		-->
		 */
		/*
		 * callback:
			Podaci koje servis šalje korisničkoj aplikaciji nakon autorizacije
			Ako je u postavkama prodajnog mjesta uključite opciju postback i upišete postback_url vrijednost, servis će nakon uspješne autorizacije programski poslati HTTP GET zahtjev na taj URL sa sljedećim varijablama:

			order_number
			SHA1(key+order_number)
			Primjer takvog upita je npr. 

			http://www.domena.hr/update_order?order_number=12345&hash=c9a53c3525e557dac9a53c3525e557da

		 */
		/*
			 Povratak kupca na stranu korisničke aplikacije nakon autorizacijeNakon uspješne autorizacije kupac se pritiskom na gumb "Natrag" preusmjerava na adresu success url  koja je određen u postavkama prodajnog mjesta. Na taj URL se kupca preusmjerava (HTTP redirect) sa sljedećim GET parametrima:

			language
			order_number
			Primjer adrese na koju se kupac preusmjerava može biti npr. 

			http://www.domena.hr/success_order?language=en&order_number=12345.
			Na ovaj način kupca možete vratiti na dinamički generiranu stranicu koja npr. sadrži rječi zahvale i informacije o ostvarenoj narudžbi.

			NAPOMENA: Ako se kod zahtjeva za autorizaciju koristi parametar rewrite_ur=true URL izgleda http://www.domena.hr/success_order/language/en/order_number/12345.
		*/


		//WEB PAY PAYMENT GATEWAY SETTING
		private static string mTransactionUrl = "https://secure.webteh.hr/";
		private static string mSiteRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // example: http://www.iceasp.net/
		private static string mReturnUrl = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot + OrderCompletePage; // OrderComplete.aspx
		private static string mCallbackUrl = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot + OrderCompletePage; // OrderComplete.aspx
		private static string mCancelURL = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // redirect user on unsucessfull transaction

		// base.PaymentType.CartTitle
		// base.PaymentType.MerchantId
		// base.PaymentType.MerchantKey
		//base.PaymentType.LanguageCode

		/// <summary>
		/// decimalna mjesta odvojiti TOCKOM, ne zarezom, tako trazi web pay
		/// tisuce se ne odvajaju (ni tockom ni zarezom)
		/// </summary>
		/// <param name="amount"></param>
		/// <returns></returns>
		private string GetAmountToPay(decimal amount)
		{
			string strtotal = amount.ToString("n2");
			string kune = strtotal.Substring(0, strtotal.Length - 3);
			string lipe = strtotal.Substring(strtotal.Length - 2);
			kune = kune.Replace(",", ""); // remove , if any left
			kune = kune.Replace(".", ""); // remove . if any
			strtotal = kune + "." + lipe;
			return strtotal;
		}

		private string GetTransactionURL()
		{
			return mTransactionUrl;
		}

		private string GetForm(Order order)
		{
			return (String.Format("<form method=\"post\" action=\"{0}\">\r\n{1}</form>", GetTransactionURL(), GetTransactionFormBody(order)));
		}

#if TRIAL
		private string GetTransactionFormBody(Order order)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}

		private PGStatus DecodeData(HttpContext context)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}
#else
		private string GetTransactionFormBody(Order order)
		{
			NameValuePairCollection nv = new NameValuePairCollection();
		
			// nuzne varijable
			nv.Add("mode", "form"); // mod rada servisa
			nv.Add("store_id", base.PaymentType.MerchantId); // id prodajnog mjesta
			nv.Add("order_number", order.OrderID +""); // max 30 chars
			nv.Add("language", base.PaymentType.LanguageCode); // jezik webteh sucelja, opcije: hr, en
			nv.Add("currency", BusinessObjects.Common.VISTACARTHelper.AppDefaults.Currency.ISOCode); // opcije: AUD, CAD, CZK, DKK, HUF, JPY, NOK, SKK, SEK, CHF, GBP, USD, EUR, PLN, HRK
			nv.Add("amount", GetAmountToPay(order.RedundantTotalToPay)); // npr: 134.65
			nv.Add("cart", base.PaymentType.CartTitle); // opis narudžbe, max 255 chars
			nv.Add("hash", this.GetSHA1hash(base.PaymentType.MerchantKey + order.OrderID + GetAmountToPay(order.RedundantTotalToPay))); // <<<< SHA1 SIGNITURE
			//string aaa = this.GetSHA1(mSecretWord + mCart.OrderID + GetTotalToPayString()); // <<<< SHA1 SIGNITU

			// opcionalne varijable
			nv.Add("require_complete", "true"); // true, false. da li se narudžba predautorizira ili ne; zaobilazi postavku prodajnog mjesta
			nv.Add("rewrite_url", "false"); // default: true. određuje format URL postavki 
			// nv.Add("number_of_installments", "01"); // broj rata
			// nv.Add("payment_start_at", "01"); // broj mjeseci nakon kojeg se naplaćuje prva rata (samo za amex)

			// address
			Address billingAddress = new Address();
			if (billingAddress.LoadFromDB(order.BillingAddressID))
			{
				nv.Add("cardholder_name", (billingAddress.FirstName)); // 20 chars
				nv.Add("cardholder_surname", (billingAddress.LastName)); // 20 chars
				nv.Add("cardholder_address", (billingAddress.Address1 + " " + billingAddress.Address2)); // 40 chars
				nv.Add("cardholder_city", (billingAddress.City)); // 20 chars
				nv.Add("cardholder_zip_code", (billingAddress.Zip));	// 9 chars
				nv.Add("cardholder_country", billingAddress.GetCountry().Symbol); // 30 chars
				nv.Add("cardholder_phone", (billingAddress.PhoneNo)); // 30 chars
				nv.Add("cardholder_email", (billingAddress.Email)); // 40 chars
			}

			return nv.ToFormPOSTInputs();
		}

		public string GetSHA1hash(string input)
		{
			return System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(input, "sha1").ToLower();
		}

		// ORDER COMPLETE
		private PGStatus DecodeData(HttpContext context)
		{
			if (base.PaymentType.IsActive != true)
			{
				return null;
			}

			// background callback: http://www.domena.hr/update_order?order_number=12345&hash=c9a53c3525e557dac9a53c3525e557da
			// return user from pgw after payment done: http://www.domena.hr/success_order?language=en&order_number=12345

			string httpMethod = context.Request.HttpMethod.ToUpper();

			if (httpMethod != "GET")
			{
				return null;
			}

			//*****************************************************************************
			// premalo je parametara u postu, ne mozemo biti sigurni da je zaista callback dosao od webteh-a
			// mozemo jos provjeriti IP s kojega je dosao callback
			//*****************************************************************************

			int orderNo = 0;

			if (int.TryParse(context.Request.QueryString["order_number"], out orderNo) && orderNo > 0)
			{
				PGStatus pgstatus = new PGStatus(base.PaymentType);
				pgstatus.OrderID = orderNo;
				
				if (context.Request.QueryString["language"] != null)
				{
					// it is user redirect from pgw
					pgstatus.IsInfoOnly = true;
					return pgstatus;
				}
				else if (context.Request.QueryString["hash"] != null)
				{
					// it is background callback from pgw
					string hash = (context.Request.QueryString["hash"] + "").ToLower();
					string calcsign = this.GetSHA1hash(base.PaymentType.MerchantKey + orderNo);
					if (hash != calcsign)
					{
						// invalid data
						return null;
					}

					// everything is ok
					// final object
					pgstatus.TransactionId = orderNo + "";
					pgstatus.IsSignatureOK = true;

					return pgstatus;

				}
			}

			// invalid order_number or doesn't exist
			return null;
		}

#endif
	}
}
