﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
//using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text;
using System.Collections.Specialized;
using System.Collections.Generic;

namespace Ice.Net.Ecommerce.Web.Modules.Common
{
	public class SitemapHelper
	{
		string mHtml = "";

		public static string GetSitemapHtml()
		{
			SitemapHelper smh = new SitemapHelper();
			return smh.mHtml;
		}

		private SitemapHelper()
		{
			SitemapItem smitem = GetSitemap();

			System.IO.StringWriter sw = new System.IO.StringWriter();
			HtmlTextWriter wr = new HtmlTextWriter(sw);
			smitem.RenderControl(wr);
			wr.Flush();
			sw.Flush();
			mHtml = sw.GetStringBuilder().ToString();
		}

		class SitemapItem : System.Web.UI.WebControls.Panel
		{
			public SitemapItem(Category category, SitemapItem parent, int level)
			{
				this.CssClass = "SitemapItem";
				if (parent == null)
				{
					this.CssClass += " Sitemap";
				}
				List<Category> childrenCategories = category.GetChildrenCategoryCollection(true, false);
	
				this.Controls.Add(new LiteralControl(GetLink(category, level, childrenCategories.Count > 0)));
				foreach (Category ccat in childrenCategories)
				{
					if (ccat.IsActive && ccat.IsPublished && ccat.IsInMap)
					{
						this.Controls.Add(new SitemapItem(ccat, this, level + 1));
					}
				}
			}

			private string GetLink(Category cat, int level, bool hasChildren)
			{
				string children = hasChildren ? " HasChildren" : "";
				FrontParameters fp = new FrontParameters();
				fp.CategoryID = cat.CategoryID;
				if (VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.IsNameInURL.GetValueOrDefault())
				{
					fp.LinkName = cat.Name;
				}
				else
				{
					fp.LinkName = "";
				}
				string link = String.Format("<div class=\"L{2}{3}\"><a href=\"{0}\">{1}</a></div>", fp.RelativeLink, cat.Name, level, children);
				return link;
			}
		}

		private SitemapItem GetSitemap()
		{
			// get all categories from root category and below
			int rootCategoryID = VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.RootCategoryID.GetValueOrDefault();
			SitemapItem mapRoot = null;
			Category rootCategory = new Category();
			rootCategory.LoadFromDB(rootCategoryID);
			
			// load children
			mapRoot = new SitemapItem(rootCategory, null, 0);

			return mapRoot;
		}
	}
}