﻿using System;
using System.Collections.Generic;
using System.Text;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;

namespace Ice.Net.Ecommerce.Web.Modules.HtmlElements
{
	public class AttributesSelectorsBuilder
	{
		public static string GetProductAttributesSelectors(Product product)
		{
			string attributesSelects = "";
			List<AttributeGroup> attributes = product.GetAttributeGroupCollection();
			foreach (AttributeGroup attGroup in attributes)
			{
				attributesSelects += GetAttributesSelect(attGroup);
			}
			return "<div id='prodAttributes'>" + attributesSelects + "</div>";
		}

		public static string GetAttributesSelect(AttributeGroup attGroup)
		{
			string attHtml = "";
			string[] attributeValues = attGroup.ValuesArray;
			if (attributeValues == null)
			{
				return attHtml;
			}
			if (attributeValues.Length > 0)
			{
				attHtml = @"
<select name='" + attGroup.Name + "' style='margin:2px'>";
				attHtml += @"
<option value=''>" + attGroup.Name + " ?</option>";

				foreach (String attValue in attributeValues)
				{
					attHtml += @"
<option value='" + attValue + "'>" + attValue + "</option>";
				}
				attHtml += @"
</select>
";
			}
			return attHtml;
		}

	}
}