﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Collections.Generic;

namespace Ice.Net.Ecommerce.Web.WebService
{
	#region .NET - JSON objects

	public class GUserResult
	{
		public bool Success = false;
		public bool Warning = false;
		public string Message = "";

		public GUserResult()
		{
		}
		public GUserResult(bool success, string message)
		{
			this.Success = success;
			this.Message = message;
		}

		public GUserResult(bool success, string message, bool warning)
		{
			this.Success = success;
			this.Message = message;
			this.Warning = warning;
		}
	}

	public class CartData
	{
		public int Count = 0;
		public string Subtotal = "";

		public CartData()
		{ }
		public CartData(int count, string subtotal)
		{
			this.Count = count;
			this.Subtotal = subtotal;
		}
	}

	public class CheckoutAddresses
	{
		public string Form = "";
		public Address Billing = new Address();
		public Address Shipping = new Address();

		public CheckoutAddresses()
		{ }

		public CheckoutAddresses(Order order)
		{
			Billing.LoadFromDB(order.BillingAddressID);
			Shipping.LoadFromDB(order.ShippingAddressID);
		}
	}

	public class UserAccountData
	{
		public String Form = "";
		public User User = null;
		public Address Address = null;
	}

	public class EmailObject
	{
		public String Name = "";
		public String Email = "";
		public String Subject = "";
		public String Message = "";
	}

	#endregion

}
