﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text;

namespace Ice.Net.Ecommerce.Web.Modules
{
	public partial class Checkout_1_2 : System.Web.UI.UserControl
	{
		protected string mCreditCardHtml = "";
		protected string mUrl = "";

		protected string mPaymentTypeID = "";
		protected string mWhatIsThis = "";
		protected string mPayNowText = "";
		protected string mProcessingMsg = "";

		protected string mCartContent = "";
		protected string mPGLongDescription = "";

		protected string mBillingAddress = "";
		protected string mShippingAddress = "";


		protected void Page_Load(object sender, EventArgs e)
		{
			ForceRender();
		}

		private void ForceRender()
		{
			/////////////////////////////////////////////////////////////////
			// SSL IS REQUIRED IF USING API PAYMENT METHOD
			/////////////////////////////////////////////////////////////////

			mUrl = SSLModeUtility.GetRedirectUrlIfRequired();
			if (mUrl != null)
			{
				plcContent.Visible = false;
				plcSSLRedirect.Visible = true;
				return; // stop processing the code
			}

			ShoppingCart cart = VISTACARTHelper.CurrentUser.ShoppingCart;
			if (cart.Order.RedundantTotalProductsCount == 0 || cart.Order.OrderStatus != Order.OrderStatusEnum.ShoppingCart)
			{
				plcSSLRedirect.Visible = true;
				// redirect to homepage
				mUrl = "./";
				return;
			}

			mPaymentTypeID = cart.Order.PaymentTypeID + "";
			mPayNowText = Message.GetContent(Message.NameEnum.PayNow) + "!";
			mProcessingMsg = Message.GetContent(Message.NameEnum.Processing) + "...";
			mWhatIsThis = Message.GetContent(Message.NameEnum.WhatIsThis);

			PaymentType pt = new PaymentType();
			if (pt.LoadFromDB(cart.Order.PaymentTypeID))
			{
				mCartContent = HtmlElements.ShoppingCartHtmlBuilder.GetHtml(cart.Order, false);
				mPGLongDescription = pt.LongDescription;

				mBillingAddress = GetAddress(cart.Order.BillingAddressID);
				mShippingAddress = GetAddress(cart.Order.ShippingAddressID);

			}
	
		}

		private string GetAddress(int? addressID)
		{
			return Ice.Net.Ecommerce.OrderContentForEmail.AddressBuilder.GetHtml(addressID);
		}


	}
}