﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text;

namespace Ice.Net.Ecommerce.Web.Modules
{
	public partial class Checkout_1_3 : System.Web.UI.UserControl
	{
		protected string mUrl = "";
		protected string mCartContent = "";
		protected string mBillingAddress = "";
		protected string mShippingAddress = "";
		protected string mForward = Message.GetContent(Message.NameEnum.Forward);
		protected string mBack = Message.GetContent(Message.NameEnum.Back);

		protected void Page_Load(object sender, EventArgs e)
		{
			ForceRender();
		}

		private void ForceRender()
		{
			plcContent.Visible = false;
			FrontParameters fp = new FrontParameters(System.Web.HttpContext.Current.Request);

			if (fp.OrderID > 0)
			{
				Order order = new Order();
				
				if (order.LoadFromDB(fp.OrderID) && order.OrderStatus == Order.OrderStatusEnum.Ordered)
				{
					if ((VISTACARTHelper.CurrentUser.UserTicket.IsAuthenticated && VISTACARTHelper.CurrentUser.UserTicket.UserID == order.UserID))
					{
						// valid
						mCartContent = HtmlElements.ShoppingCartHtmlBuilder.GetHtml(order, false);

						mBillingAddress = GetAddress(order.BillingAddressID);
						mShippingAddress = GetAddress(order.ShippingAddressID);

						plcContent.Visible = true;

					}
					else
					{
						// order doesn't belong to current user
					}

				}
			}



		}

		private string GetAddress(int? addressID)
		{
			return Ice.Net.Ecommerce.OrderContentForEmail.AddressBuilder.GetHtml(addressID);
		}
	}
}