﻿/// <reference path="/Scripts/IceFormSerialization.js" />
/// <reference path="/Scripts/IceLoadingMask.js" />

if(!Ice.GCart) {Ice.GCart = {};}

//////////////////////////////////////////////////////////
// masterSite.Master

Ice.Extend(Ice.GCart, {
	Base : (function(){
		var base = document.getElementsByTagName("base")[0];
		return (base ? base.href : "");
	})(),
	
	SetUserLanguage: function(sender)
	{
		setTimeout(function SetLanguageWorker(){
			Ice.GCart.ShowLoadingMask(true);
			var lang = Ice.FormSerialization.SerializeHtmlControls(sender.parentNode);
			GUserService.SetUserLanguage(lang.LanguageID, function(success){
				if(success)
				{
					window.location = window.location;
				}
				else
				{
					Ice.GCart.ShowLoadingMask(false);
				}
			});
		}, 10);
	},
	
	SetUserCurrency: function(sender)
	{
		setTimeout(function(){
			Ice.GCart.ShowLoadingMask(true);
			var curr = Ice.FormSerialization.SerializeHtmlControls(sender.parentNode);
			GUserService.SetUserCurrency(curr.CurrencyID, function(success){
				if(success)
				{
					window.location = window.location;
				}
				else
				{
					Ice.GCart.ShowLoadingMask(false);
				}
			});
		}, 10);
	},
	
	SetOnlineDemoSkin : function(sender)
	{
		setTimeout(function(){
			Ice.GCart.ShowLoadingMask(true);
			var skin = Ice.FormSerialization.SerializeHtmlControls(sender.parentNode);
			GUserService.SetOnlineDemoSkin(skin.SkinDirectory, function(success){
				if(success)
				{
					window.location = window.location;
				}
				else
				{
					Ice.GCart.ShowLoadingMask(false);
				}
			});
		}, 10);
	},
	
	UserNewsletterSignIn: function ()
	{
		Ice.GCart.ShowLoadingMask(true);
		var email = document.getElementById("inpNewsletterEmail").value;
		GUserService.UserNewsletterSignIn(email, function(gUsersResult){
			Ice.GCart.ShowLoadingMask(false);
			alert(gUsersResult.Message);
		});
	},

	UserLogin : function ()
	{
		Ice.GCart.ShowLoadingMask(true);
		var username = document.getElementById("inpUsername").value;
		var password = document.getElementById("inpPassword").value; 
		GUserService.UserLogin(username, password, function(gResult){
				if(gResult.Success)
				{
					window.location = window.location;
				}
				else
				{
					Ice.GCart.ShowLoadingMask(false);
					alert(gResult.Message);
				}
			});
	},

	UserLogout: function ()
	{
		Ice.GCart.ShowLoadingMask(true);
		GUserService.UserLogout(function(success){
			window.location = window.location;
			});
	},

	ShowPasswordRecovery: function ()
	{
		document.getElementById("divPassRecovery").style.display = "";
	},

	UserSendPassword: function (reload)
	{
		Ice.GCart.ShowLoadingMask(true);
		var email = document.getElementById("intEmailPassRecovery").value;
		GUserService.UserSendPassword(email, function(gUsersResult){
			Ice.GCart.ShowLoadingMask(false);
			alert(gUsersResult.Message);
			if(gUsersResult.Success)
			{
				if(reload)
				{
					window.location = window.location;
				}
				else
				{
					document.getElementById("divPassRecovery").style.display = "none";
				}
			}	
		});
	},

	UpdateQuickCartData: function (gCartData)
	{
		var divCount = document.getElementById("tdCartCount");
		var divSubtotal = document.getElementById("tdCartTotalToPay");
		divCount.innerHTML = "";
		divCount.innerHTML = gCartData.Count;
		divSubtotal.innerHTML = "";
		divSubtotal.innerHTML = gCartData.Subtotal;
	},
	
	ShowCVVExplanation: function()
	{
		var win = window.open('','cvvexplain','width=500,height=400, resizable=yes, status=yes, scrollbars=yes');
	
		GUserService.GetCVVExplanation(function(gResult){
			if(win)
			{
				win.document.open();
				win.document.write("<html><body style='margin:0px; padding:10px; font: 8pt verdana;'>" + gResult.Message + "</body></html>");
				win.document.close();
				win.focus();
			}
		});
	},
	
	ContactUsSendEmail: function(sender)
	{
		Ice.GCart.ShowLoadingMask(true);	
		sender.disabled = true;
		var emailObj = Ice.FormSerialization.SerializeHtmlControls("tableContactUs", "requiredField");
		if(emailObj == null)
		{
			alert("All fields are required!");
			sender.disabled = false;
			Ice.GCart.ShowLoadingMask(false);	
		}
		else
		{
			GUserService.ContactUsSendEmail(emailObj, function(gResult){
				if(gResult.Success)
				{
					emailObj.Message = "";
					emailObj.Subject = "";
					Ice.FormSerialization.PopulateHtmlControls("tableContactUs", emailObj);
				}
				alert(gResult.Message);
				sender.disabled = false;
				Ice.GCart.ShowLoadingMask(false);	
							
			});
		}
	},
	
	TestEnter : function(e, method)
	{
		if(e.keyCode == 13)
		{
			method();
		}
	},

	SearchClicked : function()
	{
		var inp = document.getElementById("inpSearchBox");
		if(inp.value.length > 0)
		{
			window.location = "./q1-g.aspx?q=" + inp.value;
		}
	}

	
});

//////////////////////////////////////////////////////////
// orders.aspx

Ice.Extend(Ice.GCart, {
	GetOrderDetail : function(orderID)
	{
		Ice.GCart.ShowLoadingMask(true);
		GUserService.GetOrderDetailHtml(orderID, function(html){
			var div = document.getElementById("divOrderDetails");
			if(div != null)
			{
				div.innerHTML = "";
				div.innerHTML = html;
				Ice.GCart.CartImagesLoader();
				window.scroll(0,0);
				Ice.GCart.ShowLoadingMask(false);
			}
		});
	}	
});

//////////////////////////////////////////////////////////
// detail.aspx

Ice.Extend(Ice.GCart, {
	AddProductToCart : function (productID)
	{
		function ProductAdded(gCartData)
		{
			window.location = Ice.GCart.Base + "?p=showcart";
		}

		// get product attributes
		var divAttributes = document.getElementById("prodAttributes");
		if(divAttributes != null)
		{
			var attributesObj = Ice.FormSerialization.SerializeHtmlControls("prodAttributes");
			var attributes = Ice.GCart.AttributesToString(attributesObj);
			if(attributes == null)
			{
				return;
			}
			else
			{
				Ice.GCart.ShowLoadingMask(true);
				GUserService.AddProductToCart(productID, 1, attributes, ProductAdded );
			}
		}
		else
		{
			Ice.GCart.ShowLoadingMask(true);
			GUserService.AddProductToCart(productID, 1, "", ProductAdded );
		}
	},

	AttributesToString: function (attributesObj)
	{
		var count = 0;
		var att = "";
		for(var prop in attributesObj)
		{
			if(attributesObj[prop].length > 0 == false)
			{
				alert(Ice.GCart.SystemMsg.SelectAttributes);
				return null;
			}
			if(count ++ > 0 && att.length > 0)
			{
				att += ", ";
			}
			att += prop + ":" + attributesObj[prop];
			//att += attributesObj[prop];
		}
		return att;
	}
});

//////////////////////////////////////////////////////////
// customer.aspx

Ice.Extend(Ice.GCart, {
	UpdateUserData : function (location)
	{
		var address = Ice.FormSerialization.SerializeHtmlControls("divAddressData", "requiredField");
		var user = Ice.FormSerialization.SerializeHtmlControls("divUserData", "requiredField");
		if(address == null || user == null)
		{
			alert(Ice.GCart.SystemMsg.MissingRequiredFields);
		}
		else
		{
			GUserService.UserAccountCreateOrUpdate(user, address, true, function(gResult){
				alert(gResult.Message);
				if(gResult.Success)
				{
					if(location != null)
					{
						window.location = location;
					}
					else
					{
						window.location = window.location;
					}
				}
				else
				{
					Ice.GCart.ShowLoadingMask(false);
				}
			});
		}
	},

	RegistrationGoBack : function ()
	{
		window.history.back();
	},

	RegistrationGoForward: function ()
	{
		UpdateData();
	}
});

//////////////////////////////////////////////////////////
// cart.aspx

Ice.Extend(Ice.GCart, {
	
	CopyBillingAddress: function()
	{
		var billing = Ice.FormSerialization.SerializeHtmlControls("divBillingAddress");
		billing = Ice.Clone(billing);
		delete(billing.AddressID);
		Ice.FormSerialization.PopulateHtmlControls("divShippingAddress", billing);
	},

	RemoveFromCart: function(detailIndex)
	{
		Ice.GCart.ShowLoadingMask(true);
		GUserService.RemoveFromCart(detailIndex, function(){window.location = window.location;});
	},
	
	UpdateCartItemQuantity: function ()
	{
		var updateArr = [];
		var detailIndex = 0;	
		var inputs = document.getElementsByTagName("input");
		for(var n = 0; n < inputs.length; n++)
		{
			var inp = inputs[n];
			if(inp.className.indexOf("inpQuantity") >= 0)
			{
				// valid input field
				if(inp.OldQuantity != null && inp.OldQuantity != inp.value)
				{
					// value changed, update database
					var qnt = parseInt(inp.value);
					if(qnt >= -10000)
					{
						updateArr.push({index:detailIndex, quantity: qnt});
					}
				}
				
				detailIndex ++;
			}
		}
		
		function QuantityUpdater()
		{
			var detail = updateArr.pop();
			if(detail != null)
			{
				GUserService.SetCartItemQuantity(detail.index, detail.quantity, QuantityUpdater);
			}
			else
			{
				//reload cart data
				window.location = window.location; // removes loading mask
			}
		}
		Ice.GCart.ShowLoadingMask(true);		
		QuantityUpdater();
	},
	
	QuantityChanged : function (sender)
	{
		if(sender.OldQuantity == null)
		{
			sender.OldQuantity = sender.value;
		}
	},
	
	UpdateShippingType: function(sender, reload)
	{
		setTimeout(function(){
			Ice.GCart.ShowLoadingMask(true);		
			var nvobj = Ice.FormSerialization.SerializeHtmlControls(sender.parentNode);
			GUserService.SetShippingType(nvobj.ShippingTypeID, function(){
				// reload page
				window.location = window.location;
			});
		}, 10);
	},
	
	UpdatePaymentType: function(sender, reload)
	{		
		setTimeout(function(){
			Ice.GCart.ShowLoadingMask(true);
			var nvobj = Ice.FormSerialization.SerializeHtmlControls(sender.parentNode);
			GUserService.SetPaymentType(nvobj.PaymentTypeID, function(){
				// reload page
				window.location = window.location;
			});
		}, 10);
	},
	
	DoCheckout: function(sender)
	{
		Ice.GCart.ShowLoadingMask(true);
		// test if payment type and shipping type are selected
		GUserService.IsCheckoutPossible(function(gResult){
			if(gResult.Success)
			{
				if(gResult.Warning)
				{
					if(confirm(gResult.Message))
					{
						window.location = Ice.GCart.Base + "?p=checkoutaddress";
					}
					else
					{
						Ice.GCart.ShowLoadingMask(false);
						return false;
					}
				}
				else
				{
					window.location = Ice.GCart.Base + "?p=checkoutaddress";
				}
			}
			else if(gResult.Warning)
			{
				alert(gResult.Message);
				window.location = Ice.GCart.Base + "?p=myaccount";
			}
			else
			{
				alert(gResult.Message);				
				Ice.GCart.ShowLoadingMask(false);	
				return false;			
			}
		});
	},
	
	GetCartData: function(){
		var cartCount = document.getElementById("cartCount");
		var cartSubtotal = document.getElementById("cartSubtotal");
		if(cartCount != null || cartSubtotal != null)
		{
			GUserService.GetCartData(function(cartData){
				if(cartCount != null)
				{
					cartCount.innerHTML = cartData.Count;
				}
				if(cartSubtotal != null)
				{
					cartSubtotal.innerHTML = cartData.Subtotal;
				}
			});
		}
	}
	
	
});

//////////////////////////////////////////////////////////
// UserAccountForm.aspx

Ice.Extend(Ice.GCart, {
	GetUserAccountForm: function()
	{
		Ice.GCart.ShowLoadingMask(true);		
		GUserService.GetUserAccountFormWithData(function(account){
			var div = 	document.getElementById("pageContent");
			div.innerHTML = "";
			div.innerHTML = account.Form;
			Ice.FormSerialization.PopulateHtmlControls("divAddressData", account.Address, true);
			Ice.FormSerialization.PopulateHtmlControls("divUserData", account.User, true);
			Ice.GCart.ShowLoadingMask(false);			
		});
	}
	
});

//////////////////////////////////////////////////////////
// confirm.aspx

Ice.Extend(Ice.GCart, {
	EditCheckoutAddresses: function()
	{
		Ice.GCart.ShowLoadingMask(true);		
		GUserService.GetCheckoutAddressesFormWithData(function(addresses){
			var div = document.getElementById("divCheckout");
			div.innerHTML = "";
			div.innerHTML = addresses.Form;
			Ice.FormSerialization.PopulateHtmlControls("divBillingAddress", addresses.Billing, true);
			Ice.FormSerialization.PopulateHtmlControls("divShippingAddress", addresses.Shipping, true);
			Ice.GCart.ShowLoadingMask(false);			
		});
	},
	
	UpdateCheckoutAddresses: function(redirectToNextPage)
	{
		var billing = Ice.FormSerialization.SerializeHtmlControls("divBillingAddress", "requiredField");
		var shipping = Ice.FormSerialization.SerializeHtmlControls("divShippingAddress", "requiredField");
		if(billing == null || shipping == null)
		{
			alert(Ice.GCart.SystemMsg.MissingRequiredFields);
		}
		else
		{
			Ice.GCart.ShowLoadingMask(true);			
			GUserService.UpdateCheckoutAddresses(billing, shipping, function(gResult){
				if(gResult.Success)
				{
					window.location = redirectToNextPage ? "?p=checkoutcharge" : window.location;
				}
				else
				{
					Ice.GCart.ShowLoadingMask(true);					
					alert(gResult.Message);
				}
			});
		}	
	},
	
	ProcessPGResult: function(pgResultObj)
	{
		if(pgResultObj.Form != null && pgResultObj.Form.length > 0)
		{
			// <form.. received
			var div = document.createElement("div");
			div.style.display = "none";
			div.innerHTML = pgResultObj.Form;
			document.body.appendChild(div);
			setTimeout(function(){div.getElementsByTagName("form")[0].submit();}, 10);
		}
		else if(pgResultObj.JavaScript != null && pgResultObj.JavaScript.length > 0)  // no <form tag, it's JavaScript
		{
			// execute JavaScript received
			var sc = document.createElement("script");
			sc.type = "text/javascript";
			sc.text = pgResultObj.JavaScript;
			document.body.appendChild(sc);
			Ice.GCart.ShowLoadingMask(false);
		}
		else
		{
			alert(pgResultObj.Text);
			if(pgResultObj.Reload)
			{
				window.location = window.location;
				return false;
			}
			else
			{
				return true;
			}
		}
		return false;
	},
	
	GoToPaymentGateway: function()
	{
		Ice.GCart.ShowLoadingMask(true);
		//var buttons = document.getElementById("buttons");
		//buttons.style.display = "none";
		GUserService.GetPGHandleCode(function(pgResultObj){
				if(Ice.GCart.ProcessPGResult(pgResultObj))
				{
					// show buttons again
					//buttons.style.display = "";
					Ice.GCart.ShowLoadingMask(false);
				}
			});
	},
	
	ConfirmCCNumber : function(sender, processingMessage)
	{
		sender.PayNowText = sender.value;
		sender.value = processingMessage;
		sender.disabled = true;
		
		var o = Ice.FormSerialization.SerializeHtmlControls("divPGDataContainer", "requiredField");
		if(o == null)
		{
			alert(Ice.GCart.SystemMsg.MissingRequiredFields);
			// show Pay Now button again
			sender.value = sender.PayNowText;
			sender.disabled = false;
		}
		else
		{
			Ice.GCart.ShowLoadingMask(true);
			GUserService.ChargeAIMMethodCC(o, function(pgResultObj){
				if(Ice.GCart.ProcessPGResult(pgResultObj))
				{
					// show Pay Now button again
					sender.value = sender.PayNowText;
					sender.disabled = false;
					Ice.GCart.ShowLoadingMask(false);
				}
			});
		}
	}
	
});

//////////////////////////////////////////////////////////

