﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ice.Orm.Core.Criteria.SqlBlocks
{

	/********************************
	 * Sql query blocks from MS LINQ to SQL:
	Select
	From
	Where
	Having
	OrderBy
	OrderDirection
	GroupBy
	IsDistinct
	IsPercent
	********************************/

	/// <summary>
	/// SqlBlock kind. Do not change the order in the enumeration!
	/// </summary>
	public enum BlockKindEnum
	{
		Unspecified = 0,
		/// <summary>
		/// general Sql command, highest priority
		/// </summary>
		Command,
		Delete,
		Insert,
		Update,
		Select,
		Count,
		Having,
		GroupBy,
		From,
		Join,
		Where,
		OrderBy,
		OffsetLimit
	}
}
