﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace Ice.Orm.Core.Criteria.SqlBlocks
{
	internal class SqlDeleteBlock : ISqlBlock
	{
		public BlockKindEnum Kind { get { return BlockKindEnum.Delete; } }
		public IEnumerable<SqlSegment> SelectSqlSegments()
		{
			if (!this.IsEmpty)
			{
				yield return new SqlSegment("DELETE FROM " + this.TableName);
			}
		}

		private string TableName;
		public void AddTable(SqlName tableName){this.TableName = tableName.ToFullSqlName();}

		public bool IsEmpty { get { return string.IsNullOrEmpty(this.TableName); } }
		public void Clear() { this.TableName = null; }
	}
}
