﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace Ice.Orm.Core.Criteria.SqlBlocks
{
	internal class SqlOffsetLimitBlock : ISqlBlock
	{
		public BlockKindEnum Kind { get { return BlockKindEnum.OffsetLimit; } }
		public int Offset { get; set; }
		public int? Limit { get; set; }
		public bool UseOffsetAndLimit { get; set; }
		public bool IsEmpty { get { return !(UseOffsetAndLimit && (Offset > 0 || Limit > 0)); } }

		public void Clear() { Offset = 0; Limit = null; }

		public IEnumerable<SqlSegment> SelectSqlSegments()
		{
			if (!this.IsEmpty)
			{
				yield return new SqlSegment("\r\n");
				// mora prvo LIMIT potom OFFSET, ne radi obrnuto
				// moze biti samo LIMIT, ali samo OFFSET ne moze
				yield return new SqlSegment("LIMIT " + (this.Limit > 0 ? this.Limit : int.MaxValue) + " OFFSET " + this.Offset);
			}
		}


	}
}

