﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ice.Orm.Core.Criteria;
using System.Collections.ObjectModel;

namespace Ice.Orm.Core.Criteria.SqlBlocks
{
	internal class SqlUpdateBlock : ISqlBlock
	{
		private SqlSegmentCollection _sqlSegments = new SqlSegmentCollection();

		public BlockKindEnum Kind { get { return BlockKindEnum.Update; } }
		
		public void Add(SqlName tableName, params QParameter[] args)
		{
			this.TableName = tableName.ToFullSqlName();
			args.ForEach(o => _sqlSegments.Add(o));
		}
		private string TableName;
		
		public bool IsEmpty { get { return string.IsNullOrEmpty(this.TableName) || !_sqlSegments.Any();}}
		public void Clear() { this.TableName = null; _sqlSegments.Clear(); }

		public IEnumerable<SqlSegment> SelectSqlSegments()
		{
			if (!this.IsEmpty)
			{
				yield return new SqlSegment("UPDATE " + this.TableName + "\r\n" + "SET");

				bool firstAdded = false;
				foreach (SqlSegment seg in _sqlSegments.AsEnumerable())
				{
					// insert comma between 2 values
					if (firstAdded)
					{
						yield return new SqlSegment(",");
					}
					yield return new SqlSegment(seg.Parameter.FullSqlColumn);
					yield return new SqlSegment("=");
					yield return (seg);
					firstAdded = true;
				}
			}
		}
	}
}

