﻿using System;

namespace Ice.Orm.Core.Entity
{
	using Schema;
	using DataStore;
	using System.Collections.Generic;

	[AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = true)]
	public class EntityCache : Attribute
	{
		/// <summary>
		/// Absolute expiration in seconds measured from the moment item is inserted into cache.
		/// </summary>
		public double DurationSek { get; set; }

		/// <summary>
		/// Sliding expiration in seconds. Every time object is used, expiration extends for siliding expiration value.
		/// </summary>
		public bool IsSlidingExpiration { get; set; }

		public EntityCache()
		{

		}

	}
}
