﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Collections;

namespace Ice.Converter
{
	public class IceObjectConverter
	{
		public static Dictionary<string, object> ConvertToDictionary(object obj)
		{
			Dictionary<string, object> dic = new Dictionary<string, object>();

			foreach (MemberInfo mi in obj.GetType().GetMembers(BindingFlags.Public | BindingFlags.Instance))
			{
				object value;
				Type type;

				if (mi.MemberType == MemberTypes.Property)
				{
					PropertyInfo pi = (PropertyInfo)mi;
					type = ((PropertyInfo)mi).PropertyType;
					value = pi.GetValue(obj, null);
				}
				else if (mi.MemberType == MemberTypes.Field)
				{
					FieldInfo fi = (FieldInfo)mi;
					type = fi.FieldType;
					value = fi.GetValue(obj);
				}
				else
				{
					continue;
				}

				dic.Add(mi.Name, value);
			}

			return dic;
		}
	}
}
