﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Security.Cryptography.X509Certificates;
using System.Text.RegularExpressions;

namespace Ice.IO
{
	public class FileTools
	{
		/// <summary>
		/// Get file name from full path name, works with both \ and / separator
		/// </summary>
		/// <param name="fullPathWithFileName"></param>
		/// <returns></returns>
		public static string GetFileName(string fullPathWithFileName)
		{
			Regex re = new Regex("(?<file>[^\\/\\\\]+)$");
			Match m = re.Match(fullPathWithFileName);
			if (m.Success)
			{
				return m.Groups["file"].Value;
			}
			else
			{
				return fullPathWithFileName;
			}
		}

		public static string GetFilePath(string fullPathWithFileName)
		{
			string file = GetFileName(fullPathWithFileName);
			string path = fullPathWithFileName.Replace(file, "");
			if (path.Length == 0)
			{
				return fullPathWithFileName;
			}
			return path;
		}

		public static string GetUpperDirectory(string path)
		{
			int intIndex = path.LastIndexOf("\\");
			if (intIndex > 0)
			{
				path = path.Substring(0, intIndex);
			}
			path = GetFilePath(path);
			return path;
		}


	}
}
