﻿#if !SILVERLIGHT

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.IO;
using Ice.Net.Sockets.Abstract;

namespace Ice.Net.Sockets
{
	public class IceClientSocket : IceSocketBase<IceClientSocket>
	{
		public IceClientSocket(Socket socket, IPEndPoint serverEP) : base(socket, serverEP)
		{
		}

		public IceClientSocket Connect()
		{
			// connecting client to the server: send some data to the server, than begin receiving data

			Send("connect");

			//Start receiving data
			BeginReceiveData();

			return this;
		}

		public IceClientSocket StopClient()
		{
			_socket.Close();
			return this;
		}

		public IceClientSocket Send(byte[] data)
		{
			return base.SendTo(this._remoteEP, data);
		}

		public IceClientSocket Send(string str)
		{
			return base.SendTo(this._remoteEP, Encoding.UTF8.GetBytes(str));
		}


	}
}

#endif
