﻿#if !SILVERLIGHT

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.IO;
using Ice.Net.Sockets.Abstract;

namespace Ice.Net.Sockets
{
	public class IceServerSocket : IceSocketBase<IceServerSocket>
	{
		IPEndPoint _bindToEP;

		public IceServerSocket(Socket socket, IPEndPoint bindToEP) : base(socket, new IPEndPoint(IPAddress.Any, bindToEP.Port))
		{
			this._bindToEP = bindToEP;	
		}

		public IceServerSocket StartServer()
		{
			//Bind this address to the server
			_socket.Bind(_bindToEP);

			//Start receiving data
			BeginReceiveData();

			return this;
		}

		public IceServerSocket StopServer()
		{
			_socket.Close();
			return this;
		}

		public IceServerSocket SendTo(EndPoint toEP, byte[] data)
		{
			return base.SendTo(toEP, data);
		}

		public IceServerSocket SendTo(EndPoint toEP, string str)
		{
			return SendTo(toEP, Encoding.UTF8.GetBytes(str));
		}

	}
}

#endif
