﻿using System;

namespace Ice.Utility
{
	public class UnixTimeConversion
	{
		// 1 .NET Tick = 1ms/10000;
		// 10000 .NET Ticks = 1ms

		internal static readonly long DatetimeMinTimeTicks = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc).Ticks;

		public static DateTime GetDateTime(double unixMiliseconds)
		{
			return new DateTime(DatetimeMinTimeTicks + (long)(unixMiliseconds * 10000));
		}

		public static double GetUnixMiliseconds(DateTime dateTime)
		{
			return (new TimeSpan(dateTime.Ticks - DatetimeMinTimeTicks)).TotalMilliseconds;
		}
	}
}
