﻿#if !SILVERLIGHT
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Text.RegularExpressions;
using Ice.Extensions;
using Ice.Utility;
using System.Windows.Forms;

namespace Ice.Windows.Forms.Extensions
{
	public static class ControlExtensions
	{

		#region TreeView extensions

		public static IEnumerable<TreeNode> DescendantNodes(this TreeNode node)
		{
			if (node != null && node.Nodes != null && node.Nodes.Count > 0)
			{
				foreach (TreeNode n in node.Nodes)
				{
					yield return n;

					foreach (TreeNode n1 in n.DescendantNodes())
					{
						yield return n1;
					}
				}
			}
		}

		public static IEnumerable<TreeNode> AncestorNodes(this TreeNode node)
		{
			while ((node = node.Parent) != null)
			{
				yield return node;
			}
		}

		public static IEnumerable<TreeNode> DescendantNodes(this TreeView treeView)
		{
			// return treeView.Nodes.Cast<TreeNode>().Concat(treeView.Nodes.Cast<TreeNode>().SelectMany(o => o.DescendantNodes()));
			foreach(TreeNode n in treeView.Nodes)
			{
				yield return n;

				foreach(TreeNode n1 in n.DescendantNodes())
				{
					yield return n1;
				}
			}
		}

		#endregion

	}




}
#endif
