﻿
Ice.Collections = {__class:true};

Ice.Collections.Yield = function ()
{
	this.YieldValue = null;
};

Ice.Collections.Yield.__class = true;

Ice.Collections.Yield.prototype = new (function ()
{
	this.typeName = "Ice.Collections.Yield";
})();


Ice.Collections.CreateEnumerator = new (function ()
{
	function YielderEnumerator(initFunc, yieldNextFunc)
	{
		var initDone;
		var current;
		var tmpYield;

		this.Index = -1;
		this.Finished = false;

		this.Reset = function ()
		{
			this.Finished = false;
			this.Index = -1;
			current = null;
			initDone = false;
			tmpYield = null;
		};

		this.YieldNext = function (yldobj)
		{
			if (!initDone && initFunc)
			{
				initDone = true;
				initFunc();
			}
			if (yieldNextFunc(yldobj))
			{
				this.Index++;
				current = yldobj.YieldValue;
				return true;
			}
			this.Finished = true;
			return false;
		};

		this.MoveNext = function ()
		{
			return this.YieldNext(tmpYield || (tmpYield = new Ice.Collections.Yield()));
		};

		this.Current = function ()
		{
			return current;
		};
	};

	function ArrayEnumerator(array)
	{
		/// <summary>
		/// Array or String enumerator
		/// </summary>
		/// <param name="array" type="Array|String"></param>

		var index;
		var useCharAt;

		return new YielderEnumerator(function ()
		{
			index = -1;
			useCharAt = typeof(array) == "string"; // invoke at init time, it is slow as hell if array.charAt invoked in foreach every time
		},
		function (yldobj)
		{
			if (array.length > 0 && ++index < array.length)
			{
				yldobj.YieldValue = useCharAt ? array.charAt(index) : array[index];
				return true;
			}
			return false;
		});
	};


	return function (initFuncOrArray, yieldNextFunc)
	{
		/// <summary>
		/// Enumerator ctor.
		/// </summary>
		/// <param name="initFuncOrArray" type="Array|Function">if array, create ArrayEnumerator, else if function, function is invoked on first YieldNext invocation</param>
		/// <param name="yieldNextFunc" type="Null|Function">on YieldNext, invokes yieldNextFunc(yldobj)</param>

		if (yieldNextFunc)
		{
			return new YielderEnumerator(initFuncOrArray, yieldNextFunc);
		}
		else
		{
			return new ArrayEnumerator(initFuncOrArray);
		}
	};

})();






