﻿
Ice.Colorspace = new (function ()
{
	var _this = this;

	var namedColors = {
		'aliceblue': '#f0f8ff',
		'antiquewhite': '#faebd7',
		'aqua': '#00ffff',
		'aquamarine': '#7fffd4',
		'azure': '#f0ffff',
		'beige': '#f5f5dc',
		'bisque': '#ffe4c4',
		'black': '#000000',
		'blanchedalmond': '#ffebcd',
		'blue': '#0000ff',
		'blueviolet': '#8a2be2',
		'brown': '#a52a2a',
		'burlywood': '#deb887',
		'cadetblue': '#5f9ea0',
		'chartreuse': '#7fff00',
		'chocolate': '#d2691e',
		'coral': '#ff7f50',
		'cornflowerblue': '#6495ed',
		'cornsilk': '#fff8dc',
		'crimson': '#dc143c',
		'cyan': '#00ffff',
		'darkblue': '#00008b',
		'darkcyan': '#008b8b',
		'darkgoldenrod': '#b8860b',
		'darkgray': '#a9a9a9',
		'darkgrey': '#a9a9a9',
		'darkgreen': '#006400',
		'darkkhaki': '#bdb76b',
		'darkmagenta': '#8b008b',
		'darkolivegreen': '#556b2f',
		'darkorange': '#ff8c00',
		'darkorchid': '#9932cc',
		'darkred': '#8b0000',
		'darksalmon': '#e9967a',
		'darkseagreen': '#8fbc8f',
		'darkslateblue': '#483d8b',
		'darkslategray': '#2f4f4f',
		'darkslategrey': '#2f4f4f',
		'darkturquoise': '#00ced1',
		'darkviolet': '#9400d3',
		'deeppink': '#ff1493',
		'deepskyblue': '#00bfff',
		'dimgray': '#696969',
		'dimgrey': '#696969',
		'dodgerblue': '#1e90ff',
		'firebrick': '#b22222',
		'floralwhite': '#fffaf0',
		'forestgreen': '#228b22',
		'fuchsia': '#ff00ff',
		'gainsboro': '#dcdcdc',
		'ghostwhite': '#f8f8ff',
		'gold': '#ffd700',
		'goldenrod': '#daa520',
		'gray': '#808080',
		'grey': '#808080',
		'green': '#008000',
		'greenyellow': '#adff2f',
		'honeydew': '#f0fff0',
		'hotpink': '#ff69b4',
		'indianred': '#cd5c5c',
		'indigo': '#4b0082',
		'ivory': '#fffff0',
		'khaki': '#f0e68c',
		'lavender': '#e6e6fa',
		'lavenderblush': '#fff0f5',
		'lawngreen': '#7cfc00',
		'lemonchiffon': '#fffacd',
		'lightblue': '#add8e6',
		'lightcoral': '#f08080',
		'lightcyan': '#e0ffff',
		'lightgoldenrodyellow': '#fafad2',
		'lightgray': '#d3d3d3',
		'lightgrey': '#d3d3d3',
		'lightgreen': '#90ee90',
		'lightpink': '#ffb6c1',
		'lightsalmon': '#ffa07a',
		'lightseagreen': '#20b2aa',
		'lightskyblue': '#87cefa',
		'lightslategray': '#778899',
		'lightslategrey': '#778899',
		'lightsteelblue': '#b0c4de',
		'lightyellow': '#ffffe0',
		'lime': '#00ff00',
		'limegreen': '#32cd32',
		'linen': '#faf0e6',
		'magenta': '#ff00ff',
		'maroon': '#800000',
		'mediumaquamarine': '#66cdaa',
		'mediumblue': '#0000cd',
		'mediumorchid': '#ba55d3',
		'mediumpurple': '#9370d8',
		'mediumseagreen': '#3cb371',
		'mediumslateblue': '#7b68ee',
		'mediumspringgreen': '#00fa9a',
		'mediumturquoise': '#48d1cc',
		'mediumvioletred': '#c71585',
		'midnightblue': '#191970',
		'mintcream': '#f5fffa',
		'mistyrose': '#ffe4e1',
		'moccasin': '#ffe4b5',
		'navajowhite': '#ffdead',
		'navy': '#000080',
		'oldlace': '#fdf5e6',
		'olive': '#808000',
		'olivedrab': '#6b8e23',
		'orange': '#ffa500',
		'orangered': '#ff4500',
		'orchid': '#da70d6',
		'palegoldenrod': '#eee8aa',
		'palegreen': '#98fb98',
		'paleturquoise': '#afeeee',
		'palevioletred': '#d87093',
		'papayawhip': '#ffefd5',
		'peachpuff': '#ffdab9',
		'peru': '#cd853f',
		'pink': '#ffc0cb',
		'plum': '#dda0dd',
		'powderblue': '#b0e0e6',
		'purple': '#800080',
		'red': '#ff0000',
		'rosybrown': '#bc8f8f',
		'royalblue': '#4169e1',
		'saddlebrown': '#8b4513',
		'salmon': '#fa8072',
		'sandybrown': '#f4a460',
		'seagreen': '#2e8b57',
		'seashell': '#fff5ee',
		'sienna': '#a0522d',
		'silver': '#c0c0c0',
		'skyblue': '#87ceeb',
		'slateblue': '#6a5acd',
		'slategray': '#708090',
		'slategrey': '#708090',
		'snow': '#fffafa',
		'springgreen': '#00ff7f',
		'steelblue': '#4682b4',
		'tan': '#d2b48c',
		'teal': '#008080',
		'thistle': '#d8bfd8',
		'tomato': '#ff6347',
		'turquoise': '#40e0d0',
		'violet': '#ee82ee',
		'wheat': '#f5deb3',
		'white': '#ffffff',
		'whitesmoke': '#f5f5f5',
		'yellow': '#ffff00',
		'yellowgreen': '#9acd32'
	};


	var ColorConverter =
	{
		RGBtoHSV: function (RGB)
		{
			var result = new _this.HSV(0, 0, 0);

			r = RGB.r / 255;
			g = RGB.g / 255;
			b = RGB.b / 255;

			var minVal = Math.min(r, g, b);
			var maxVal = Math.max(r, g, b);
			var delta = maxVal - minVal;

			result.v = maxVal;

			if (delta == 0)
			{
				result.h = 0;
				result.s = 0;
			} else
			{
				result.s = delta / maxVal;
				var del_R = (((maxVal - r) / 6) + (delta / 2)) / delta;
				var del_G = (((maxVal - g) / 6) + (delta / 2)) / delta;
				var del_B = (((maxVal - b) / 6) + (delta / 2)) / delta;

				if (r == maxVal) { result.h = del_B - del_G; }
				else if (g == maxVal) { result.h = (1 / 3) + del_R - del_B; }
				else if (b == maxVal) { result.h = (2 / 3) + del_G - del_R; }

				if (result.h < 0) { result.h += 1; }
				if (result.h > 1) { result.h -= 1; }
			}

			////result.h = Math.round(result.h * 360);
			////result.s = Math.round(result.s * 100);
			////result.v = Math.round(result.v * 100);

			// don't round it, to be more precize when adjusting values for web
			result.h = (result.h * 360);
			result.s = (result.s * 100);
			result.v = (result.v * 100);

			return result;
		},

		HSVtoRGB: function (HSV)
		{
			var result = new _this.RGB(0, 0, 0);

			var h = HSV.h / 360;
			var s = HSV.s / 100;
			var v = HSV.v / 100;

			if (s == 0)
			{
				result.r = v * 255;
				result.g = v * 255;
				result.v = v * 255;
			}
			else
			{
				var var_h = h * 6;
				var var_i = Math.floor(var_h);
				var var_1 = v * (1 - s);
				var var_2 = v * (1 - s * (var_h - var_i));
				var var_3 = v * (1 - s * (1 - (var_h - var_i)));

				if (var_i == 0) { var_r = v; var_g = var_3; var_b = var_1 }
				else if (var_i == 1) { var_r = var_2; var_g = v; var_b = var_1 }
				else if (var_i == 2) { var_r = var_1; var_g = v; var_b = var_3 }
				else if (var_i == 3) { var_r = var_1; var_g = var_2; var_b = v }
				else if (var_i == 4) { var_r = var_3; var_g = var_1; var_b = v }
				else { var_r = v; var_g = var_1; var_b = var_2 };

				result.r = var_r * 255;
				result.g = var_g * 255;
				result.b = var_b * 255;

				result.r = Math.round(result.r);
				result.g = Math.round(result.g);
				result.b = Math.round(result.b);
			}

			return result;
		},

		CMYKtoRGB: function (CMYK)
		{
			var result = new _this.RGB(0, 0, 0);

			var c = CMYK.c / 100;
			var m = CMYK.m / 100;
			var y = CMYK.y / 100;
			var k = CMYK.k / 100;

			result.r = 1 - Math.min(1, c * (1 - k) + k);
			result.g = 1 - Math.min(1, m * (1 - k) + k);
			result.b = 1 - Math.min(1, y * (1 - k) + k);

			result.r = Math.round(result.r * 255);
			result.g = Math.round(result.g * 255);
			result.b = Math.round(result.b * 255);

			return result;
		},

		RGBtoCMYK: function (RGB)
		{
			var result = new _this.CMYK(0, 0, 0, 0);

			var r = RGB.r / 255;
			var g = RGB.g / 255;
			var b = RGB.b / 255;

			result.k = Math.min(1 - r, 1 - g, 1 - b);
			result.c = (1 - r - result.k) / (1 - result.k);
			result.m = (1 - g - result.k) / (1 - result.k);
			result.y = (1 - b - result.k) / (1 - result.k);

			result.c = Math.round(result.c * 100);
			result.m = Math.round(result.m * 100);
			result.y = Math.round(result.y * 100);
			result.k = Math.round(result.k * 100);

			return result;
		},

		parseHEXtoRGB: function (hex, opacity) 
		{
			/// <summary>
			/// accept #rgb and #rrggbb variants and opacity.
			/// </summary>
			/// <param name="hex"></param>
			/// <param name="opacity"></param>
			
			var h=hex.replace('#', '');
			h =  h.match(new RegExp('(.{'+ h.length / 3+ '})', 'g'));

			for (var i = 0; i < h.length; i++)
			{
				h[i] = parseInt(h[i].length == 1 ? h[i] + h[i] : h[i], 16);
			}

			if (typeof opacity != 'undefined')
			{
				h.push(opacity);
			}

			//return 'rgba('+h.join(',')+')';
			var result = new _this.RGB(0, 0, 0);
			result.r = h[0];
			result.g = h[1];
			result.b = h[2];
			result.op = h[3];
			return result;
		},

		pad: function (val, len)
		{
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		},

		RGBtoHEX: function(RGB)
		{
			return "#" + ColorConverter.pad(Number(Math.round(RGB.r || 0)).toString(16), 2)
				+ ColorConverter.pad(Number(Math.round(RGB.g || 0)).toString(16), 2)
				+ ColorConverter.pad(Number(Math.round(RGB.b || 0)).toString(16), 2);
		}

	};

	_this.converter = ColorConverter;

	_this.HSV = function (h, s, v)
	{
		/// <summary>
		/// ctor.
		/// </summary>
		/// <param name="h">0...360 (hue)</param>
		/// <param name="s">0...100 (saturation)</param>
		/// <param name="v">0...100 (value or brightnes)</param>

		if (h <= 0) { h = 0; }
		if (s <= 0) { s = 0; }
		if (v <= 0) { v = 0; }

		if (h > 360) { h = 360; }
		if (s > 100) { s = 100; }
		if (v > 100) { v = 100; }

		this.h = h;
		this.s = s;
		this.v = v;
	};

	_this.HSV.ParseHSV = function (hsvString)
	{
		/// <summary>
		/// parse from hsv(h, s, v). Returns HSV instance.
		/// </summary>
		/// <param name="hsvString"></param>

		var arr = hsvString.match(new RegExp("[\\d]+", "ig"));

		return new _this.HSV(
			parseInt(arr[0], 10),
			parseInt(arr[1], 10),
			parseInt(arr[2], 10)
			);
	};

	_this.HSV.prototype.ToHSV = function () { return this.Clone(); };
	_this.HSV.prototype.ToRGB = function () { return ColorConverter.HSVtoRGB(this); };
	_this.HSV.prototype.ToHEX = function () { return this.ToRGB().ToHEX(); };
	_this.HSV.prototype.ToCMYK = function () { return this.ToRGB().ToCMYK(); };
	_this.HSV.prototype.Clone = function () { return new _this.HSV(this.h, this.s, this.v); };
	_this.HSV.prototype.ToHtml = function () { return "hsv(" + Math.round(this.h) + ", " + Math.round(this.s) + ", " + Math.round(this.v) + ")"; };

	_this.HSV.prototype.ChangeSaturationPercent = function (saturationChangePercent)
	{
		var obj = new _this.HSV(this.h, this.s, this.v);

		if (saturationChangePercent != 0)
		{
			obj.s += obj.s * saturationChangePercent / 100;
		}
		return obj;
	};

	_this.HSV.prototype.ChangeLightnesPercent = function (lightnesChangePercent)
	{
		var obj = new _this.HSV(this.h, this.s, this.v);
		if (lightnesChangePercent != 0)
		{
			obj.v += obj.v * lightnesChangePercent / 100;
		}
		return obj;
	};

	_this.RGB = function (r, g, b, opacity)
	{
		/// <summary>
		/// ctor.
		/// </summary>
		/// <param name="r">0...255</param>
		/// <param name="g">0...255</param>
		/// <param name="b">0...255</param>
		if (r <= 0) { r = 0; }
		if (g <= 0) { g = 0; }
		if (b <= 0) { b = 0; }
		if (opacity <= 0) { opacity = 0;}

		if (r > 255) { r = 255; }
		if (g > 255) { g = 255; }
		if (b > 255) { b = 255; }
		if (opacity > 255) { opacity = 255;}

		this.r = r;
		this.g = g;
		this.b = b;
		this.op = opacity;
	};

	_this.RGB.ParseHEX = function (hexString)
	{
		/// <summary>
		/// parse hex #rgb or #rrggbb
		/// </summary>
		/// <param name="hexString"></param>
		
		var v = ColorConverter.parseHEXtoRGB(hexString);
		return new _this.RGB(v.r, v.g, v.b, v.op);
	};

	_this.RGB.ParseRGB = function (rgbString)
	{
		/// <summary>
		/// parse rgb(r, g, b) or rgb(r, g, b, opacity)
		/// </summary>
		/// <param name="rgbString"></param>

		var arr = rgbString.match(new RegExp("[\\d]+", "ig"));

		return new _this.RGB(parseInt(arr[0], 10),
			parseInt(arr[1], 10),
			parseInt(arr[2], 10),
			parseInt(arr[3], 10)
			);
	};

	_this.RGB.prototype.ToRGB = function () { return this.Clone(); };
	_this.RGB.prototype.ToHEX = function () { return ColorConverter.RGBtoHEX(this); };
	_this.RGB.prototype.ToHSV = function () { return ColorConverter.RGBtoHSV(this); };
	_this.RGB.prototype.ToCMYK = function () { return ColorConverter.RGBtoCMYK(this); };
	_this.RGB.prototype.Clone = function () { return new _this.RGB(this.r, this.g, this.b, this.op); };
	_this.RGB.prototype.ToHtml = function () { return "rgb(" + Math.round(this.r) + ", " + Math.round(this.g) + ", " + Math.round(this.b) + (Ice.Type.IsNumber(this.op) ? (", " + Math.round(this.op)) : "") + ")"; };

	_this.CMYK = function (c, m, y, k)
	{
		/// <summary>
		/// ctor.
		/// </summary>
		/// <param name="c">0...100</param>
		/// <param name="m">0...100</param>
		/// <param name="y">0...100</param>
		/// <param name="k">0...100</param>

		if (c <= 0) { c = 0; }
		if (m <= 0) { m = 0; }
		if (y <= 0) { y = 0; }
		if (k <= 0) { k = 0; }

		if (c > 100) { c = 100; }
		if (m > 100) { m = 100; }
		if (y > 100) { y = 100; }
		if (k > 100) { k = 100; }

		this.c = c;
		this.m = m;
		this.y = y;
		this.k = k;
	};

	_this.CMYK.prototype.ToRGB = function () { return ColorConverter.CMYKtoRGB(this); };


	_this.Parse = function (colorStr)
	{
		/// <summary>
		/// Returns RGB color object. Parse from hex, rgb or hsv: #rgb, #rrggbb, rgb(R, G, B), rgb(R, G, B, opacity), hsv(H, S, V)
		/// </summary>
		/// <param name="colorStr"></param>

		var hex;

		if (colorStr.indexOf("rgb") == 0)
		{
			return _this.RGB.ParseRGB(colorStr);
		}
		else if (colorStr.indexOf("#") == 0)
		{
			return _this.RGB.ParseHEX(colorStr);
		}
		else if(colorStr.indexOf("hsv") == 0)
		{
			return _this.HSV.ParseHSV(colorStr).ToRGB();
		}
		else if(colorStr && (hex = namedColors[colorStr]) && hex.indexOf("#") == 0)
		{
			return _this.RGB.ParseHEX(hex);
		}
		else if (Ice.IsVSIntellisene)
		{
			// for vs intellisense to work
			return new _this.RGB();
		}
	};

})();


