﻿/// <reference path="Ice.js" />
/// <reference path="Ice.Net.js" />
/// <reference path="Ice.Diagnostic.js" />
/// <reference path="Ice.DataBinder.js" />

Ice.RegisterNs("Ice.Diagnostic");

Ice.Diagnostic.AssertFunction = function (fullName, context)
{
	/// <summary>
	/// Test if function with fullName exists in contex or window. Throws exception if function not found.
	/// </summary>
	/// <param name="fullName">full function name including namespace from root</param>
	/// <param name="context" optional="true" type="Object">default value is window</param>

	if (typeof (Ice.DataBinder.GetValue(window, fullName)) != "function")
	{
		Ice.Diagnostic.Exception("Function not found: " + fullName);
	}
};

