﻿//********************************************
// this file is included in engine if DEBUG is defined
//********************************************

new (function ()
{

	var test1 = new Ice.DomQuery(["one", "two", "nemza", "temza", "aa", "bb", "cc"])
	.OrderBy("o => o.length", true)
	.ThenBy("o=>o", true) // then order by, automatic recognition
	.GroupBy("o=>o.length") // then order by, automatic recognition
	.Select("o=>o.KeySelector + ': ' + o.Key + ', items: ' + o.ToStringJoined('|')")
	.ToStringJoined(", ");

	if (test1 != "o=>o.length: 5, items: temza|nemza, o=>o.length: 3, items: two|one, o=>o.length: 2, items: cc|bb|aa")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.List test 1! Result: " + test1);
	}

	//********************************************
	// test 2
	//********************************************
	var test2 = new Ice.DomQuery([1, 2, 3, 4, 5])
	.Where("o=>o > 2")
	.Select("(o, n) => new {item: o, index: n}")
	.OrderBy("o=>o.index", true)
	.Select("(o, n) => 'index: ' + n + ', value: ' + o.item")
	.ToStringJoined("; ");

	if (test2 != "index: 0, value: 5; index: 1, value: 4; index: 2, value: 3")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.List test 2! Result: " + test2);
	}


	var aaa =
	[
		{ Ordinal: 11, ParentCategoryID: 5, Name: "111" },
		{ Ordinal: 11, ParentCategoryID: 5, Name: "222" },
		{ Ordinal: 11, ParentCategoryID: 5, Name: "333" },
		{ Ordinal: 11, ParentCategoryID: 5, Name: "" },
		{ Ordinal: 11, ParentCategoryID: 5, Name: null },
		{ Ordinal: 11, ParentCategoryID: 5 },

		{ Ordinal: 24, ParentCategoryID: 22, Name: "SomeName" },
		{ Ordinal: 24, ParentCategoryID: 22, Name: "555" },
		{ Ordinal: 24, ParentCategoryID: 55, Name: "666" },

		{ Ordinal: 88, ParentCategoryID: 33, Name: "Mark" },
		{ Ordinal: 88, ParentCategoryID: 55 },

		{ Ordinal: 11, ParentCategoryID: 22 },
		{ Ordinal: 11, ParentCategoryID: 33 },
		{ Ordinal: 11, ParentCategoryID: 55, Name: "Anthon" },

		{ Ordinal: 24, ParentCategoryID: 22 },
		{ Ordinal: 24, ParentCategoryID: 33 },
		{ Ordinal: 24, ParentCategoryID: 55, Name: "Clara" },

		{ Ordinal: 11, ParentCategoryID: 55, Name: "Runna" },
		{ Ordinal: 11, ParentCategoryID: 55, Name: "Inta" },
		{ Ordinal: 11, ParentCategoryID: 55, Name: "333" },
		{ Ordinal: 11, ParentCategoryID: 55, Name: "333" },

		{ Ordinal: 88, ParentCategoryID: 22 },
		{ Ordinal: 88, ParentCategoryID: 33 },
		{ Ordinal: 88, ParentCategoryID: 55 }

	];

	//********************************************
	// test 3
	//********************************************
	var bb = new Ice.DomQuery(aaa)
		.OrderBy("o=>o.Ordinal", false)
		.ThenBy("o=>o.ParentCategoryID", true)
		.ThenBy("o=>o.Name", false)
		.Where("o=>o.Ordinal > 11")
		.OrderBy("o=>o.ParentCategoryID", true)
		.ThenBy("o=>o.Name");

	var cc = bb.Select("o=>o.Ordinal + ', ' + o.ParentCategoryID + ', ' + o.Name").ToStringJoined("|");
	if (cc != "24, 55, 666|24, 55, Clara|88, 55, undefined|88, 55, undefined|24, 33, undefined|88, 33, undefined|88, 33, Mark|24, 22, 555|24, 22, SomeName|24, 22, undefined|88, 22, undefined")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.List test 3. Result: " + cc);
	}

////	//********************************************
////	// test 4
////	//********************************************
///	// used for thenBy after groupBy, not used any more
////	var ss = new Ice.DomQuery(aaa)
////			.OrderBy("o=>o.Ordinal")
////			.ThenByDescending("o=>o.ParentCategoryID")
////			.ThenBy("o=>o.Name")
////			;

////	var cc = ss.Select("o=>o.Key + ', ' + o.KeySelector").ToStringJoined("|");
////	if (cc != "88, o=>o.Ordinal|24, o=>o.Ordinal|11, o=>o.Ordinal")
////	{
////		Ice.Diagnostic.Exception("Self test failed in Ice.List test 4. Result: " + cc);
////	}

	//********************************************
	// test 5
	//********************************************

	var kk = bb.ToGroupsArray();

	if (kk.length != 3)
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.List test 5. Result: " + kk.length);
	}


	var res = new Ice.List(["to sam ja", "ovo je drugi", "treca opcija"]).Cycle().Select("(o, n)=>new {Key: n, Value: o}").SkipWhile("o=>o.Key < 2").TakeWhile("o=>o.Key < 6").Select("o=>o.Key+'_'+o.Value").ToStringJoined();
	if (res != "2_treca opcija3_to sam ja4_ovo je drugi5_treca opcija")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.List.Cycle test. Result: " + res);
	}




	//Ice.Diagnostic.Exception("Ice.Link tests ok");

})();



new (function ()
{

	var html =
	'<div class="search_v2" style="margin-right: 5px;" >\
		<form id="form_search" name="search_main" onsubmit="return check_search_box_keyword()" action="/index.php" method="get">\
			<input name="ctl" type="hidden" value=" ddfe nedgd search2iio" style="display: none" ice-num="45"/>\
			<label ice-num="55" for="f_keywords">Upiši pojam...</label>\
			<input name="f_keywords" id="f_keywords" type="text" style="width: 263px" onfocus="javascript:reset_search_style()" />\
			<input ice-num="25" class="mini_button" type="submit" value="Tražiiio" />\
			<img alt="Beta" style="float: left; margin-top: -3px; padding-left: 5px;" />\
		</form>\
	</div>\
	<div class="clear1" ></div>\
	<div class="clear" ></div>';

	var ddd = Ice.DomQuery.FromHtml(html);

	//alert(ddd.Query("div:not(>input[name])").Count());

	var results = [
		ddd.Query("div:is(>>input[name='ctl'])").Count(), // 1
		ddd.Query("div:not(>>input[name=ctl])").Count(), // 2 // div whic doesn't have second child input[name=ctl33]
		ddd.Query("//input[type=hidden]").Count(), // 1 input with attribute type="hidden"
		ddd.Query("//input[type]").Count(), //3 contains input with attribute type
		ddd.Query("//[type]").Count(), //3 contains attribute type
		ddd.Query("//[value^=Tra]").Count(), //1 attribute value begins with Tra
		ddd.Query("//[value$=io]").Count(), //2 ends with io
		ddd.Query("//[value~=ddfe]").Count(), //1 contains exact word ddfe in list of space-separated values
		ddd.Query("//[ice-num]").Count(), // 3
		ddd.Query("//[ice-num==25]").Count(), // 1
		ddd.Query("//[ice-num > 25]").Count(), // 2
		ddd.Query("//[ice-num <= 45]").Count() // 2
	];

	// 1, 2, 1, 3, 8, 1, 2, 1, 8, 1, 2, 2

	var attrTest1 = results.join(", ");
	if (attrTest1 != "1, 2, 1, 3, 3, 1, 2, 1, 3, 1, 2, 2")
	{
		Ice.Diagnostic.Exception("error in Ice.DomQuery attribute test, result: " + attrTest1);
	}

	var test1 = ddd.Select("o=>o.tagName")
	.Where("o=>o") // don't take text nodes which doesn't have tagname
	.ToStringJoined(", ").toLowerCase();

	if (test1 != "div, div, div")
	{
		Ice.Diagnostic.Exception("error in Ice.DomQuery test1, result: " + test1);
	}

	var test2 = ddd.DescendantNodes()
	.Query("form>label, a, IMG, input.mini_button")
	.Select("o=>o.tagName + o.id + o.name + o.className").ToStringJoined(", ").toLowerCase();

	if (test2 != "labelundefined, img, inputmini_button")
	{
		Ice.Diagnostic.Exception("self test failed in Ice.DomQuery test2, result: " + test2);
	}

	// animation and color test in Chrome requires node to be attached to DOM
	var html2 = '<div><span id="col333" style="background-color:aliceblue">fdsa</span> <span></span>   <div id="dd1" style="overflow:hidden; border:solid 1px red; width:900px; height:65px; position:absolute; margin-top:0;; top:200px; left:200px; background:red; "> prvi</div>	<div>drugi</div>	<div hrEF="hadsfmojurlfasd">treci<p><a class="mmkk" href="http://www.dd.com/mojlink1">moj link</a></p></div>	<div hrEF="hadsfmojurlfasd">treci<p><a class="mmkk" href="http://www.dd.com/mojlink2">moj link</a></p></div>	<div hrEF="hadsfmojurlfasd">treci<p><a class="mmkk" href="http://www.dd.com/mojlink31">moj link</a><a class="mmkk" href="http://www.dd.com/mojlink32">moj link</a><a class="mmkk" href="http://www.dd.com/mojlink33">moj link</a></p></div>	<div>cetvrti</div>	<div id="hh">peti</div></div>';

	var bbb = Ice.DomQuery.FromHtml(html2);

	/// html has to be attached to dom or else Chrome won't mesure runtime widht and height
	var bbb = Ice.DomQuery.FromSelector(document.documentElement).InsertChildren(html2).ChildNodes().Take(1);

	var test3 = bbb.DescendantNodes().Query("div>>a:reverse:take(4):skip(1):reverse").SelectAttribute("hrEF").ToStringJoined(", ");

	if (test3 != "http://www.dd.com/mojlink2, http://www.dd.com/mojlink31, http://www.dd.com/mojlink32")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.DomQuery test3. Result: " + test3);
	}

	//Ice.Diagnostic.Exception("Ice.DomLink tests ok");

	// test4
	var bcolor = $$ice("#col333").SelectStyle("background-color").FirstOrDefault();
	// IE < v9 returns named color, aliceblue in this case
	if (bcolor != "rgb(240, 248, 255)" && bcolor != "aliceblue")
	{
		// aliceblue "rgb(240, 248, 255)"
		Ice.Diagnostic.Exception("Self test failed in Ice.DomQuery test5. Result: " + bcolor + ", expected: " + "rgb(240, 248, 255)");
	}

	var item = bbb.DescendantNodes().Query("#dd1");
	var hh11 = item.SelectStyle("height").FirstOrDefault(); // before
	item.ApplyStyleMap({ width: "950px", opacity: "-=60", height: "+=500" });
	var hh1 = item.SelectStyle("height").FirstOrDefault(); // after
	var hh2 = item.SelectStyle("width").FirstOrDefault();
	var hh3 = item.SelectStyle("opacity").FirstOrDefault();
	var h5 = new Ice.DomQuery([hh11, hh1, hh2, hh3]).ToStringJoined(", ");
	if (h5 != "65, 565, 950, 40")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.DomQuery test4. Result: " + h5);
	}

	// test5
	item.ToAnimator({ height: "+=460", opacity: "-=10" }).Easing(Ice.Animator.Easing.easeInOutExpo).Start().OnComplete(function ()
	{
		var gg11 = new Ice.DomQuery([this._items[0].element]);
		var kk1 = gg11.SelectStyle("opacity").FirstOrDefault();
		var kk2 = gg11.SelectStyle("height").FirstOrDefault();
		var kk6 = new Ice.DomQuery([kk1]).ToStringJoined(", ");

		if (kk6 != "30")
		{
			Ice.Diagnostic.Exception("Self test failed in Ice.DomQuery test5. Result: " + kk6);
		}
	});

	// test6
	var cnt11 = item.PreviousSiblings().Where("o=>o.nodeType != 3").Count();
	if (cnt11 != 2) // count non-text nodes, different doctypes count text node as node or ignore it
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.DomQuery test6. Result: " + cnt11);
	}

	// test7
	var cnt12 = item.NextSiblings().Where("o=>o.nodeType != 3").Count();
	if (cnt12 != 6) // count non-text nodes
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.DomQuery test7. Result: " + cnt12);
	}

	// remove from dom
	bbb.RemoveFromDom();


	//***********************************************************************
	var kk1 = Ice.String.TakeFirst("moj tekst je ovo", 9, "...");
	var kk2 = Ice.String.TakeLast("moj tekst je ovo", 9, "...");

	if (kk1 != "moj te...")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.String.TakeLast, result: " + kk1);
	}

	if (kk2 != "...je ovo")
	{
		Ice.Diagnostic.Exception("Self test failed in Ice.String.TakeFirst, result: " + kk2);
	}

	var items11 = new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:solid 1px blue; padding:5px;")
.AddChildren("<div style='position:absolute;border:solid 10px red;'>ovo je moj div</div>");

	items11.ChildNodes().ApplyStyle("border:solid 1px green; padding:5px;")
.InsertBefore
(
	new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:15px solid red;").ForEach("o=>o.innerHTML='div 2'"),
	new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:15px solid red;").ForEach("o=>o.innerHTML='div 3'"),
	new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:25px solid red;").ForEach("o=>o.innerHTML='div 4'"),
	"<div>prvi div</div><div style='border:solid 18px blue;'>drugi div</div><div>treci div</div>",
	"ovo je drugi text node",
	new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:5px solid red;").ForEach("o=>o.innerHTML='div 5'")
);

	var dd00 = items11.DescendantNodes("div").ToArray();
	var dd11 = items11.DescendantNodes().WhereStyle("border-width", "o=>o==18").ToArray();
	var dd12 = items11.DescendantNodes().WhereStyle("border-width", "o=>o==15").ToArray();

	if (dd00.length != 8)
	{
		Ice.Diagnostic.Exception("Self test dd00 failed in Ice.DomQuery, result: " + dd00.length);
	}

	if (dd11.length != 1)
	{
		Ice.Diagnostic.Exception("Self test dd11 failed in Ice.DomQuery, result: " + dd11.length);
	}

	if (dd12.length != 2)
	{
		Ice.Diagnostic.Exception("Self test dd12 failed in Ice.DomQuery, result: " + dd12.length);
	}




	var ddd = new Ice.DomQuery.HtmlElement("div");
	ddd.ApplyStyle("border:solid 1px blue; padding:5px;")
	.AddChildren("<div style='position:absolute;border:solid 10px red;'>ovo je moj div</div>")
	.ChildNodes().ApplyStyle("border:solid 1px green; padding:5px;")
	.InsertBefore
	(
		new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:5px solid red;").ForEach("o=>o.innerHTML='div 2'"),
		new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:5px solid red;").ForEach("o=>o.innerHTML='div 3'"),
		new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:5px solid red;").ForEach("o=>o.innerHTML='div 4'"),
		"<div>prvi div</div><div>drugi div</div><div>treci div</div>",
		"ovo je drugi text node",
		new Ice.DomQuery.HtmlElement("div").ApplyStyle("border:5px solid red;").ForEach("o=>o.innerHTML='div 5'")
	).ParentNodes().DescendantNodes().ApplyStyle("margin:5px;").Where("o=>o.childNodes && o.childNodes.length==1");

	var html = ddd.Select(function (o) { return o.innerHTML.replace(/<[^>]+>/g, ""); }).FirstOrDefault(); // ie8 i ie7 prilikom kreiranja elemenata dodaju new line iza svakog elementa pa konacni html nije isti ko na chreomeu i ostalima

	var arr = ddd.DescendantNodes().Where("o=>o.nodeType==1").Select("o=>o.nodeValue || o.innerHTML").ToList();
	var hhtml = arr.ToStringJoined(", ");

	if (hhtml != "div 2, div 3, div 4, prvi div, drugi div, treci div, div 5, ovo je moj div")
	{
		Ice.Diagnostic.Exception("SelfTest failed in test #html1, result: " + hhtml);
	}


})();

