﻿/// <reference path="Ice.js" />

if (typeof (Ice) == "undefined") { Ice = {}; }

Ice.Event = {};

//How to get acctual char from event:
//Use "keypress" event, than read event.charCode. To get acctual char: String.fromCharCode(event.charCode).
//In firefox we have to read charCode, keyCode is 0. All other browsers has the same value for keyCode and charCode in case of "keypress" event.
//Other events like "keydown" and "keyup" gives keyCode which is not char code.

// all browsers:
// event.clientX, event.clientY: location on screen, top left is always 0,0, doesn't matter where scroll position is
// event.pageX, event.pageY: position including page scroll
// scrollHeight and scrollWidth are total size of element including part which is visible when scrolled
// scrollLeft and scrollTop are current scroll positions of current element

//#region event dumps

/* IE 9 EVENT PROPERTIES
actionURL: ""
altKey: false
altLeft: false
behaviorCookie: 0
behaviorPart: 0
bookmarks: null
boundElements: {...}
button: 0
buttonID: 0
cancelBubble: false
clientX: 271
clientY: 250
contentOverflow: false
ctrlKey: false
ctrlLeft: false
data: ""
dataFld: ""
dataTransfer: null
fromElement: null
keyCode: 0
nextPage: ""
offsetX: 70
offsetY: 49
origin: ""
propertyName: ""
qualifier: ""
reason: 0
recordset: null
repeat: false
returnValue: true
screenX: 638
screenY: 350
shiftKey: false
shiftLeft: false
source: null
srcElement: {...}
srcFilter: null
srcUrn: ""
toElement: null
type: "click"
url: ""
wheelDelta: 0
x: 271
y: 250
*/

/* IE 9 EVENT, generirano foreachom:
fromElement: null
layerX: 72
layerY: 16
toElement: null
which: 1
altKey: false
button: 0
buttons: 0
clientX: 72
clientY: 16
ctrlKey: false
metaKey: false
offsetX: 64
offsetY: 8
pageX: 72
pageY: 16
relatedTarget: null
screenX: 157
screenY: 94
shiftKey: false
x: 72
y: 16
getModifierState: function getModifierState() { [native code] } 
initMouseEvent: function initMouseEvent() { [native code] } 
detail: 1
view: [object Window]
initUIEvent: function initUIEvent() { [native code] } 
bubbles: true
cancelable: true
currentTarget: http://localhost:16244/
defaultPrevented: false
eventPhase: 2
isTrusted: true
target: http://localhost:16244/
timeStamp: 1364741512756
type: click
cancelBubble: false
srcElement: http://localhost:16244/
initEvent: function initEvent() { [native code] } 
preventDefault: function preventDefault() { [native code] } 
stopImmediatePropagation: function stopImmediatePropagation() { [native code] } 
stopPropagation: function stopPropagation() { [native code] } 
AT_TARGET: 2
BUBBLING_PHASE: 3
CAPTURING_PHASE: 1
*/

/* CHROME 24 EVENT PROPERTIES
altKey: false
bubbles: true
button: 0
cancelBubble: false
cancelable: true
charCode: 0
clientX: 305
clientY: 214
clipboardData: undefined
ctrlKey: false
currentTarget: HTMLDivElement
dataTransfer: null
defaultPrevented: false
detail: 1
eventPhase: 2
fromElement: null
keyCode: 0
layerX: 105
layerY: 14
metaKey: false
offsetX: 105
offsetY: 14
pageX: 305
pageY: 214
relatedTarget: null
returnValue: true
screenX: 310
screenY: 315
shiftKey: false
srcElement: HTMLDivElement
target: HTMLDivElement
timeStamp: 1352137743755
toElement: HTMLDivElement
type: "click"
view: Window
which: 1
x: 305
y: 214
*/

/* CHROME 19, generirano foreachom:
dataTransfer: null
toElement: http://localhost:16244/
fromElement: null
y: 13
x: 61
offsetY: 5
offsetX: 53
relatedTarget: null
button: 0
metaKey: false
altKey: false
shiftKey: false
ctrlKey: false
webkitMovementY: 0
webkitMovementX: 0
clientY: 13
clientX: 61
screenY: 118
screenX: 70
which: 1
pageY: 13
pageX: 61
layerY: 13
layerX: 61
charCode: 0
keyCode: 0
detail: 1
view: [object Window]
clipboardData: undefined
cancelBubble: false
returnValue: true
srcElement: http://localhost:16244/
defaultPrevented: false
timeStamp: 1364741717164
cancelable: true
bubbles: true
eventPhase: 2
currentTarget: http://localhost:16244/
target: http://localhost:16244/
type: click
initMouseEvent: function initMouseEvent() { [native code] }
initUIEvent: function initUIEvent() { [native code] }
stopPropagation: function stopPropagation() { [native code] }
preventDefault: function preventDefault() { [native code] }
initEvent: function initEvent() { [native code] }
stopImmediatePropagation: function stopImmediatePropagation() { [native code] }
NONE: 0
CAPTURING_PHASE: 1
AT_TARGET: 2
BUBBLING_PHASE: 3
MOUSEDOWN: 1
MOUSEUP: 2
MOUSEOVER: 4
MOUSEOUT: 8
MOUSEMOVE: 16
MOUSEDRAG: 32
CLICK: 64
DBLCLICK: 128
KEYDOWN: 256
KEYUP: 512
KEYPRESS: 1024
DRAGDROP: 2048
FOCUS: 4096
BLUR: 8192
SELECT: 16384
CHANGE: 32768
*/

/* FIREFOX 19 EVENT PROPERTIES
type: click
target: http://localhost:16244/
currentTarget: http://localhost:16244/
eventPhase: 2
bubbles: true
cancelable: true
timeStamp: 612022950
defaultPrevented: false
stopPropagation: function stopPropagation() { [native code] }
preventDefault: function preventDefault() { [native code] }
initEvent: function initEvent() { [native code] }
stopImmediatePropagation: function stopImmediatePropagation() { [native code] }
which: 1
rangeParent: [object Text]
rangeOffset: 13
pageX: 77
pageY: 21
isChar: false
screenX: 105
screenY: 107
mozMovementX: 78
mozMovementY: 107
clientX: 77
clientY: 21
ctrlKey: false
shiftKey: false
altKey: false
metaKey: false
button: 0
buttons: 0
relatedTarget: null
mozPressure: 0
mozInputSource: 1
initMouseEvent: function initMouseEvent() { [native code] }
initNSMouseEvent: function initNSMouseEvent() { [native code] }
getModifierState: function getModifierState() { [native code] }
originalTarget: http://localhost:16244/
explicitOriginalTarget: [object Text]
preventBubble: function preventBubble() { [native code] }
preventCapture: function preventCapture() { [native code] }
getPreventDefault: function getPreventDefault() { [native code] }
isTrusted: true
view: [object Window]
detail: 1
initUIEvent: function initUIEvent() { [native code] }
layerX: 77
layerY: 21
cancelBubble: false
NONE: 0
CAPTURING_PHASE: 1
AT_TARGET: 2
BUBBLING_PHASE: 3
MOUSEDOWN: 1
MOUSEUP: 2
MOUSEOVER: 4
MOUSEOUT: 8
MOUSEMOVE: 16
MOUSEDRAG: 32
CLICK: 64
DBLCLICK: 128
KEYDOWN: 256
KEYUP: 512
KEYPRESS: 1024
DRAGDROP: 2048
FOCUS: 4096
BLUR: 8192
SELECT: 16384
CHANGE: 32768
RESET: 65536
SUBMIT: 131072
SCROLL: 262144
LOAD: 524288
UNLOAD: 1048576
XFER_DONE: 2097152
ABORT: 4194304
ERROR: 8388608
LOCATE: 16777216
MOVE: 33554432
RESIZE: 67108864
FORWARD: 134217728
HELP: 268435456
BACK: 536870912
TEXT: 1073741824
ALT_MASK: 1
CONTROL_MASK: 2
SHIFT_MASK: 4
META_MASK: 8
SCROLL_PAGE_UP: -32768
SCROLL_PAGE_DOWN: 32768
MOZ_SOURCE_UNKNOWN: 0
MOZ_SOURCE_MOUSE: 1
MOZ_SOURCE_PEN: 2
MOZ_SOURCE_ERASER: 3
MOZ_SOURCE_CURSOR: 4
MOZ_SOURCE_TOUCH: 5
MOZ_SOURCE_KEYBOARD: 6
*/

/* SAFARI 5.1.7, generirano foreachom:
shiftKey: false
toElement: http://localhost:16244/
clientY: 17
y: 17
x: 74
ctrlKey: false
relatedTarget: null
clientX: 74
screenY: 97
metaKey: false
offsetX: 66
altKey: false
offsetY: 9
fromElement: null
screenX: 74
dataTransfer: null
button: 0
pageY: 17
layerY: 17
pageX: 74
charCode: 0
view: [object DOMWindow]
which: 1
keyCode: 0
detail: 1
layerX: 74
returnValue: true
timeStamp: 1364741857074
eventPhase: 2
target: http://localhost:16244/
defaultPrevented: false
srcElement: http://localhost:16244/
type: click
clipboardData: undefined
cancelable: true
currentTarget: http://localhost:16244/
bubbles: true
cancelBubble: false
initMouseEvent: function initMouseEvent() { [native code] }
initUIEvent: function initUIEvent() { [native code] }
MOUSEOUT: 8
preventDefault: function preventDefault() { [native code] }
FOCUS: 4096
CHANGE: 32768
initEvent: function initEvent() { [native code] }
MOUSEMOVE: 16
AT_TARGET: 2
stopPropagation: function stopPropagation() { [native code] }
SELECT: 16384
BLUR: 8192
KEYUP: 512
MOUSEDOWN: 1
MOUSEDRAG: 32
BUBBLING_PHASE: 3
MOUSEUP: 2
CAPTURING_PHASE: 1
MOUSEOVER: 4
CLICK: 64
DBLCLICK: 128
KEYDOWN: 256
KEYPRESS: 1024
DRAGDROP: 2048
stopImmediatePropagation: function stopImmediatePropagation() { [native code] }
*/

//#endregion

//#region keyCodes

/*
var allKeyCodes =
{
8: "Backspace",
9: "Tab",
13: "Enter",
16: "Shift",
17: "Ctrl",
18: "Alt",
19: "Pause/Break",
20: "Caps Lock",
27: "Esc",
32: "Space",
33: "Page Up",
34: "Page Down",
35: "End",
36: "Home",
37: "Left",
38: "Up",
39: "Right",
40: "Down",
45: "Insert",
46: "Delete",
48: "0",
49: "1",
50: "2",
51: "3",
52: "4",
53: "5",
54: "6",
55: "7",
56: "8",
57: "9",
65: "A",
66: "B",
67: "C",
68: "D",
69: "E",
70: "F",
71: "G",
72: "H",
73: "I",
74: "J",
75: "K",
76: "L",
77: "M",
78: "N",
79: "O",
80: "P",
81: "Q",
82: "R",
83: "S",
84: "T",
85: "U",
86: "V",
87: "W",
88: "X",
89: "Y",
90: "Z",
91: "Windows",
93: "Right Click",
96: "Numpad 0",
97: "Numpad 1",
98: "Numpad 2",
99: "Numpad 3",
100: "Numpad 4",
101: "Numpad 5",
102: "Numpad 6",
103: "Numpad 7",
104: "Numpad 8",
105: "Numpad 9",
106: "Numpad *",
107: "Numpad +",
109: "Numpad -",
110: "Numpad .",
111: "Numpad /",
112: "F1",
113: "F2",
114: "F3",
115: "F4",
116: "F5",
117: "F6",
118: "F7",
119: "F8",
120: "F9",
121: "F10",
122: "F11",
123: "F12",
144: "Num Lock",
145: "Scroll Lock",
182: "My Computer",
183: "My Calculator",
186: ";",
187: "=",
188: ",",
189: "-",
190: ".",
191: "/",
192: "`",
219: "[",
220: "\\",
221: "]",
222: "'"
};
*/

//#endregion

Ice.Event = new (function ()
{
	var __ev = this;

	var TAGNAMES = {
		'select': 'input',
		'change': 'input',
		'submit': 'form',
		'reset': 'form',
		'error': 'img',
		'load': 'img',
		'abort': 'img'
	};

	__ev.IsSupported = function (eventName)
	{
		/// <summary>
		/// Test if event name is supported by the browser.
		/// </summary>
		/// <param name="eventName" type="String">event name without 'on'</param>
		/// <returns type="Boolean"></returns>
		switch(eventName)
		{
			case "hover":
				eventName = "mouseover";
				break;
			case "hout":
				eventName = "mouseout";
				break;
		}

		var el = document.createElement(TAGNAMES[eventName] || 'div');
		eventName = 'on' + eventName;
		var isSupported = (eventName in el);
		if (!isSupported)
		{
			el.setAttribute(eventName, 'return;');
			isSupported = typeof el[eventName] == 'function';
		}
		el = null;
		return isSupported;
	};

	__ev.Attach = function (obj, eventName, callbackMethod, useCapture)
	{
		///<summary>Attach event</summary>
		///<param name="obj" type="Object">Object to attach event to</param>
		///<param name="eventName" type="String">Event name without 'on'</param>
		///<param name="callbackMethod" type="Function">Callback delegate function(event){...}</param>
		///<param name="context" type="Object">Context to bind 'this' to</param>
		///<param name="useCapture" type="Boolean">if false, inner element event has precedence</param>

		//#if VSINTELLISENSE
		if (Ice.IsVSIntellisene)
		{
			callbackMethod.call(obj || HTMLDivElement.prototype, MouseEvent.prototype);
		}
		//#endif

		useCapture = useCapture ? true : false;

		if (window.addEventListener)
		{
			obj.addEventListener(eventName, callbackMethod, useCapture);
		}
		else if (window.attachEvent)
		{
			obj.attachEvent("on" + eventName, callbackMethod, useCapture);
		}
	};

	__ev.Detach = function (obj, eventName, callbackMethod, useCapture)
	{
		///<summary>Detach event from object</summary>
		///<param name="obj" type="Object">Object to detach event from</param>
		///<param name="eventName" type="String">Event name without 'on'</param>
		///<param name="callbackMethod" type="Function" optional="true">Callback delegate</param>

		// for removal must use the same settings as listeners were set
		useCapture = useCapture ? true : false;

		if (window.addEventListener)
		{
			obj.removeEventListener(eventName, callbackMethod, useCapture);
		}
		else if (window.attachEvent)
		{
			obj.detachEvent("on" + eventName, callbackMethod);
		}
	};

	__ev.GetTarget = function (event)
	{
		///<summary>Returns event source element</summary>
		///<param name="obj" type="Object">Event object</param>

		if (window.addEventListener)
		{
			return event.target;
		}
		else if (window.attachEvent)
		{
			return event.srcElement;
		}
	};

	__ev.GetOffsetToTarget = function (event)
	{
		/// <summary>
		/// Mouse event relative positions to target element. Returns {offsetX:..., offsetY:...}. Firefox doesn't have offsetX,Y, so, take layerX, layerY.
		/// </summary>
		/// <param name="event"></param>

		return {
			offsetX: "offsetX" in event ? event.offsetX : "layerX" in event ? event.layerX : NaN,
			offsetY: "offsetY" in event ? event.offsetY : "layerY" in event ? event.layerY : NaN
		};

	};

	__ev.IsLeftMouseButton = function (event)
	{
		///<summary>Returns event source element</summary>
		///<param name="obj" type="Object">Event object</param>
		// mouse button:
		// IE : 1=left down, 2=right down, 4=middle down
		// Chrome, FF, Safari: 0=left down or up, 2=right down, 1=middle down or up

		// right button is alway 2 on all browsers

		if (window.attachEvent)
		{
			return event.button == 0 || event.button == 1; // left down = 1, left up = 0
		}
		else if (window.addEventListener)
		{
			return event.button == 0; // non ie browsers: 0 up or down
		}
	};

	__ev.IsRightMouseButton = function (event)
	{
		///<summary>Returns event source element</summary>
		///<param name="obj" type="Object">Event object</param>
		// mouse button:
		// IE: 1=left, 2=right, 4=middle
		// Chrome, FF, Safari: 0=left, 2=right, 1=middle
		if (window.attachEvent)
		{
			return event.button == 2;
		}
		else if (window.addEventListener)
		{
			return event.button == 2;
		}
	};

	__ev.IsMiddleMouseButton = function (event)
	{
		///<summary>Returns event source element</summary>
		///<param name="obj" type="Object">Event object</param>
		// mouse button:
		// IE: 1=left, 2=right, 4=middle
		// Chrome, FF, Safari: 0=left, 2=right, 1=middle
		if (window.attachEvent)
		{
			return event.button == 4;
		}
		else if (window.addEventListener)
		{
			return event.button == 1;
		}
	};

	__ev.IsAnyMouseButton = function (event)
	{
		return event && (event.button === 0 || event.button > 0);
	};

	__ev.IsEnterKey = function (event)
	{
		/// <summary>
		/// Test if key or char is ENTER.
		/// </summary>
		/// <param name="event" type="Char|Event"></param>

		return event && (event.keyCode == 10 || event.keyCode == 13); // CTRL + enter (ie = 10, ff = 13)
	};

	__ev.IsCtrlKey = function (event)
	{
		return event && event.ctrlKey ? true : false;
	};

	__ev.IsShiftKey = function (event)
	{
		return event && event.shiftKey ? true : false;
	};

	__ev.IsEscKey = function (event)
	{
		return event && event.keyCode == 27;
	};

	return __ev;

})();


