﻿// no external dependencies

Ice.Features = new (function()
{
	var __iceFeat = this;

	function IsContained(str)
	{
		if (window.navigator && navigator.mimeTypes)
		{
			for (var n = 0; n < navigator.mimeTypes.length; n++)
			{
				if ((navigator.mimeTypes[n].type + "").indexOf(str) > 0)
				{
					return true;
				}
			}
		}
		return false;
	}

	var hasFlash = 9;

	__iceFeat.HasFlash = function()
	{
		if (hasFlash == 9)
		{
			hasFlash = IsContained("x-shockwave-flash");
		}
		return hasFlash;
	};
	
	var hasSilverlight = 9;

	__iceFeat.HasSilverlight = function()
	{
		if (hasSilverlight == 9)
		{
			hasSilverlight = IsContained("x-silverlight");
		}
		return hasSilverlight;
	};

	/*
	navigator.userAgent:
	IE11: "Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; rv:11.0) like Gecko"
	IE10: "Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)"
	IE9: "Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)"
	IE8: "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)"
	IE7: "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)"

	Opera: "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/33.0.1750.154 Safari/537.36 OPR/20.0.1387.82"

	Chrome: "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/36.0.1985.125 Safari/537.36"

	Firefox: "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:30.0) Gecko/20100101 Firefox/30.0"

	Safari: "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534.57.2 (KHTML, like Gecko) Version/5.1.7 Safari/534.57.2"
	
	Intel Mac OS X 10.7

	*/

	function RemoveDots(verStr)
	{
		// eg. "20.0.1387.82", leave first dot and remove others: 20.0138782
		var arr = verStr.split(".");
		var vv = arr.shift();
		if (arr.length > 0)
		{
			vv += "." + arr.join("");
		}
		return vv;
	}

	var BrowserKindEnum = {
		Unknown: 0,
		Firefox: 1,
		Chrome: 2,
		Sarafi: 3,
		Opera: 4,
		MSIE: 5
	};

	function GetBrowserName(br)
	{
		switch(br)
		{
			case 1:
				return "Firefox";
			case 2:
				return "Chrome";
			case 3:
				return "Safari";
			case 4:
				return "Opera";
			case 5:
				return "MSIE";
			default:
				return "Unknown";
		}
	}

	function DetectBrowser()
	{
		var ua = navigator.userAgent || "";
		var br = BrowserKindEnum.Unknown;
		var vendor = navigator.vendor || "";
		var m;

		if (vendor.indexOf("Google") >= 0)
		{
			br = BrowserKindEnum.Chrome;
			m = ua.match("Chrome\\/([\\d\\.]+)");
		}
		else if (vendor.indexOf("Opera") >= 0)
		{
			br = BrowserKindEnum.Opera;
			m = ua.match("OPR|Opera\\/([\\d\\.]+)");
		}
		else if (vendor.indexOf("Apple") >= 0)
		{
			br = BrowserKindEnum.Sarafi;
			m = ua.match("Version\\/([\\d\\.]+)");
		}
		else if ((m = ua.match("MSIE ([\\d\\.]+)"))) // ie v <= 10
		{
			br = BrowserKindEnum.MSIE;
		}
		else if ("msFullscreenEnabled" in document && (m = ua.match("rv:([\\d\\.]+)"))) // ie 11 only
		{
			// ie 11 has no vendor string
			br = BrowserKindEnum.MSIE;
		}
		else if ((m = ua.match("Firefox\\/([\\d\\.]+)")))
		{
			// firefox has no vendor string
			br = BrowserKindEnum.Firefox;
		}

		var verNum = null, verStr = null;
		if (m && m[1])
		{
			verStr = m[1];
			if (verStr)
			{
				verNum = parseFloat(RemoveDots(verStr));
			}
		}

		return {
			Found: br > 0,
			Name: GetBrowserName(br),
			Kind: br,
			Version: verNum,
			VerStr: verStr
		};
	}

	var OSKindEnum = {
		Unknown: 0,
		Windows: 1,
		Macintosh: 2,
		Android: 3,
		Linux:4
	};

	function GetOSName(os)
	{
		switch(os)
		{
			case 1:
				return "Windows";
			case 2:
				return "Macintosh";
			case 3:
				return "Android";
			case 4:
				return "Linux";
			default:
				return "Unknown";

		}
	}

	function GetWindowsVersionName(ntversion)
	{
		switch(ntversion)
		{
			case 6.3:
				return "Windows 8.1";
			case 6.2:
				return "Windows 8";
			case 6.1:
				return "Windows 7";
			case 6.0:
				return "Windows Vista";
			case 5.2:
				return "Windows XP Professional x64";
			case 5.1:
				return "Windows XP";
			case 4.9:
				return "Windows ME";
			case 5.0:
				return "Windows 2000";
			case 4.1:
				return "Windows 98";
			case 4.0:
				return "Windows NT 4.0";

		}
	}

	function DetectOS()
	{
		var ua = navigator.userAgent || "";
		var os = OSKindEnum.Unknown;
		var m;

		if (ua.indexOf("Windows") > 0)
		{
			os = OSKindEnum.Windows;
			m = ua.match(new RegExp("Windows NT ([\\d\\.]+)"));
		}
		else if (ua.indexOf("Mac") > 0)
		{
			os = OSKindEnum.Macintosh;
			// Mozilla/5.0 (iPad; CPU OS 7_1_1 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D201 Safari/9537.53
			// Mozilla/5.0 (Macintosh; Intel Mac OS X 10_6_8) AppleWebKit/534.59.10 (KHTML, like Gecko) Version/5.1.9 Safari/534.59.10
			m = ua.match(new RegExp("(OS |OS X )([\\d_]+)"));
			if(m && m[2])
			{
				m = [m[0], m[2].replace(new RegExp("_", "g"), ".")];
			}
		}
		else if (ua.indexOf("Android") > 0)
		{
			// must test for Android before Linux because Android userAgent contains Linux word too
			os = OSKindEnum.Android;
			m = ua.match(new RegExp("Android ([\\d\\.]+)"));
		}
		else if (ua.indexOf("Linux") > 0)
		{
			os = OSKindEnum.Linux;
		}



		var verNum = null, verStr = null, winVersion = null;

		if (m && m[1])
		{
			verStr = m[1];
			if (verStr)
			{
				verNum = parseFloat(RemoveDots(verStr));
				if(os == OSKindEnum.Windows)
				{
					winVersion = GetWindowsVersionName(verNum);
				}
			}
		}

		return {
			Found: os > 0,
			Name: GetOSName(os),
			Kind: os,
			Version: verNum,
			VerStr: verStr,
			WinName: winVersion
		};
	}

	function BrowserHelper()
	{
		this.Browser = DetectBrowser();
	}

	BrowserHelper.prototype = new (function ()
	{
		this.Browser = null; // DetectBrowser();

		this.IsFirefox = function () { return this.Browser.Kind == BrowserKindEnum.Firefox; };
		this.IsMSIE = function () { return this.Browser.Kind == BrowserKindEnum.MSIE; };
		this.IsChrome = function () { return this.Browser.Kind == BrowserKindEnum.Chrome; };
		this.IsOpera = function () { return this.Browser.Kind == BrowserKindEnum.Opera; };
		this.IsSafari = function () { return this.Browser.Kind == BrowserKindEnum.Sarafi; };

	})();

	function OSHelper()
	{
		this.OS = DetectOS();
	}

	OSHelper.prototype = new (function ()
	{
		this.OS = null;// DetectOS();

		this.IsWindows = function () { return this.OS.Kind == OSKindEnum.Windows; };
		this.IsAndroid = function () { return this.OS.Kind == OSKindEnum.Android; };
		this.IsLinux = function () { return this.OS.Kind == OSKindEnum.Linux; };
		this.IsMacintosh = function () { return this.OS.Kind == OSKindEnum.Macintosh; };

	})();

	var _detectedBrowser;

	__iceFeat.GetBrowser = function ()
	{
		if (!_detectedBrowser)
		{
			_detectedBrowser = new BrowserHelper();
		}

		return _detectedBrowser;
	};

	var _detectedOS;

	__iceFeat.GetOS = function ()
	{
		if (!_detectedOS)
		{
			_detectedOS = new OSHelper();
		}

		return _detectedOS;
	};
	


})();
