﻿/// <reference path="Ice.js" />

if (typeof (Ice) == "undefined") { Ice = {}; }

Ice.Timer = function ()
{
	var __this = this;
	var _items = [];
	var _sleepMs = 0;
	var _timeoutId;

	__this.Abort = function ()
	{
		if (_timeoutId)
		{
			clearTimeout(_timeoutId);
			_timeoutId = null;
		}
		return __this;
	};

	__this.Start = function (sleepMs)
	{
		/// <summary>
		/// Start new timeout. Abort previous if exists.
		/// </summary>
		/// <param name="sleepMs"></param>
		__this.Abort();
		_sleepMs = sleepMs;
		_timeoutId = setTimeout(function ()
		{
			for (var n = 0; n < _items.length; n++)
			{
				_items[n]();
			}
		}, _sleepMs);
		return __this;
	};

	__this.OnTimeout = function (func)
	{
		/// <summary>
		/// MulticastDelegate. Add callback function(s) to be executed on timeout.
		/// </summary>
		/// <param name="func">function(sender){...}, this == sender</param>

		//#if VSINTELLISENSE
		if (Ice.IsVSIntellisene) { func.call(__this, {}); }
		//#endif

		_items.push(func);
		return __this;
	};
};


