﻿//*******************************************************************
// NO EXTERNAL DEPENDENCIES
//*******************************************************************

if (typeof (Ice) == "undefined") { Ice = {}; }

Ice.Type = new (function ()
{
	var __ice = this;

	__ice.IsBoolean = function (obj)
	{
		return typeof (obj) == "boolean";
	};

	__ice.IsNumber = function (obj)
	{
		//return !isNaN(parseFloat(obj)) && isFinite(obj); // from jQuery
		// if obj already is nuber, it may be parsed with parseFloat again
		return typeof(obj) == "number" && !isNaN(obj) && isFinite(obj);//// && (parseFloat(obj) + "") == (obj + ""); // make sure it is not NaN
	};

	__ice.IsString = function (obj)
	{
		return typeof (obj) == "string";
	};

	__ice.IsArray = function (obj)
	{
		/// <summary>
		/// array or dom array
		/// </summary>
		/// <param name="obj"></param>

		// if obj is string, typeof(obj) == "string", everything else is the same as in array
		// dom array has length only, no push, pop, etc.
		return obj && typeof (obj) == "object" && __ice.IsNumber(obj.length) && (obj.length > 0 || obj.length == 0);
	};

	__ice.IsFunction = function (obj)
	{
		return typeof (obj) == "function";
	};

	__ice.IsNullOrUndefined = function (obj1, obj2, obj3, etc)
	{
		///<summary>returns true if any of objects is null or undefined or NaN</summary>
		///<param name="obj1" type="Object"></param>
		for (var n = 0; n < arguments.length; n++)
		{
			var tmp = arguments[n];
			if (tmp === null || typeof (tmp) == "undefined")
			{
				return true;
			}
			else if (typeof (tmp) == "number" && isNaN(tmp))
			{
				return true;
			}
		}
		return false;
	};

	__ice.Coalesce = function (obj1, obj2, obj3, etc)
	{
		/// <summary>
		/// Returns first obj which not null and not undefined and not NaN if it't type is number
		/// </summary>
		/// <param name="obj1"></param>
		/// <param name="obj2"></param>
		/// <param name="obj3"></param>
		/// <param name="etc"></param>
		var tmp = null;
		for (var n = 0; n < arguments.length; n++)
		{
			tmp = arguments[n];
			if (!Ice.Type.IsNullOrUndefined(tmp))
			{
				return tmp;
			}
		}
		// don't return anything, this way method will return undefined
	};


})();
