﻿
/* example

intellisense.addEventListener('statementcompletion', function (e)
{
	// Prints out statement completion info: Either (1) the member 
	// list, if the trigger character was typed, or (2) the 
	// statement completion identifiers.
	// e.target represents the object left of the trigger character.
	intellisense.logMessage(
        e.target ? 'member list requested, target: ' + e.targetName : 'statement completion for current scope requested');

	// Prints out all statement completion items.
	e.items.forEach(function (item)
	{
		intellisense.logMessage('[completion item] ' + item.name + ', kind:' + item.kind + ', scope:' + item.scope + ', value:' + item.value);
	});
});

intellisense.addEventListener('statementcompletion', function (e) {
    e.items.forEach(function (item) {
        // Detect a namespace by using the _isNamespace flag.
        if (item.value && item.value._isNamespace) {
            item.glyph = 'vs:GlyphGroupNamespace';
            }

        if (item.parentObject && item.parentObject._isNamespace) {
            // The item is a member of a namespace. 

            // All constructor functions that are part of a namespace 
            // are considered classes. 
            // A constructor function starts with
            // an uppercase letter by convention.  
            if (typeof item.value == 'function' && (item.name[0].toUpperCase() 
                == item.name[0])) {
                item.glyph = 'vs:GlyphGroupClass';
            }

            // Detect an enumeration by using the _isEnum flag.
            if (item.value && item.value._isEnum) {
                item.glyph = 'vs:GlyphGroupEnum';
            }
        }
    });
});

intellisense.addEventListener('statementcompletionhint', function (e) {
    if (e.completionItem.value) {
        if (e.completionItem.value._isNamespace) {
            e.symbolHelp.symbolDisplayType = 'Namespace';
        }
        if (e.completionItem.value._isEnum) {
            e.symbolHelp.symbolDisplayType = 'Enum';
        }
    }
});

*/
