﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.IO;

namespace Ice.Web.Script.Services
{
	class IceJavascriptException : Exception
	{
		public IceJavascriptException(string msg)
			: base(msg)
		{ }

		public IceJavascriptException(string msg, Exception ex)
			: base(msg, ex)
		{ }
	}

	class IceElmahErrorHandler : IHttpHandler
	{
		/* to make this to work, disable form validation in .net 4.0 by adding next config to web config:
		 * section has to be added into web.config as sibbling to appSettings or connectionStrings or system.webServer
	<!--disable form validation in .net 4.0-->
	<location path="ICE-EX-IceRes.axd">
		<system.web>
			<pages validateRequest="false" />
			<httpRuntime requestValidationMode="2.0" />
		</system.web>
	</location>
	
	*/

		public void ProcessRequest(HttpContext context)
		{
			if (!IceWebSettings.WriteIceWebElmahLog)
			{
				return;
			}


			try
			{
				string title = context.Request["title"];
				if (string.IsNullOrEmpty(title))
				{
					title = "Ice.Error";
				}
				
				string str = new StreamReader(context.Request.InputStream).ReadToEnd();
				str = HttpUtility.UrlDecode(str);
				object ccc = Ice.Elmah.ErrorLog.Default;
				Ice.Elmah.ErrorLog.WriteLog(new IceJavascriptException(str, new IceJavascriptException(title)), context); // if context not set, elamah will use current context - the same thing
			}
			catch
			{
				// elmah is not available
			}
		}

		public bool IsReusable
		{
			get
			{
				return false;
			}
		}

	}
}
