﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace System.Web.Services
{
	[AttributeUsage(AttributeTargets.Method)]
	public sealed class IceWebMethodAttribute : Attribute
	{
		/// <summary>
		/// If true, ajax synchronous request.
		/// </summary>
		public bool Synchronous { get; set; }

		/// <summary>
		/// Current method ajax request timeout in ms. Default is 0 meaning will use global timeout value.
		/// </summary>
		public int Timeout { get; set; }

		/// <summary>
		/// If true, use HttpSessionState.
		/// </summary>
		public bool SessionState { get; set; }
	}
}
