﻿using System;
using System.Web;
using System.Reflection;
using System.Text;
using System.Linq;
using System.Web.SessionState;

namespace Ice.Web.Script.Services
{
	class WsjsTypeHandler : IHttpHandler // , IRequiresSessionState // include this interface to enable session
	{
		public void ProcessRequest(HttpContext context)
		{
			Ice.Web.QueryStringHelper qq = new Ice.Web.QueryStringHelper(context.Request.RawUrl);

			string typeName = qq.GetValue<string>("c");
			try { typeName = Ice.Converter.IceBase64.DecodeBase64StringToString(typeName); }
			catch { }

			string currentLocation = qq.GetValue<string>("iceloc");
			try { currentLocation = Ice.Converter.IceBase64.DecodeBase64StringToString(currentLocation); }
			catch { }

			string methodName = qq.GetValue<string>("icewm");

			long timestamp = 0;
			long.TryParse(qq.GetValue<string>("icevr"), out timestamp); // samo brojka jer se u Ice.Net.js repalcea ovaj parametar i prebacuje na kraj url-a

			new IceAjaxHandler().ProcessRequest(context, typeName, timestamp, methodName, currentLocation);
		}

		public bool IsReusable
		{
			get
			{
				return false;
			}
		}

		public static string CreateQstr(string baseUrl, string type, long timestamp)
		{
			// PAZI: u Ice.Net.js prije posta ili geta na server, verzion parameter se prebacuje na kraj url-a jer neki browseri salju skraceni url pa nek im vrati reload command

			return baseUrl + "?icewm=__ice_web_method_name__&c=" + Ice.Converter.IceBase64.ToBase64String(type) + "&icess=__ice_ss__&iceloc=__ice_current_url__" + "&icevr=" + timestamp; // icewm= is method name, it has to be created here, so in JS only method name is appended
		}
	}

}
