﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ice.Web.Extensions;
using System.IO;
using System.Drawing;
using Ice.Colorspace;

namespace Ice.Web.UI.Css
{
	public class IceCssTest
	{
		private IceCssClass ClassicButton(int width, int height)
		{
			return new IceCssClass().ApplyValue("width", width + "px").ApplyValue("height", height + "px");
		}

		public void RenderCss()
		{
			IceStyleSheet sheet = new IceStyleSheet().AddCss(@"@font-face 
{ 
	font-family:'Moj-Kvart'; 
	src:url('fonts/moj-kvart_icon.eot'); 
	src:url('fonts/moj-kvart_icon.eot?#iefix') format('embedded-opentype'),url('fonts/moj-kvart_icon.woff') format('woff'),url('fonts/moj-kvart_icon.ttf') format('truetype'),url('fonts/moj-kvart_icon.svg#Moj-Kvart') format('svg'); 
	font-weight:normal; 
	font-style:normal; 
}");

			IceCssClass template1 = new IceCssClass()
				.AddToStyleSheet(sheet)
				.ApplyStyle(@"
border:solid 1px red;
color:red;
border-bottom:1px solid blue;	
");

			IceCssClass template2 = new IceCssClass(".name div, #first .moj.nesto")
				.AddToStyleSheet(sheet)
				.ApplyStyle(@"
width:500px;
height:100px;
");
			new IcePlainCssText("/*ovo je moj komentar*/").AddToStyleSheet(sheet);

			IceCssClass template3 = new IceCssClass("#test1")
				.AddToStyleSheet(sheet)
				.ApplyClass(template1)
				.Transition()
				.Opacity(50)
				.Background("red", "/any.gif", "no-repeat", "center", "center")
				.ApplyClass(template2)
				.ApplyStyle(@"
background-color:red;
border-bottom:none;
")
				.ApplyClass(ClassicButton(10, 10));

			template3 = template3.ApplyValue("border", "none");

			IceCssClass template4 = new IceCssClass("#first .moj.nesto")
			.AddToStyleSheet(sheet)
			.ApplyStyle(@"
	width:350px;
");

			template4.Transition();

			IceMediaRule rule = new IceMediaRule("screen and (width-max:900px)").Add(template3, template4.ApplyClass(template1))
				.AddToStyleSheet(sheet)
				.Add(new IcePlainCssText("/*drugi komentar*/"));

			Color borderColor = ColorExtensions.FromHtml("#affaab");
			Color backColor = borderColor.ChangeLightnesPercent(-50).ChangeSaturationPercent(-50);

			template4.ApplyValue("color1", borderColor.ToHtml());
			template4.ApplyValue("color2", backColor.ToHtml());

			new IceMediaScreenRule(p=>p.Width > 100 && p.Width <= 500 && p.Height > 100).AddToStyleSheet(sheet)
				.Add(new IcePlainCssText("/*ovo je unutra*/"));

			sheet.NewMediaScreenRule(s => s.Width > 100 && s.Width < 1000, m=>m.NewCssClass(".fadsg", c=>c.ApplyStyle("dime:234px")));

			sheet.NewCssClass(".nasljedeni    #dva tri .jedan, #moj .novi     div", ".fads5g, .fadsg", c => c.ApplyStyle("nasljedeni:prosjek"));
			sheet.NewCssClass(".klasa1", c => c.ApplyStyle("potreban-prosje:2343252zcmd"));



			////File.WriteAllText("d:\\tt.css", sheet.ToCssString());


		}

	}
}
