﻿
Ice.Web.UI.WebControls.IceHorizontalSplit = {};

Ice.Web.UI.WebControls.IceHorizontalSplit.Setup = function (splitBarId, frameColor, hoverColor, topMinHeight, topMaxHeight, bottomMinHeight, bottomMaxHeight)
{
	var splitEL = $$ice("#" + splitBarId).First();
	if (splitEL.__iceHorizontalSplit)
	{
		return; // prevent multiple managers after postback
	}
	splitEL.__iceHorizontalSplit = this;

	var topEL = $$ice(splitEL).PreviousSiblings("div").First();
	var bottomEL = $$ice(splitEL).NextSiblings("div").First();
	var toTop = splitEL.className.indexOf("toTop") >= 0 ? true : splitEL.className.indexOf("toBottom") >= 0 ? false : Ice.Diagnostic.Exception("IceHorizontalSplit: direction unknown");
	var splitDim = $$ice(splitEL).SelectStyleMap(["height"]).First();
	var originalCursor = $$ice(splitEL).SelectStyle("cursor").First();
	var isCollapsed;
	var uncollpasedDim;
	var state;

	function SetHeight(height)
	{
		if (toTop)
		{
			$$ice(topEL).ApplyStyle("height", height);
			$$ice(splitEL).ApplyStyle("top", height);
			$$ice(bottomEL).ApplyStyle("top", height + splitDim.height);
		}
		else
		{
			$$ice(bottomEL).ApplyStyle("height", height);
			$$ice(splitEL).ApplyStyle("bottom", height);
			$$ice(topEL).ApplyStyle("bottom", height + splitDim.height);
		}
	}

	$$ice(splitEL)
	.OnHover(function (sender, ev)
	{
		if (!isCollapsed)
		{
			$$ice(this).ApplyStyle("cursor", "n-resize").ApplyStyle("background-color", hoverColor);
		}
	}
	, function ()
	{
		if (!state)
		{
			$$ice(this).ApplyStyle("cursor", originalCursor).ApplyStyle("background-color", frameColor);
		}
	})
	.OnMouseDown(function (sender, ev)
	{
		if (!isCollapsed)
		{
			$$ice(document.body).SetSelectable(false);
			state = {};
			state.startPageY = ev.pageY;
			state.topDim = $$ice(topEL).SelectStyleMap(["height"]).First();
			state.bottomDim = $$ice(bottomEL).SelectStyleMap(["height"]).First();
		}
	});

	$$ice(document)
	.OnMouseUp(function (sender, ev)
	{
		$$ice(splitEL).ApplyStyle("cursor", originalCursor).ApplyStyle("background-color", frameColor);
		$$ice(document.body).SetSelectable(true);
		state = false;
	})
	.OnMouseMove(function (sender, ev)
	{
		if (state)
		{
			var deltaY = ev.pageY - state.startPageY;
			var newTopHeight = state.topDim.height + deltaY;
			var newBottomHeight = state.bottomDim.height - deltaY;

			if (toTop)
			{
				if (newTopHeight < topMinHeight)
				{
					newTopHeight = topMinHeight;
				}
				if (newTopHeight > topMaxHeight)
				{
					newTopHeight = topMaxHeight;
				}
			}
			else // toBottom
			{
				if (newBottomHeight < bottomMinHeight)
				{
					newBottomHeight = bottomMinHeight;
				}
				if (newBottomHeight > bottomMaxHeight)
				{
					newBottomHeight = bottomMaxHeight;
				}
			}

			if (newTopHeight >= topMinHeight && newTopHeight <= topMaxHeight && newTopHeight >= bottomMinHeight && newTopHeight <= bottomMaxHeight)
			{
				if (toTop)
				{
					SetHeight(newTopHeight);
				}
				else
				{
					SetHeight(newBottomHeight);
				}
			}
		}
	});

};
