﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using Ice.Web.Extensions;
using System.Web.UI.WebControls;
using Ice.Web.Resources;

namespace Ice.Web.UI.WebControls
{
	public class IceImageButton:System.Web.UI.WebControls.ImageButton
	{
		public string HoverImageUrl { get; set; }

		public IconEnum Icon { get { return (IconEnum)(this.ViewState["_icon"] as int?).GetValueOrDefault(); } set { this.ViewState["_icon"] = (int)value; } }
		public IconEnum HoverIcon { get { return (IconEnum)(this.ViewState["_hicon"] as int?).GetValueOrDefault(); } set { this.ViewState["_hicon"] = (int)value; } }
		public string HoverStyle { get { return this.ViewState["_hs"] as string; } set { this.ViewState["_hs"] = value; } }
		public string HoverCssClass { get { return this.ViewState["_hc"] as string; } set { this.ViewState["_hc"] = value; } }

		/// <summary>
		/// Confirmation text.
		/// </summary>
		public string Confirm { get; set; }

		public override void RenderControl(HtmlTextWriter writer)
		{
			if (!this.Visible)
			{
				return;
			}

			if (this.Icon != IconEnum.None)
			{
				this.ImageUrl = IceScriptManager.CreateUrl(this.Icon);
			}

			if (this.HoverIcon != IconEnum.None)
			{
				this.HoverImageUrl = IceScriptManager.CreateUrl(this.HoverIcon);
			}

			if (!string.IsNullOrEmpty(this.Confirm))
			{
				this.OnClientClick = "if(!confirm('" + this.Confirm + "')){return false;} ";
			}

			if (!string.IsNullOrEmpty(this.HoverImageUrl))
			{
				this.AppendJsEvent(JavascriptEventEnum.MouseOver, "this.src='" + this.HoverImageUrl + "';");
				this.AppendJsEvent(JavascriptEventEnum.MouseOut, "this.src='" + this.ImageUrl + "';");
			}

			if (!string.IsNullOrEmpty(this.HoverStyle))
			{
				this.AppendJsEvent(JavascriptEventEnum.MouseOver, "this.style.cssText+='" + this.HoverStyle + "';");
				this.AppendJsEvent(JavascriptEventEnum.MouseOut, "this.style.cssText+='" + this.Style.Value + "';");
			}

			if (!string.IsNullOrEmpty(this.HoverCssClass))
			{
				this.AppendJsEvent(JavascriptEventEnum.MouseOver, "this.className='" + this.HoverCssClass + "';");
				this.AppendJsEvent(JavascriptEventEnum.MouseOut, "this.className='" + this.CssClass + "';");
			}

			base.RenderControl(writer);
		}

	}
}
