﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using Ice.Web.Extensions;
using Ice.Web.Resources;

namespace Ice.Web.UI.WebControls
{
	[ParseChildren(true)]
	public class IceResource : System.Web.UI.Control
	{
		public IconEnum Icon { get { return (IconEnum)(this.ViewState["_icon"] as int?).GetValueOrDefault(); } set { this.ViewState["_icon"] = (int)value; } }
		public string Filename { get; set; }

		public string GetUrl()
		{
			if(Icon > 0 && !string.IsNullOrEmpty(this.Filename))
			{
				throw new ArgumentException("Can not specifiy Icon and Filename at the same time");
			}
			return IceScriptManager.CreateUrl(this.Icon, this.Filename);
		}

		public override void RenderControl(HtmlTextWriter writer)
		{
			if (!this.Visible)
			{
				return;
			}

			this.Controls.Add(new LiteralControl(this.GetUrl()));

			base.RenderControl(writer);
		}
	}


}
