﻿
Ice.Web.UI.WebControls.IceTextWatermark = new (function ()
{
	function WatermarkInitialize(targetEl, wmClass, emptyText, errorClass, isError, visibleMask, formatMask)
	{
		var el = targetEl;
		emptyText = emptyText || el.title;
		var isSelect = el.tagName.toLowerCase().indexOf("select") >= 0;
		var errorValue;
		var wmset;
		var type = el.type;
		////	var className = el.className;
		////	var initialValue = el.value;

		var rightToLeft = formatMask && formatMask.indexOf("<") >= 0; // eg. <ddd.ddd.ddd,dd kn, currency and chars are filled from right to left (<)
		// var visibleMask = visibleMaskOrig; // mask visible to user, eg: __.__.____. __:__
		// format mask specifies type or char: d, w, a. _ is considered as digit. If formatMask is not defined, visibleMask is used, _ is considered as digit.
		// format mask has to be defined because all calculations are made with it, visibleMask is just to guide user
		// format mask defined max length of chars entered
		formatMask = formatMask || visibleMask; // formating mask: dd.dd.dddd. dd:dd, where d: digit, a: letter, w: digit or letter. Eg. price: ddd.ddd.ddd.ddd.ddd.ddd,dd while mask can be shorter just to guide user: _.___,__

		if (isSelect)
		{
			// in strict mode functions inside function has to be defined as variables var funcName = function(...){...};
			var OnChangeCallback = function ()
			{
				var val = el.options[el.selectedIndex].value;
				if (val)
				{
					Ice.Utility.Dom.RemoveClass(el, wmClass);
				}
				else
				{
					Ice.Utility.Dom.AddClass(el, wmClass);
				}

				if (errorClass)
				{
					if (errorValue == el.value)
					{
						Ice.Utility.Dom.AddClass(el, errorClass);
					}
					else
					{
						Ice.Utility.Dom.RemoveClass(el, errorClass);
					}
				}
			};

			if (isError && errorClass)
			{
				errorValue = el.options[el.selectedIndex].value;
			}

			$$ice(el).OnChange(OnChangeCallback);

			OnChangeCallback();
		}
		else
		{
			if (isError && errorClass)
			{
				errorValue = el.value;
			}

			// TextBox
			var OnFocusCallback = function ()
			{
				if (wmset)
				{
					wmset = false;
					el.value = "";
					try
					{
						el.type = type;
					}
					catch (ex)
					{
					}
					Ice.Utility.Dom.RemoveClass(el, wmClass);
				}

				if (visibleMask)
				{
					if (!el.value)
					{
						el.value = visibleMask;
						Ice.Utility.Caret.SetCaret(el, 0);
					}
					else
					{
						// move caret to end of text
						return KeyPressHandler.call(el, el, { moveCaretToEnd: true });
					}
				}
			};

			var OnBlurCallback = function ()
			{
				if (visibleMask)
				{
					if (el.value == visibleMask)
					{
						el.value = "";
					}
				}

				if (errorClass)
				{
					if (errorValue == el.value)
					{
						Ice.Utility.Dom.AddClass(el, errorClass);
					}
					else
					{
						Ice.Utility.Dom.RemoveClass(el, errorClass);
					}
				}

				if (!el.value || el.value == emptyText)
				{
					wmset = true;
					el.value = emptyText;
					Ice.Utility.Dom.AddClass(el, wmClass);
					try
					{
						el.type = "text";
					}
					catch (ex)
					{
					}
				}
			};

			var letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZĐŠŽĆČžćčđš";
			letters += letters.toLowerCase();

			var digits = "0123456789";

			var IscCharOfType = function (position, ch)
			{
				var tt;
				if (rightToLeft)
				{
					tt = acceptesKindList.Reverse().ElementAt(0);
				}
				else
				{
					tt = acceptesKindList.ElementAt(position);
				}

				switch (tt)
				{
					case "_": // treat as digit format
					case "d": // digit
						return digits.indexOf(ch) >= 0;
					case "a": // alpha
						return letters.indexOf(ch) >= 0;
					default: // w, or anything
						return true;
				}
			};

			var IsCharAccepted = function (ch)
			{
				return (enteredChars.length) < acceptesKindList.Count() && IscCharOfType(enteredChars.length, ch);
			};

			var FormatWithMask = function ()
			{
				var formated = "";

				var arr = new Ice.List(enteredChars).Take(expectedCount)
					.Case(rightToLeft, function () { return this.Reverse(); })
					.ToArray();

				var maskArr = new Ice.List(visibleMask)
					.Case(rightToLeft, function () { return this.Reverse(); })
					.ToArray();

				var formatArr = new Ice.List(formatMask)
					.Case(rightToLeft, function () { return this.Reverse(); })
					.ToArray();

				new Ice.List(formatArr).ForEach(function (o)
				{
					var m1 = maskArr.shift();

					if ("dwa_".indexOf(o) >= 0 && arr.length > 0)
					{
						formated += arr.shift();
					}
					else if (arr.length > 0)
					{
						formated += o;
					}
					else if (m1)
					{
						formated += m1;
					}
				});

				if (rightToLeft)
				{
					return new Ice.List(formated).Reverse().ToStringJoined();
				}
				else
				{
					return formated;
				}
			};

			var KeyDownHandler = function (sender, ev)
			{
				if (ev.keyCode == 46) // "delete"
				{
					enteredChars = "";
					KeyPressHandler.call(this, sender, { moveCaretToEnd: true });
					return false;
				}
				else if (ev.keyCode == 8) // <-- "backspace"
				{
					if (enteredChars.length > 0)
					{
						// remove last char
						enteredChars = enteredChars.substr(0, enteredChars.length - 1);
						KeyPressHandler.call(this, sender, { moveCaretToEnd: true });
					}
					return false;
				}
			};

			var KeyPressHandler = function (sender, ev)
			{
				var el = this;
				var ch = String.fromCharCode(ev.charCode);

				if (ev.moveCaretToEnd) //
				{
					// move caret to the end of entered chars, return true
				}
				else if (IsCharAccepted(ch))
				{
					enteredChars += ch;
				}
				else
				{
					// non-acceptable char
					return false;
				}

				el.value = FormatWithMask();

				// move caret to the end of text
				var pos = rightToLeft ? el.value.length - carretPosFromRight : el.value.indexOf('_');
				if (pos < 0)
				{
					pos = el.value.length;
				}
				Ice.Utility.Caret.SetCaret(el, pos);

				return false;
			};

			// format mask
			var acceptesKindList = new Ice.List();
			var expectedCount = 0;
			var enteredChars = "";
			var carretPosFromRight = 0;

			if (formatMask)
			{
				acceptesKindList = new Ice.List(formatMask).Where("o=>'dwa_'.indexOf(o) >= 0").ToList();
				expectedCount = acceptesKindList.Count();
				if (rightToLeft)
				{
					carretPosFromRight = new Ice.List(formatMask).Reverse().Select("(o,n)=>new {item:o, index:n}").Where("o=>'dwa_'.indexOf(o.item) >= 0").Select("o=>o.index").First();
				}

				enteredChars = new Ice.List(el.value).Where(function (o)
				{
					// get already existing chars in the text box (after page get or postback)
					return IsCharAccepted(o);
				}).ToStringJoined();

				$$ice(el)
				.OnMouseDown(function (sender, ev)
				{
					return KeyPressHandler.call(this, sender, { moveCaretToEnd: true });
				})
				.OnKeyPress(KeyPressHandler)
				.OnKeyDown(KeyDownHandler);

			}

			$$ice(el).OnFocus(OnFocusCallback).OnBlur(OnBlurCallback);

			OnBlurCallback();

		}
	}

	this.Setup = function (targetSelector, wmClass, emptyText, errorClass, isError, visibleMask, formatMask)
	{
		$$ice(targetSelector).ForEach(function (el)
		{
			if(!el.__iceTextWatermark)
			{
				el.__iceTextWatermark = true;
				WatermarkInitialize(el, wmClass, emptyText, errorClass, isError, visibleMask, formatMask);
			}
		});
	};

})();




