﻿
Ice.Web.UI.WebControls.ToolTip = new (function ()
{
	var arrHPos = [{ Pos: "left" }, { Pos: "center" }, { Pos: "right" }]; // left and right are reversed
	var arrVPos = [{ Pos: "top" }, { Pos: "middle" }, { Pos: "bottom" }]; // top and bottom are reversed
	var arrMargin = 10;
	var distance = 1.5;
	var defaultArrSize = 8;

	var pos = [
		{ Tip: "top", Arr: arrHPos },
		{ Tip: "bottom", Arr: arrHPos },
		{ Tip: "left", Arr: arrVPos },
		{ Tip: "right", Arr: arrVPos}
	];

	function GetArrHPos(pos, tipWidth, anchorWidth, arrW)
	{
		switch(pos)
		{
			case "right":
				return anchorWidth / 2 - arrMargin - arrW / 2;
			case "center":
				return -tipWidth / 2 + anchorWidth / 2;
			case "left":
				return -tipWidth + anchorWidth / 2 + arrMargin + arrW / 2;
		}
	}

	function GetArrVPos(pos, tipHeight, anchorHeight, arrH)
	{
		switch (pos)
		{
			case "bottom":
				return -arrMargin - arrH / 2 + anchorHeight / 2;
			case "middle":
				return -tipHeight / 2 + anchorHeight / 2;
			case "top":
				return -tipHeight + anchorHeight / 2 + arrMargin + arrH / 2;
		}
	}

	function CreateToolTip(iceTip, anchorEl)
	{
		/// <summary>
		/// 
		/// </summary>
		/// <param name="iceTip" type="Ice.DomQuery"></param>
		/// <param name="anchorEl" type="HtmlElement"></param>

		var tipDimensions = iceTip.SelectStyleMap(["offsetWidth", "offsetHeight"]).First();
		var cls = iceTip.SelectClassNames().Where("o=>o.StartsWith('pos-')").FirstOrDefault();
		if (cls)
		{
			var anchorDimensions = $$ice(anchorEl).SelectStyleMap(["offsetWidth", "offsetHeight"]).First();

			var arr = cls.ReplaceAll("pos-", "").split("-");
			var first = pos.AsEnumerable().Where(function (o) { return o.Tip == arr[0]; }).First();
			var sec = first.Arr.AsEnumerable().Where(function (o) { return o.Pos == arr[1]; }).First();

			var top = 0;
			var left = 0;
			var arrTop;
			var arrLeft;
			var arrBottom;
			var arrRight;
			var arrW;
			var arrH;

			var divArrInner = new Ice.DomQuery.HtmlElement("div").ApplyStyle("position:absolute;");
			var divArrow = new Ice.DomQuery.HtmlElement("div").AddClass("tipArrow").ApplyStyle("position:absolute").AddChildren(divArrInner);

			$$ice(iceTip).AddChildren(divArrow);
			var tipInnerColor = iceTip.SelectStyle("background-color").First();
			var arrColor = iceTip.SelectStyle("border-top-color").First();
			var borderWidth = iceTip.SelectStyle("border-top-width").First();
			var arrSize = defaultArrSize + borderWidth;

			switch (first.Tip)
			{
				case "top":
					divArrInner.ApplyStyle("	border-top: " + arrSize + "px solid " + tipInnerColor + ";border-left: " + arrSize + "px solid transparent;	border-right: " + arrSize + "px solid transparent;");
					divArrInner.ApplyStyleMap({ top: -arrSize - borderWidth, left: -arrSize });
					divArrow = divArrow.ApplyStyle("	border-top: " + arrSize + "px solid " + arrColor + ";border-left: " + arrSize + "px solid transparent;	border-right: " + arrSize + "px solid transparent;").First();
					arrW = divArrow.offsetWidth;
					arrH = divArrow.offsetHeight;
					top = (-1) * (tipDimensions.offsetHeight + arrH * distance);
					left = GetArrHPos(sec.Pos, tipDimensions.offsetWidth, anchorDimensions.offsetWidth, arrW);
					arrBottom = (-1) * arrH;
					arrLeft = (-1) * left + anchorDimensions.offsetWidth / 2 - arrW / 2;
					break;
				case "bottom":
					divArrInner.ApplyStyle("	border-bottom: " + arrSize + "px solid " + tipInnerColor + ";border-left: " + arrSize + "px solid transparent;	border-right: " + arrSize + "px solid transparent;");
					divArrInner.ApplyStyleMap({ top: borderWidth, left: -arrSize });
					divArrow = divArrow.ApplyStyle("	border-bottom: " + arrSize + "px solid " + arrColor + ";border-left: " + arrSize + "px solid transparent;	border-right: " + arrSize + "px solid transparent;").First();
					arrW = divArrow.offsetWidth;
					arrH = divArrow.offsetHeight;
					top = anchorDimensions.offsetHeight + arrH * distance;
					left = GetArrHPos(sec.Pos, tipDimensions.offsetWidth, anchorDimensions.offsetWidth, arrW);
					arrTop = (-1) * arrH;
					arrLeft = (-1) * left + anchorDimensions.offsetWidth / 2 - arrW / 2;
					break;
				case "left":
					divArrInner.ApplyStyle("	border-left: " + arrSize + "px solid " + tipInnerColor + ";border-top: " + arrSize + "px solid transparent;	border-bottom: " + arrSize + "px solid transparent;");
					divArrInner.ApplyStyleMap({ top: -arrSize, left: -arrSize - borderWidth });
					divArrow = divArrow.ApplyStyle("	border-left: " + arrSize + "px solid " + arrColor + ";border-top: " + arrSize + "px solid transparent;	border-bottom: " + arrSize + "px solid transparent;").First();
					arrW = divArrow.offsetWidth;
					arrH = divArrow.offsetHeight;
					left = (-1) * (tipDimensions.offsetWidth + arrW * distance);
					top = GetArrVPos(sec.Pos, tipDimensions.offsetHeight, anchorDimensions.offsetHeight, arrH);
					arrTop = (-1 * top - arrH / 2 + anchorDimensions.offsetHeight / 2);
					arrRight = -1 * arrW;
					break;
				case "right":
					divArrInner.ApplyStyle("	border-right: " + arrSize + "px solid " + tipInnerColor + ";border-top: " + arrSize + "px solid transparent;	border-bottom: " + arrSize + "px solid transparent;");
					divArrInner.ApplyStyleMap({ top: -arrSize, left: +borderWidth });
					divArrow = divArrow.ApplyStyle("	border-right: " + arrSize + "px solid " + arrColor + ";border-top: " + arrSize + "px solid transparent;	border-bottom: " + arrSize + "px solid transparent;").First();
					arrW = divArrow.offsetWidth;
					arrH = divArrow.offsetHeight;
					left = anchorDimensions.offsetWidth + arrW * distance;
					top = GetArrVPos(sec.Pos, tipDimensions.offsetHeight, anchorDimensions.offsetHeight, arrH);
					arrTop = (-1 * top - arrH / 2 + anchorDimensions.offsetHeight / 2);
					arrLeft = -1 * arrW;
					break;
			}

			
			var style = "";
			if (arrTop)
			{
				style += "top:" + arrTop + "px;";
			}
			if (arrBottom)
			{
				style += "bottom:" + arrBottom + "px;";
			}
			if (arrLeft)
			{
				style += "left:" + arrLeft + "px;";
			}
			if (arrRight)
			{
				style += "right:" + arrRight + "px;";
			}
			$$ice(divArrow).ApplyStyle(style);
		}
		iceTip.ApplyStyle("top", top).ApplyStyle("left", left);
	}

	function IceToolTip(anchorEl)
	{
		/// <summary>
		/// constructor
		/// </summary>
		
		var _animator;
		var iceTip = $$ice(anchorEl).Query(">div.iceTip:first").SetOpacity(0).ToDomQuery();
		var ttCreated;

		$$ice(anchorEl).OnHover(function (sender, ev)
		{
			// show tip
			if (_animator){_animator.Abort();}
			_animator = iceTip.ApplyStyle("position:absolute;display:block;")
				.ToAnimator({ "opacity": 100 }).Duration(200)
				.OnStart(function (animator)
				{
					if (!ttCreated)
					{
						ttCreated = true;
						CreateToolTip(iceTip, anchorEl);
					}
				}).Start();
			
		}, function (sender, ev)
		{
			// hide tip
			if (_animator) { _animator.Abort(); }
			_animator = iceTip.ToAnimator({ "opacity": 0 }).Duration(500)
			.OnComplete(function (animator)
			{
				animator.ToDomQuery().ApplyStyle("display:none");
			}).Start();
		});
	}

	this.Setup = function (anchorSelector)
	{
		////Ice.Diagnostic.WriteLine("setup tooltip: " + anchorSelector);

		$$ice(anchorSelector).Where("o=>!o.__iceToolTip").ForEach(function (anchorEl)
		{
			////Ice.Diagnostic.WriteLine("setup tooltip found: " + anchorSelector);
			anchorEl.__iceToolTip = new IceToolTip(anchorEl);
		});
	};

})();

