﻿
Ice.Web.UI.WebControls.IceTreeContextMenu = (function ()
{
	var menuItems =
		[
			{
				name: "Reload",
				cls: "reloadicon",
				clickHandler: function (treeNode)
				{
					treeNode.ReloadChildren();
				}

				/*,
				items:
				[
					{
						name: "Reload",
						cls: "reloadicon",
						clickHandler: function (treeNode)
						{
							treeNode.ReloadChildren();
						}
					},
					"-",
					{
						//hidden: true,
						name: "Expand All",
						cls: "expandicon",
						clickHandler: function (treeNode)
						{
							function expandchildren(node)
							{
								new Ice.List(node.GetChildren()).ForEach(function (item, index)
								{
									item.Expand(expandchildren); // callback method may give different this in ForEach
								});
							}

							treeNode.Expand(expandchildren); // on exanded, expand children
						},
						items:
						[
							{
								//hidden: true,
								name: "Expand All",
								cls: "expandicon",
								clickHandler: function (treeNode)
								{
									function expandchildren(node)
									{
										new Ice.List(node.GetChildren()).ForEach(function (item, index)
										{
											item.Expand(expandchildren); // callback method may give different this in ForEach
										});
									}

									treeNode.Expand(expandchildren); // on exanded, expand children
								}
							},
							{
								name: "Collapse All",
								cls: "collapseicon",
								clickHandler: function (treeNode)
								{
									function CollapseNode(treeNode)
									{
										treeNode.Collapse();
										var children = treeNode.GetChildren();
										for (var nn = 0; nn < children.length; nn++)
										{
											CollapseNode(children[nn]);
										}
									}
									CollapseNode(treeNode);
								}
							}
						]
					}
				]
				*/
			},
			"-",
			{
				//hidden: true,
				name: "Expand All",
				cls: "expandicon",
				clickHandler: function (treeNode)
				{
					function expandchildren(node)
					{
						new Ice.List(node.GetChildren()).ForEach(function (item, index)
						{
							item.Expand(expandchildren); // callback method may give different this in ForEach
						});
					}
					if (treeNode.expanded)
					{
						expandchildren(treeNode);
					}
					else
					{
						treeNode.Expand(expandchildren); // on exanded, expand children
					}
				}
			},
			{
				name: "Collapse All",
				cls: "collapseicon",
				clickHandler: function (treeNode)
				{
					function CollapseNode(treeNode)
					{
						treeNode.Collapse();
						var children = treeNode.GetChildren();
						for (var nn = 0; nn < children.length; nn++)
						{
							CollapseNode(children[nn]);
						}
					}
					CollapseNode(treeNode);
				}
			},
			{
				name: "New",
				cls: "newicon",
				clickHandler: function (treeNode)
				{
					var nn = prompt("New node:", "");
					if (nn && nn.length > 0)
					{
						var o = {
							Name: nn,
							ParentNodeID: treeNode.NodeID,
							Ordinal: null
						};
						treeNode.SetIcon(treeNode.loadingIcon);
						treeNode.ownerTree.NewNode(o, function (nodeData)
						{
							if (!nodeData)
							{
								alert("Can not add new node here");
							}
							
							treeNode.ReloadChildren();
						});
					}
				}
			},
			{
				name: "Rename",
				cls: "renameicon",
				clickHandler: function (treeNode)
				{
					var nn = prompt("Rename:", treeNode.Name);
					if (nn && nn.length > 0 && nn != treeNode.Name)
					{
						treeNode.Name = nn;
						treeNode.SetIcon(treeNode.loadingIcon);
						var o = treeNode;
						treeNode.ownerTree.SaveNodes([{
							NodeID: o.NodeID,
							ParentNodeID: o.ParentNodeID,
							Ordinal: o.Ordinal,
							Name: o.Name
						}], function (result)
						{
							treeNode.SetIcon();
							if (result)
							{
								treeNode.SetText(nn);
							}
						});
					}
				}
			},
			"-",
			{
				name: "Delete",
				cls: "deleteicon",
				clickHandler: function (treeNode)
				{
					if (confirm("Are you sure?"))
					{
						treeNode.SetIcon(treeNode.loadingIcon);
						var o = treeNode;
						treeNode.ownerTree.DeleteNodes([{
							NodeID: o.NodeID,
							ParentNodeID: o.ParentNodeID,
							Ordinal: o.Ordinal,
							Name: o.Name
						}], function (result)
						{
							var parentNode = treeNode.parentNode;
							treeNode.SetIcon(); // remove loading icon
							if (result)
							{
								treeNode.RemoveNode();
								parentNode.SetIcon();
							}
							else
							{
								alert("Node can not be deleted");
							}
						}, function (err)
						{
							alert(err);
							treeNode.SetIcon();
						});
					}
				}
			}
		];
	

	// constructor
	return (function(){
		return new Ice.Web.UI.WebControls.ContextMenu(menuItems);
	});

})();

