﻿
Ice.Web.UI.WebControls.IceTreeNode = function (config)
{
	Ice.Extend(this, config, true);
};

Ice.Web.UI.WebControls.IceTreeNode.prototype = new (function ()
{
	//#region initialize variables

	this.isRoot = false;
	this.expanded = false;
	this.childrenLoaded = false;
	////this.data = null; // js object from json received from server

	this.MayDropToNode = false,
	this.MayDropToSeparator = false,
	this.SeparatorAcceptsDrop = false;
	this.NodeAcceptsDrop = false;
	this.NodeDraggable = false;
	this.ShowMenu = false;
	this.ShowCheckbox = false;
	this.ShowIcon = false;
	this.NodeSelectable = false;
	this.HasParent = false;
	this.Animate = true; // default 
	this.IconUrl = null; // custom icon
	this.CopyDroppedNode = false;
	this.IsLastSibling = false;

	this.ownerTree = null;
	this.parentNode = null;

	this.domElement = null;
	this.domChildrenHolder = null;
	this.domSeparator = null;
	this.domAElement = null;
	this.domPlusMinusEl = null;
	this.domElWithIcon = null;

	this.currentIcon = null;

	this.loadingIcon = "loading";
	this.acceptIcon = "accept";
	this.deleteIcon = "delete";
	this.emptyIcon = "empty";
	this.openedIcon = "openf3";
	this.closedIcon = "folder3";
	this.notLoadedIcon = "world";

	//#endregion

	function FindTreeNode(element)
	{
		return $$ice(element).Query(".ice-treenode, ^.ice-treenode").Select("o=>o._iceTreeNode").First();
	}

	var _uniqueId = 0;

	this.CreateElementDom = function ()
	{
		if (!this.domElement)
		{
			var uid = "iceNode" + (_uniqueId++);
			var chk = "";
			if (this.ShowCheckbox)
			{
				chk = "<input type='checkbox' id='" + uid + "' value='" + ((this.ChkValue || "").replace("'", "\'")) + "' title='" + ((this.ChkTitle || "").replace("'", "\'")) + "' />";
			}
			var lbl = "<label for='" + uid + "' class='aname" + (this.NodeDraggable ? " draggCatch" : "") + "' >" + (this.Name || "") + "</label>";

			var div = this.domElement = document.createElement("div");
			div._iceTreeNode = this;
			div.className = "ice-treenode draggable group1";
			div.innerHTML =
		"<div class='sep group1'></div>" + // separator
		"<table class='nname group1' cellpadding='0' cellspacing='0'><tbody><tr>" +
			"<td class='nplusminus'></td>" +
			"<td class='nicon'></td>" +
			"<td  class='" + (this.ShowCheckbox ? "chkholder" : "") + "'>" + chk + lbl + "</td>" +
		////	"<td class='aname" + (this.NodeDraggable ? " draggCatch" : "") + "' title='" + ((this.NameTitle||"").replace("'", "\'")) + "'></td>" +
		"</tr></tbody></table>" +
		"<div class='children' style='height:0;overflow:hidden;'></div>";

			this.domChildrenHolder = div.childNodes[2];
			this.domSeparator = div.childNodes[0];
			this.nodeDropTarget = div.childNodes[1]; // table
			////this.domChkHolder = $$ice(div).Query("//td.chkholder").First();//.ApplyStyle(!this.ShowCheckbox ? "display:none" : "") .First();
			this.domAElement = $$ice(div).Query("//label.aname").First();
			this.domPlusMinusEl = $$ice(div).Query("//td.nplusminus").First();
			this.domElWithIcon = $$ice(div).Query("//td.nicon").ApplyStyle(!this.ShowIcon ? "display:none" : "").First();
			this.checkbox = $$ice(div).Query("//input[type=checkbox]").FirstOrDefault();
			if (this.checkbox)
			{
				this.checkbox.checked = this.IsChecked;
			}

			if (this.isRoot)
			{
				this.domSeparator.style.display = "none";
			}

			this.SetText(this.Name || ""); // ako je .Name == null, ie prikazuje text "null"
			this.SetIcon();

			// **************************************************
			// attach events
			this.domPlusMinusEl.onclick = function () { this.ToggleExpanded(); }.BindContext(this);

			if (this.HidePlusMinus)
			{
				// just to make it's visual presentation of parent-children relation more logical
				this.domPlusMinusEl.style.width = "0";
			}

			////$$ice(this.domAElement).OnHover(function (sender, ev)
			////{
			////	$$ice(sender).AddClass("over");
			////}, function (sender, ev)
			////{
			////	$$ice(sender).RemoveClass("over");
			////});

			if (this.ShowMenu)
			{
				//document.body.onkeyup
				$$ice(this.domAElement).OnRightMouseDown(function (sender, event)
				{
					this.ownerTree.contextMenu.ShowMenu(event, this);
				}.BindContext(this));
			}

			this.domAElement.ondblclick = function ()
			{
				this.ToggleExpanded();
			} .BindContext(this);

			$$ice(this.domAElement).OnMouseDown(function (sender, ev)
			{
				this.SelectNode();
			}.BindContext(this));

			if (this.SeparatorAcceptsDrop)
			{
				$$ice(this.domSeparator).AddClass("dropTarget");

				// separator as drop target
				this.domSeparator.OnDragHover = function (dropTarget, isOver)
				{
					Ice.Utility.Dom[isOver ? "AddClass" : "RemoveClass"](dropTarget, "sepover");
				};

				this.domSeparator.OnDrop = function (dropTarget, draggableElement, event)
				{
					var targetNode = FindTreeNode(dropTarget);
					var draggedNode = draggableElement._iceTreeNode;
					if (!draggedNode || !draggedNode.MayDropToSeparator)
					{
						return;
					}
					var previousParent = draggedNode.parentNode;
					if (draggedNode.CopyDroppedNode)
					{
						draggedNode = new Ice.Web.UI.WebControls.IceTreeNode(draggedNode); // clone node
						draggedNode.domElement = null;
					}
					else
					{
						draggedNode.RemoveNode();
					}
					draggedNode.InsertBefore(targetNode);
					draggedNode.Show();

					draggedNode.parentNode.NormalizeChildrenOrdinal(draggedNode); // draggedNode has already changed parentNodeID, so it has to be saved

					if (previousParent != targetNode.parentNode)
					{
						previousParent.SetIcon();
					}
					
					draggedNode.SetIcon(); // rekreate plus/minus/end icons

				};
			}

			if (this.NodeAcceptsDrop)
			{
				$$ice(this.nodeDropTarget).AddClass("dropTarget");

				// drop target - A node
				this.nodeDropTarget.OnDragHover = function (dropTarget, isOver)
				{
					Ice.Utility.Dom[isOver ? "AddClass" : "RemoveClass"](dropTarget, "nodeover");
				};

				this.nodeDropTarget.OnDrop = function (dropTarget, draggableElement, event)
				{
					var draggedNode = draggableElement._iceTreeNode;
					if (!draggedNode.MayDropToNode)
					{
						return;
					}
					var previousParent = draggedNode.parentNode;
					var newParent = FindTreeNode(dropTarget);

					if (draggedNode && newParent.NodeID == draggedNode.NodeID) // same node 2 trees
					{
						draggedNode.SetIcon(); // rekreate plus/minus/end icons
						return;
					}

					if (newParent.childrenLoaded)
					{

						if (draggedNode.CopyDroppedNode)
						{
							draggedNode = new Ice.Web.UI.WebControls.IceTreeNode(draggedNode); // clone node
							draggedNode.domElement = null;
						}
						else
						{
							draggedNode.RemoveNode();
						}

						draggedNode.ParentNodeID = newParent.NodeID;

						// just add node to the end
						newParent.AddChildNode(draggedNode);
						draggedNode.Show();

						if (previousParent != newParent)
						{
							previousParent.SetIcon();
						}

						newParent.NormalizeChildrenOrdinal(draggedNode); // draggedNode has already changed parentNodeID, so it has to be saved

						draggedNode.SetIcon(); // rekreate plus/minus/end icons

					}
					else // children are not loaded
					{
						newParent.Collapse();
						newParent.SetIcon(newParent.loadingIcon);

						//draggedNode.RemoveNode(); // remove from dom // ne! kad ponovo pozove ovu metodu, pokusa ponovo ukloniti isiti node, zato pozvati .Hide(), a kasnije .Show()
						// prvo loadiraj childrene, potom dodaj node
						draggedNode.Hide();

						newParent.Expand(function ()
						{
							// add node
							draggedNode.Show();
							draggedNode.SetIcon(); // rekreate plus/minus/end icons
							newParent.AddChildNode(draggedNode);
							newParent.NormalizeChildrenOrdinal(draggedNode);
						});
					}
				};
			}

		}

		// append to dom
		this.parentNode.domChildrenHolder.appendChild(this.domElement);

	};

	this.AdjustLeftMargin = function ()
	{
		if(this.isRoot || this.parentNode == null || this.parentNode.isRoot)
		{
			Ice.Utility.Dom.RemoveClass(this.domElement, "leftmargin");
		}
		else
		{
			Ice.Utility.Dom.AddClass(this.domElement, "leftmargin");
		}
	};

	this.SelectNode = function ()
	{
		if (this.ownerTree.selectedTreeNode)
		{
			// deselect previously selected node
			Ice.Utility.Dom.RemoveClass(this.ownerTree.selectedTreeNode.domAElement, "sel");
		}
		if (this.NodeSelectable)
		{
			Ice.Utility.Dom.AddClass(this.domAElement, "sel"); // sel se lijepi na A tag
			this.ownerTree.selectedTreeNode = this;
		}
	};

	this.SetText = function (text)
	{
		this.domAElement.innerHTML = text || ""; // ako je text == null, IE null prikazuje ko "null"
	};

	this.GetText = function ()
	{
		return this.domAElement.innerHTML;
	};

	this.GetChildren = function ()
	{
		return new Ice.List(this.domChildrenHolder.childNodes).Select("o=>o._iceTreeNode").ToArray();
	};

	this.RemoveChildren = function ()
	{
		this.domChildrenHolder.innerHTML = "";
		this.childrenLoaded = false;
		this.SetIcon();
	};

	this.RemoveNode = function ()
	{
		///<summary>remove this node from tree</summary>
		var parent = FindTreeNode(this.domElement.parentNode);
		this.domElement.parentNode.removeChild(this.domElement);
		parent.IsLeaf = parent.GetChildren().length == 0;
		parent.SetIcon();
	};

	this.AddChildNode = function (node)
	{
		this.IsLeaf = false;
		node.ParentNodeID = this.NodeID;
		node.parentNode = this;
		node.CreateElementDom(); // render dom if required and attach to this.parentNode.domChildrenHolder
		this.SetIcon();
	};

	this.InsertBefore = function (node)
	{
		// insert this before node
		this.parentNode = node.parentNode; // new parent
		this.ParentNodeID = node.ParentNodeID;
		node.domElement.parentNode.insertBefore(this.domElement, node.domElement); // must use parentNode here!!!
		this.AdjustLeftMargin();
	};

	this.ReloadChildren = function ()
	{
		var wasExpanded = this.expanded;
		this.RemoveChildren();
		this.Collapse();
		this.LoadChildren(function ()
		{
			if (wasExpanded)
			{
				this.Expand();
			}
		}.BindContext(this));
	};

	this.GetParentNode = function ()
	{
		return this.parentNode;
	};

	this.Expand = function (onDone)
	{
		if (!this.childrenLoaded)
		{
			this.LoadChildren(function ()
			{
				this.Expand(onDone);
			}.BindContext(this));
			return;
		}

		if (this.expanded)
		{
			return;
		}

		this.expanded = true;
		this.SetIcon();

		if (this.Animate)
		{
			if (this._animator)
			{
				this._animator.Abort();
				this._animator = null;
			}

			// mesure finalHeight:
			var currentHeight = $$ice(this.domChildrenHolder).SelectStyle("clientHeight").First();
			var finalHeight = $$ice(this.domChildrenHolder).ApplyStyle("height", "").SelectStyle("clientHeight").First();

			this._animator = $$ice(this.domChildrenHolder)
				.ApplyStyle("height", currentHeight)
				.ToAnimator({ "height": finalHeight }).OnComplete(function (animator)
			{
				animator.ToDomQuery().ApplyStyle("height", ""); // to be v-resizable if children are expanded

				if (onDone)
				{
					onDone(this); // used with Expand All
				}

				}.BindContext(this)).Easing(Ice.Animator.Easing.easeInOutCubic).Start();
		}
		else
		{
			$$ice(this.domChildrenHolder).ApplyStyle("height", ""); // to be v-resizable if children are expanded

			if (onDone)
			{
				onDone(this); // used with Expand All
			}
		}
	};

	this.Collapse = function ()
	{
		if (!this.expanded)
		{
			return;
		}
		this.expanded = false; // set false before it is expanded for real, this is important if Animate is true

		if (this.Animate)
		{
			if (this._animator)
			{
				this._animator.Abort();
				this._animator = null;
			}

			//var currentHeight = $$ice(this.domChildrenHolder).SelectStyle("clientHeight").First();

			this._animator = $$ice(this.domChildrenHolder)
				//.ApplyStyle("height", currentHeight) // not needed, height is mesured in Animator using property clientHeight
				.ToAnimator({ "height": 0 }).Easing(Ice.Animator.Easing.easeInOutCubic)
			.OnComplete(function (animator)
			{
				this.SetIcon();
			}.BindContext(this))
			.Start();
		}
		else
		{
			$$ice(this.domChildrenHolder).ApplyStyle("height", "0");
			this.SetIcon();
		}
	};

	this.ToggleExpanded = function ()
	{
		this.expanded ? this.Collapse() : this.Expand();
	};

	this.HasChildren = function ()
	{
		if (this.childrenLoaded)
		{
			return this.GetChildren().length > 0;
		}
		else
		{

		}
	};

	this.SetIcon = function (icon)
	{
		// icon is class name

		this.AdjustLeftMargin();

		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "plus");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "elbow-plus");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "elbow-plus-end");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "minus");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "elbow-minus");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "elbow-minus-end");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "elbow-end");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, "elbow");
		Ice.Utility.Dom.RemoveClass(this.domPlusMinusEl, this.loadingIcon);
		if (this.currentIcon)
		{
			Ice.Utility.Dom.RemoveClass(this.domElWithIcon, this.currentIcon);
			this.currentIcon = null;
		}
		if (this.domElWithIcon)
		{
			this.domElWithIcon.innerHTML = "";
		}

		if (this.IconUrl)
		{
			this.domElWithIcon.innerHTML = "<img src='" + this.IconUrl + "' style='max-width:20px;max-height:16px' />";
			Ice.Utility.Dom.AddClass(this.domPlusMinusEl, this.IsLastSibling ? "elbow-end" : "elbow");
			return;
		}

		if (icon == this.loadingIcon)
		{
			Ice.Utility.Dom.AddClass(this.domPlusMinusEl, this.loadingIcon);
			Ice.Utility.Dom.AddClass(this.domPlusMinusEl, this.IsLastSibling ? "elbow-end" : "elbow");
			return;
		}

		if (icon)
		{
			// set icon
			Ice.Utility.Dom.AddClass(this.domPlusMinusEl, this.IsLastSibling ? "elbow-end" : "elbow");
		}
		else if(this.IsLeaf)
		{
			icon = this.emptyIcon;
			Ice.Utility.Dom.AddClass(this.domPlusMinusEl, this.IsLastSibling ? "elbow-end" : "elbow");
		}
		else if (this.expanded)
		{
			icon = this.openedIcon;
			Ice.Utility.Dom.AddClass(this.domPlusMinusEl, this.IsLastSibling || !this.HasChildren() ? "elbow-minus-end" : "elbow-minus");
		}
		else
		{
			icon = this.closedIcon;
			Ice.Utility.Dom.AddClass(this.domPlusMinusEl, this.IsLastSibling ? "elbow-plus-end" : "elbow-plus");
		}

		// set icon
		Ice.Utility.Dom.AddClass(this.domElWithIcon, icon);
		this.currentIcon = icon;
	};

	this.Hide = function ()
	{
		this.domElement.style.display = "none";
	};

	this.Show = function ()
	{
		this.domElement.style.display = "block";
	};

	function AppendChildren(parent, childrenArr)
	{
		if (!childrenArr)
		{
			return;
		}

		new Ice.List(childrenArr).ForEach(function (o, index)
		{
			o.ownerTree = parent.ownerTree;
			o.parentNode = parent;
			o.childrenLoaded = o.IsLeaf;  // don't try to load children if it is leaf node
			o.IsLastSibling = index + 1 == childrenArr.length;

			var child;
			parent.AddChildNode(child = new Ice.Web.UI.WebControls.IceTreeNode(o));

			if (o.Children && o.Children.length > 0)
			{
				AppendChildren(child, o.Children);
			}

			if (o.ShouldExpand)
			{
				child.Expand();
			}
		});

		if (parent.isRoot)
		{
			// hide root node after children were loaded
			parent.nodeDropTarget.style.display = "none"
		}

		parent.childrenLoaded = true;

		parent.ownerTree.OnChildrenLoaded.Invoke(parent.ownerTree, parent);
	}

	this.LoadChildren = function (onDone)
	{
		if (this.isLoading || this.childrenLoaded)
		{
			return;
		}

		this.isLoading = true;
		this.SetIcon(this.loadingIcon);

		var parentId = this.NodeID || null; // root node has no nodeID
		var node = this;

		this.ownerTree.GetChildren(parentId, function (data)
		{
			AppendChildren(node, data);

			node.isLoading = false;
			node.SetIcon();

			Ice.Web.UI.WebControls.Dragger.Initialize(node.domElement);

			if (onDone)
			{
				onDone(node);
			}
		});
	};

	this.NormalizeChildrenOrdinal = function (alreadyChangedData)
	{
		var changedData = [];
		var __this = this;
		var arrchildren = this.GetChildren();

		new Ice.List(arrchildren).ForEach(function (o, n)
		{
			o.IsLastSibling = n + 1 == arrchildren.length;
			o.SetIcon();

			var ordinal = n + 1;

			if (o.Ordinal != ordinal || o.NodeID == alreadyChangedData.NodeID)
			{
				o.Ordinal = ordinal;
				changedData.push({
					NodeID: o.NodeID,
					ParentNodeID: o.ParentNodeID,
					Ordinal: o.Ordinal,
					Name: o.Name
				});
			}
		});

		this.SetIcon(this.loadingIcon);

		this.ownerTree.SaveNodes(changedData, function (data)
		{
			__this.SetIcon(); // restore default icon
		});
	};


})();

