﻿
Ice.Web.UI.WebControls.IceWindowManager = new (function ()
{
	function WindowManager(winMainId, titleId, maskId, isModal)
	{
		var winMainEl = $$ice(winMainId).First();
		var winContentEl = $$ice(winMainEl).DescendantNodes(".iceWinContentContainer").Take(1).ToDomQuery();
		var titleEl = $$ice(titleId).Take(1).ToDomQuery(); // must be list if there is no elements to avoid exception
		var maskEl = $$ice(maskId).First();
		var winDim = $$ice(winMainEl).ApplyStyleMap({ opacity: 0, display: "block" }).SelectStyleMap(["width", "height", "offsetWidth", "offsetHeight"]).First(); // render window to mesure original dimensions
		$$ice(winMainEl).ApplyStyleMap({ display: "none" }); // hide after mesured
		var maskAnimateMs = 500;
		var winAnimateMs = 500;
		var winBtnResize = $$ice(winMainEl).DescendantNodes(".iceWinBtnResize").Take(1).ToDomQuery(); // must be list if there is no elements to avoid exception
		var maskOpacity = $$ice(maskEl).SelectStyle("opacity").First();
		if (!isModal)
		{
			maskAnimateMs = 0;
			maskOpacity = 0;
			$$ice(maskEl).ApplyStyle("background:none;background-color:none;z-index:-1000;");
		}

		var isShown = false;
		var isMaximized = false;

		function CenterWindow()
		{
			if (isShown)
			{
				var currDim = $$ice(winMainEl).SelectStyleMap(["offsetWidth", "offsetHeight"]).First();
				var doc = $$ice(maskEl).SelectStyleMap(["clientWidth", "clientHeight"]).First();
				var left = (doc.clientWidth - currDim.offsetWidth) / 2;
				var top = (doc.clientHeight - currDim.offsetHeight) / 2;
				$$ice(winMainEl).ApplyStyleMap({ "left": left, "top": top });
				if (isMaximized)
				{
					$$ice(winMainEl).ApplyStyleMap({ "width": doc.width, "height": doc.height });
				}
			}
		}

		////	// if there is more than 1 window, onclick has to bring window to the front
		////	$$ice(winMainEl).OnClick(function (sender, ev)
		////	{
		////		this.style.zIndex = ++globalZIndex; // global z-index has to be stored to windows manager
		////		Ice.Console.WriteLine(this.id + ": " + this.style.zIndex);
		////		$$ice(this).ApplyStyle("left", "+=1").Sleep(1, function () { this.ApplyStyle("left", "-=1"); }); // force stupid IE to render it
		////	});

		$$ice(window).On("resize", CenterWindow).On("scroll", CenterWindow);

		var dragger = $$ice(titleEl).Any() ? new Ice.Draggable($$ice(winMainEl).First(), $$ice(titleEl).First()).Start() : null;

		var state;

		$$ice(winMainEl).DescendantNodes(".winTop, .winLeft, .winBottom, .winRight").OnHover(function ()
		{
			var dd = $$ice(this)
			//.ApplyStyle("background-color", "white")
			.Where(function () { return isMaximized; }) // if window is maximized, set default cursor
			.ApplyStyle("cursor", "default");

		}, function ()
		{
			//$$ice(this).ApplyStyle("background-color", ""); // use css value
		})
		.OnMouseDown(function (sender, ev)
		{
			if (isMaximized)
			{
				return;
			}

			$$ice(document.body).SetSelectable(false);

			state = {};
			state.startPageX = ev.pageX;
			state.startPageY = ev.pageY;
			state.winLeft = this.className.indexOf("winLeft") >= 0;
			state.winTop = this.className.indexOf("winTop") >= 0;
			state.winBottom = this.className.indexOf("winBottom") >= 0;
			state.winRight = this.className.indexOf("winRight") >= 0;
			state.dimensions = $$ice(winMainEl).SelectStyleMap(["top", "left", "width", "height"]).First();
		});


		$$ice(document.body)
		.OnMouseUp(function (sender, ev)
		{
			$$ice(document.body).SetSelectable(true);

			state = false;
		})
		.OnMouseMove(function (sender, ev)
		{
			if (state)
			{
				var deltaX = ev.pageX - state.startPageX;
				var deltaY = ev.pageY - state.startPageY;

				var curr = state.dimensions;

				if (state.winLeft)
				{
					$$ice(winMainEl).ApplyStyle("left", curr.left + deltaX).ApplyStyle("width", curr.width - deltaX);
				}

				if (state.winRight)
				{
					$$ice(winMainEl).ApplyStyle("width", curr.width + deltaX);
				}

				if (state.winTop)
				{
					$$ice(winMainEl).ApplyStyle("top", curr.top + deltaY).ApplyStyle("height", curr.height - deltaY);
				}

				if (state.winBottom)
				{
					$$ice(winMainEl).ApplyStyle("height", curr.height + deltaY)
				}
			}
		});


		this.Close = function ()
		{
			$$ice(winContentEl).SetVisible(false);

			$$ice(maskEl).ToAnimator({ opacity: 0 })
			.Duration(maskAnimateMs)
			.Easing(Ice.Animator.Easing.easeInOutExpo)
			.OnComplete(function ()
			{
				$$ice(maskEl).ApplyStyle("display", "none");
			})
			.Start();

			var top = animateTarget ? animateTarget.top : 0;
			var left = animateTarget ? animateTarget.left : 0;

			$$ice(winMainEl).ToAnimator({ opacity: 0, width: 0, height: 0, left: left, top: top })
			.Easing(Ice.Animator.Easing.easeInOutExpo)
			.Duration(animateTarget ? winAnimateMs : 0)
			.OnComplete(function ()
			{
				isShown = false;
				$$ice(winMainEl).ApplyStyle("display", "none");
			})
			.Start();
		};

		var animateTarget = null;

		this.Show = function (animatePos)
		{
			if (isShown)
			{
				return;
			}

			animateTarget = animatePos;

			var top = animateTarget ? animateTarget.top : 0;
			var left = animateTarget ? animateTarget.left : 0;

			$$ice(winContentEl).SetVisible(false);

			$$ice(maskEl).ApplyStyleMap({ opacity: 0, display: "block" })
			.ToAnimator({ opacity: maskOpacity })
			.Easing(Ice.Animator.Easing.easeInOutExpo)
			.Duration(maskAnimateMs)
			.Start();

			var doc = $$ice(maskEl).SelectStyleMap(["clientWidth", "clientHeight"]).First();

			$$ice(winMainEl).ApplyStyleMap({ top: top, left: left, width: 0, height: 0, opacity: 0, display: "block" })
			.ToAnimator({
				opacity: 100,
				width: winDim.width,
				height: winDim.height,
				left: (doc.clientWidth - winDim.offsetWidth) / 2,
				top: (doc.clientHeight - winDim.offsetHeight) / 2
			})
			.Easing(Ice.Animator.Easing.easeInOutExpo)
			.Duration(animateTarget ? winAnimateMs : 0)
			.OnComplete(function ()
			{
				isShown = true;
				$$ice(winContentEl).SetVisible(true);
			})
			.Start();

		};

		var positionBeforeResize;

		this.Resize = function ()
		{
			var doc = $$ice(maskEl).SelectStyleMap(["width", "height"]).First();

			$$ice(winContentEl).SetVisible(false);

			if (isMaximized)
			{
				// restore:

				isMaximized = false;

				if (dragger)
				{
					dragger.Start();
				}

				$$ice(winBtnResize).SetVisible(true).NextSiblings("img, input[type='image']").Take(1).SetVisible(false);

				$$ice(winMainEl).ToAnimator({
					left: positionBeforeResize.left,
					top: positionBeforeResize.top,
					width: positionBeforeResize.width,
					height: positionBeforeResize.height
				})
				.Easing(Ice.Animator.Easing.easeInOutExpo)
				.Duration(winAnimateMs)
				.OnComplete(function ()
				{
					$$ice(winContentEl).SetVisible(true);
				})
				.Start();
			}
			else
			{
				// maximize:
				isMaximized = true;

				if (dragger)
				{
					dragger.Stop();
				}

				positionBeforeResize = $$ice(winMainEl).SelectStyleMap(["top", "left", "width", "height"]).First();

				$$ice(winBtnResize).SetVisible(false).NextSiblings("img, input[type='image']").Take(1).SetVisible(true);

				$$ice(winMainEl).ToAnimator({
					left: 0,
					top: 0,
					width: doc.width,
					height: doc.height
				})
				.Easing(Ice.Animator.Easing.easeInOutExpo)
				.Duration(winAnimateMs)
				.OnComplete(function ()
				{
					$$ice(winContentEl).SetVisible(true);
				})
				.Start();
			}

		};

	};


	this.Setup = function (winContainerId, winMainId, titleId, maskId, isModal, show)
	{
		// get current or instantinate new
		var winContainerEl = $$ice("#" + winContainerId).First();
		if (winContainerEl.__iceWindowManager)
		{
			// manager is already created, required on postback to avoid double managers for single window
			return winContainerEl.__iceWindowManager;
		}
		winContainerEl.__iceWindowManager = new WindowManager("#" + winMainId, "#" + titleId, "#" + maskId, isModal, show);

		if (show)
		{
			winContainerEl.__iceWindowManager.Show();
		}

		return winContainerEl.__iceWindowManager;

	};

	this.FindOwnerWindow = function (iceSelector)
	{
		/// <summary>
		/// Find owner window from child element defined by iceSelector.
		/// </summary>
		/// <param name="iceSelector">window selector or window child element selector</param>

		return $$ice(iceSelector)
				.Concat($$ice(iceSelector).AncestorNodes())
				.Where(function (o) { return o.__iceWindowManager; })
				.Select(function (o) { return o.__iceWindowManager; })
				.First();
	};


})();



