﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />


QoDesk.CountryEditorGrid = function(config){
	QoDesk.CountryEditorGrid.superclass.constructor.apply(this, arguments);
};

QoDesk.CountryEditorGrid = Ext.extend(QoDesk.CountryEditorGrid, Ext.app.Module, {

	name: "Countries",
	windowId: "CountriesWin",
	moduleType: 'demo',
    moduleId: 'CountryEditorGrid',
	autoload: true,
	iconCls : "country-icon-small",
	shortcutIconCls : "country-icon-large" ,

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls,
            scope: this,
            shortcutIconCls: this.shortcutIconCls,
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
		
		if(win)
		{
	        win.show();
		}
		else
        {
        	win = desktop.createWindow({
		        id: this.windowId,
                title: this.name,
                width:850,
                height:600,
                //closeAction:'hide',
                iconCls: this.iconCls,
                shim:false,
                animCollapse:false,
                constrainHeader:true,
				layout: 'fit',
               // items: grid,
                taskbuttonTooltip: "<b>" + this.name + "</b>"
			});
			
			
			function LoadGridView()
			{
				var grid = Ice.DbAdmin.GetGridWithPaging({
					tableName:"Country", 
					delayLoad:0, 
					disableInlineEditing:true,
					hideSchemaInfo:true,
					sortInfo: {field:'Ordinal', direction:'DESC'},
					columns:
					{
						"TaxID": // add new column
						{
							width:100,
							header:"Tax", 
							dataIndex:"TaxID", 
							hidden:false,
							renderer: taxEditor.renderer, // grid renderer
							formEditor: Ext.grid.TaxField
						}
					}
				});
				
				function Refreshed()
				{
					win.nextDirection = win.nextDirection == 1 ? -1 : 1;
					win.width += win.nextDirection;
					win.setWidth(win.width); // have to re-render window after data is loaded					
				}
				grid.view.on("refresh", function(){ setTimeout(Refreshed, 1000);});
				
				win.add(grid);
				win.show();
	//			win.render();
			}
			
			var taxEditor = new Ext.grid.TaxField();
			
			function CombosLoader()
			{
				if(taxEditor.dataLoaded)
				{
					LoadGridView();
				}
				else
				{
					setTimeout(CombosLoader, 100);
				}
			}
			
			CombosLoader();
        }
        
    }
 });
 
 