﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="../IceExtExtensions.js" />
/// <reference path="/Scripts/IceFormSerialization.js" />

Ice.DbAdmin.PaymentTypeWin = {};

Ice.DbAdmin.ShowPaymentTypeForm = function(config){

	//alert("ShowFormAddNew");
	/*
	config is the same as GridWithPaging plus some extra properties:
		config.animateTarget = sender;
		config.onSaved = AfterSaveMethod;
		config.record = record;
		config.forceInsert = forceInsert;
		config.iconCls = iconCls;
	*/
	
	var data = config.record ? (config.record.data || {}) : {};
	var divId = "cp_" + data.PGName;
			
	function PopulateWithValues()
	{
		var divHolder = document.getElementById(divId);
		
		if(!divHolder)
		{
			setTimeout(PopulateWithValues, 100);
		}
		else
		{
			Ice.FormSerialization.PopulateHtmlControls(divId, data, true);
			
			// resize window
			win.setHeight(divHolder.offsetHeight + 90);
			var top = (document.body.offsetHeight - win.getSize().height) / 2;
			win.setPosition(win.x, Math.round(top));
		}
	}
	
	function GetWindow(cpHtml)
	{
		
		var win = new Ext.Window({

			title: data.PGName,
			minimizable:false,
			modal:true,
			maximizable:false,
			resizable:true,
			closable:true,
			maximized:false,
			iconCls: config.iconCls,
			border:true,
			width: 400,
			height: 600,
			shim:false,
			closeAction:'hide',
			animCollapse:true,
			autoScroll: true,
			layout: 'fit',
			bodyStyle: "background-color:#ECECEC; padding:0px;",
			html: "<div id='" + divId + "'>" + cpHtml + "</div>",
			buttons: 
			[
				{
					text: "Update",
					iconCls:"icon_table_save",
					handler: function()
					{
						var gds = 34;
						Ice.FormSerialization.SerializeHtmlControls(divId);
						config.record.commit();

						var obj = config.record.data;
						if(obj == null)
						{
							alert("NotNull values must be assigned!")
						}
						else
						{	
							GService.UpdateRows(config.tableName, [obj], function(newRows){
								if(newRows && newRows.length > 0)
								{
									win.hide();
									win.onFormSaved(newRows);
								}						
							});
						}
					}
				},
				{
					text: "Close",
					iconCls:"icon_cancel",
					handler: function()
					{
						win.hide();
					}
				}
			]
		});
		
		return win;
	}
	
	var win = Ice.DbAdmin.PaymentTypeWin[divId];
	
	if(win)
	{
		win.currentRecord = config.record;
		win.onFormSaved = config.onSaved;
		win.show();
		PopulateWithValues();
		return;
	}
	else
	{
		GService.GetPaymentTypeControlPanel(data.PaymentTypeID, function(cp){
			
			win = GetWindow(cp);
			Ice.DbAdmin.PaymentTypeWin[divId] = win;
			
			win.currentRecord = config.record;
			win.onFormSaved = config.onSaved;

			win.show();
			PopulateWithValues();
		});
	}
	
};



if(!QoDesk.PaymentTypeEditor)
{
	QoDesk.PaymentTypeEditor = {};
}

QoDesk.PaymentTypeEditor.ShowQuickHelp = function(sender){
	var msg = sender.parentNode.parentNode.firstChild.innerHTML;
	
	var win = window.open('','help','width=500,height=400, resizable=yes, status=yes, scrollbars=yes');
	if(win)
	{
		win.document.open();
		win.document.write("<html><body style='margin:0px; padding:10px; font: 8pt verdana;'>" + msg + "</body></html>");
		win.document.close();
		win.focus();
	}
};

