﻿/// <reference path="../../ice-fix-ext-before.js" />
/// <reference path="../../Ext_21/source/core/Ext.js" />
/// <reference path="../../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../../Ext_21/ext-all-debug.js" />
/// <reference path="../../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="GridWithPaging.js" />
/// <reference path="TabCloseMenu.js" />
/// <reference path="CategoriesTree.js" />

Ice.DbAdmin.GetCategoryTab = function(categoryData){

	//alert("GetCategoryTab");
	
	var categoryTitle = categoryData ? categoryData.Title : "all";
	var categoryId = categoryData ? categoryData.CategoryID : "";
	
	var articleGrid = Ice.DbAdmin.GetGridWithPaging({tableName:"Article", CategoryID: categoryId});
	var articleRetrieverGrid = Ice.DbAdmin.GetGridWithPaging({tableName:"ArticleRetriever", CategoryID: categoryId});
	
	var tab = new Ext.Panel({
		title: categoryTitle,
		layout:"border",
		border:false,
		closable: categoryId > 0,
		iconCls:"icon_application_view_columns",
		items:
		[
			{
				//title:"Articles",
				region:"center",
				layout:"fit",
				border:true,
				items: articleGrid
			},
			{
				//title:"Articles Retrievers",
				region:"south",
				height: 200,
				layout:"fit",
				split:true,
				border:true,
				collapsible:true,
				items: articleRetrieverGrid
			}
		]
	});
	
	tab.CategoryID = categoryId;
	
	var count = 0;
	
	tab.on("show", function(){
		if(count ++ > 0) // don't reload on first time show
		{
			articleGrid.Reload();
			articleRetrieverGrid.Reload();
		}
	});
	
	return tab;
};




Ice.DbAdmin.GetCategoriesMainForm = function(){

	//alert("GetCategoriesMainForm");
	
	function CategoryNodeClicked(node, e)
	{
		// find tab by CategoryID
		for(var n = 0; n < tabs.items.items.length; n++)
		{
			var tab = tabs.items.items[n];
			if(tab.CategoryID == node.nodeId)
			{
				tabs.setActiveTab(tab);
				return;
			}
		}
		// create new tab
		if(node.nodeData)
		{
			var tab = Ice.DbAdmin.GetCategoryTab(node.nodeData); 
			tabs.add(tab);
			tabs.show(tab);
			setTimeout(function(){tabs.setActiveTab(tab);}, 10);
		}
	}
	
	// right pane tabs
	var tabs = new Ext.TabPanel({
		resizeTabs:true,
		autoWidth:false,
		tabWidth:150,
		minTabWidth:150,
		enableTabScroll:true,
		activeTab:0,
		border:false,
		split:true,
		items:[Ice.DbAdmin.GetCategoryTab(null)],
		plugins: new Ext.ux.TabCloseMenu()
	});
	
	// main form
	var panel = new Ext.Panel({
		layout:"border",
		border:false,		
		items:
		[
			{
				region:"west",
				split:true,
				width:300,
				border:false,
				layout:"fit",
				items: Ice.DbAdmin.GetCategoriesTree(CategoryNodeClicked)
			},
			{
				region:"center",
				layout:"fit",
				items: tabs
			}
		]
	});

	return panel;
           
};


