﻿/// <reference path="../../ice-fix-ext-before.js" />
/// <reference path="../../Ext_21/source/core/Ext.js" />
/// <reference path="../../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../../Ext_21/ext-all-debug.js" />
/// <reference path="../../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />


Ice.DbAdmin.DatabaseSchemaTables = {};

Ice.DbAdmin.GetGridWithPaging = function (config)
{

	//alert("GetGridWithPaging");
	/*
	config = 
	{
	tableName:"PaymentType", 
	baseParams: null, // data store baseParams		
	CategoryID:null,		
	delayLoad: -1, // delay grid data auoload for x miliseconds, if < 0, don't autoload at all, if null, load immediately		
	disableInlineEditing:false, // disable grid inline editing
	columns:{
	"PGName":{editable: false, hidden:false} // add or modify columns settings
	},
	hideNew: true,
	hideEdit: false,
	hideDelete:true,
	hideSchemaInfo:true,
	customForm: function(){...} // custom form to be used instead of FormAddNew
	};
	*/

	var defaultPageSize = 50;
	config = config || {};

	var checkEditor = new Ext.form.Checkbox();
	checkEditor.renderer = function (v, p, record)
	{
		var isChecked = v == true;
		var id = "";
		p.css += ' x-grid3-check-col-td';
		return '<div class="x-grid3-check-col' + (isChecked ? '-on' : '') + ' x-grid3-cc-' + id + '">&#160;</div>';
	};


	function GetField(column)
	{
		/*
		public string ColumnName;
		public bool AllowDBNull;
		public bool AutoIncrement;
		public string TypeName;
		public int MaxLength;
		public bool ReadOnly;
		public bool Unique;
		public bool PK;
		*/
		var len = column.MaxLength;
		var p = {
			editor: null,
			renderer: null,
			width: len,
			align: "left"
		};

		if (p.width > 0)
		{
			// it is text fields
			p.width = p.width * 8; // 1 char =  8 pixels approx
			if (p.width > 150)
			{
				p.width = 150;
			}
		}

		var tn = column.TypeName;

		switch (tn)
		{
			case "DateTime":
				p.editor = new Ext.form.DateTimeField({ width: 200 });
				p.renderer = Ext.form.DateTimeField.ToISOFormat;
				p.width = 130;
				break;

			case "Boolean":
			case "Byte": // for MySQL
			case "SByte":
				p.editor = checkEditor;
				p.renderer = checkEditor.renderer;
				break;

			case "String":
				p.editor = new Ext.form.TextArea();
				break;

			default:
				if (tn.indexOf("Int") >= 0)// || tn.indexOf("Byte") >= 0) // Int, UInt, Byte, SByte
				{
					p.editor = new Ext.form.NumberField({ width: 100, allowDecimals: false });
					p.align = "center";
				}
				else if (tn.indexOf("Double") || tn.indexOf("Single") || tn.indexOf("Decimal"))
				{
					p.editor = new Ext.form.NumberField({ width: 100, allowDecimals: true, decimalPrecision: 8 });
					p.align = "center";
				}
				else
				{
					p.editor = new Ext.form.TextField({ width: 200 }); // unknown type
				}
				break;
		}

		if (column.ReadOnly || column.AutoIncrement)
		{
			p.editor.disable();
		}

		p.editor.name = column.ColumnName;

		// mesure columna name length
		var measure = Ext.util.TextMetrics.measure(document.body, p.editor.name);
		var delta = measure.width - p.width;
		if ((delta + 20) >= 0)
		{
			p.width += delta + 20;
		}

		return p;
	}

	////	function GetColumnTooltip(column)
	////	{
	////		var tt = "";
	////		for(var prop in column)
	////		{
	////			tt += prop + " = " + column[prop]  + "<br/>";
	////		}
	////		return tt;
	////	}

	function GetGridColumns(schema)
	{
		if (!schema)
		{
			return [];
		}
		var cols = [];
		for (var n = 0; n < schema.length; n++)
		{
			var col = schema[n];
			var field = GetField(col);

			// tooltip
			var tt = "";
			for (var prop in col)
			{
				if (prop == "ColumnName")
				{
					tt += "<b>" + col[prop] + "</b><br/>";
				}
				else
				{
					tt += prop + " = " + col[prop] + "<br/>";
				}
			}

			var style = "";
			if (col.PK)
			{
				style += "font-weight:bold;";
			}
			if (!col.AllowDBNull)
			{
				style += "color:red;";
			}

			var colSetting = {
				style: style,
				header: col.ColumnName,
				dataIndex: col.ColumnName,
				hidden: false,
				width: field.width,
				tooltip: tt,
				//	align:field.align, // column text is aligned too!!!
				sortable: true,
				editor: field.editor,
				editable: config.disableInlineEditing != true,
				renderer: field.renderer
			};

			cols.push(colSetting);

		}

		if (config.columns)
		{
			// apply custom settings to existing column or add new column
			for (var prop in config.columns)
			{
				var custom = config.columns[prop];
				var col = null;
				for (var nn = 0; nn < cols.length; nn++)
				{
					col = cols[nn];
					if (col.dataIndex == prop)
					{
						// found
						for (var prop in custom)
						{
							col[prop] = custom[prop];
						}
						col = null;
						break;
					}
				}
				if (col != null)
				{
					cols.push(custom);
					col = null;
				}
			}
		}

		return cols;
	}

	var columns = [];

	var reader = new Ext.data.GDataTableReader({
	//		id:'company'
	//		,totalProperty:'TotalCount'
	//		,root:'Rows'
	//		,fields:dt.Columns
});

var store = new Ext.data.Store({
	reader: reader
		, remoteSort: true
		, baseParams: config.baseParams || {} // {"parameter":432325} // will be sent on ajax request
		, url: GService.GetTableDataPaged // using modified Ext.Ajax.request allows to use url or web service method
	//	,proxy:proxy
	//	,sortInfo: config.sortInfo// {field:'MSI_VIEW_ID', direction:'DESC'}
		, autoLoad: false // if true, paging info is not used! invoke load on grid render
});

store.on("load", function (store, records, options)
{
	if (records.length == 0)
	{
		return;
	}
	else
	{
		store.fields = records[0].fields; // update fields on reload
	}
});

var pageSizes = [10, 20, 50, 100, 200, 500, 1000];

var pageSizeCombo = new Ext.form.ComboBox({
	width: 60
		, triggerAction: "all"
		, editable: false
		, value: defaultPageSize
		, store: pageSizes
});

var pager = new Ext.PagingToolbar({
	store: store
			, displayInfo: true
			, pageSize: defaultPageSize
			, items: ["-", "Page size ", pageSizeCombo]
});

pageSizeCombo.on("select", function (record, index)
{
	var val = pageSizeCombo.getValue();
	if (val != pager.pageSize)
	{
		pager.pageSize = val;
		store.reload({ params: { start: 0, limit: val} });
	}
});

var tableNames = [];

var tableNameCombo = new Ext.form.ComboBox({
	width: 250
		, disabled: config.tableName != null
		, triggerAction: "all"
		, editable: false
		, value: "Loading..."
		, store: tableNames
});

function SetTableName(tableName)
{
	if (tableName != store.baseParams.tableName)
	{
		tableNameCombo.setValue(tableName);
		store.sortInfo = null;
		store.lastOptions = null;
		store.baseParams.tableName = tableName;

		var schema = Ice.DbAdmin.DatabaseSchemaTables[tableName];

		if (schema == null)
		{
			// get schema from database
			GService.GetSchemaColumns(tableName, function (schema)
			{
				Ice.DbAdmin.DatabaseSchemaTables[tableName] = schema;
				var cols = GetGridColumns(schema);
				grid.colModel.setConfig(cols);
				grid.tableName = store.baseParams.tableName;
				store.lastOptions = { params: { start: 0, limit: pager.pageSize} };
				store.sortInfo = config.sortInfo;
				store.reload();
			});
		}
		else
		{
			var cols = GetGridColumns(schema);
			grid.colModel.setConfig(cols);
			grid.tableName = store.baseParams.tableName;
			store.lastOptions = { params: { start: 0, limit: pager.pageSize} };
			store.sortInfo = config.sortInfo;
			store.reload();
		}
	}
}

tableNameCombo.on("select", function (record, index)
{
	var tableName = tableNameCombo.getValue();
	SetTableName(tableName);
});

function EditOrAddNewRow(sender, forceInsert, iconCls)
{
	var record = null;
	var fields = store.reader.jsonData.Columns;
	var selections = grid.getSelectionModel().getSelections(); // use selected data as template for new record
	if (selections && selections.length > 0)
	{
		record = selections[0];
	}
	if (!record && !forceInsert)
	{
		alert("Nothing selected!");
		return;
	}
	record = record || {};
	var method = store.reload.createDelegate(store);

	function AfterSaveMethod(newRecords)
	{
		method();
	}

	config.tableName = config.tableName == store.baseParams.tableName ? config.tableName : store.baseParams.tableName;
	config.animateTarget = sender;
	config.onSaved = config.onSaved || AfterSaveMethod;
	config.record = record;
	config.forceInsert = forceInsert;
	config.iconCls = iconCls;

	if (config.customForm)
	{
		config.customForm(config)
	}
	else
	{
		Ice.DbAdmin.ShowFormAddNew(config);
	}

}

function SaveChanges()
{
	var arr = [];
	var total = grid.store.getTotalCount();
	var rec = grid.store.getRange();
	for (var n = 0; n < rec.length; n++)
	{
		if (rec[n].data.Ordinal != null)
		{
			rec[n].set("Ordinal", total - n - pager.cursor);
		}

		if (rec[n].dirty)
		{
			arr.push(rec[n].data);
		}
	}
	if (arr.length > 0)
	{
		GService.UpdateRows(store.baseParams.tableName, arr, function (newRows)
		{
			store.reload();
		});
	}
	else
	{
		alert("Nothing to update!");
	}
}

function DeleteRows()
{
	function DoDelete(result)
	{
		if (result == "yes")
		{
			var records = grid.getSelectionModel().getSelections();
			var arr = [];
			for (var k = 0; k < records.length; k++)
			{
				arr.push(records[k].data);
			}
			if (arr.length > 0)
			{
				var method = config.methodDelete ? config.methodDelete : GService.DeleteRows;
				method(store.baseParams.tableName, arr, function (count)
				{
					store.reload();
				});

			}
		}
	}
	var records = grid.getSelectionModel().getSelections();
	if (records.length > 0)
	{
		//Ext.MessageBox.confirm("Please confirm!", "Are you sure?", DoDelete);
		if (confirm("Are you sure?"))
		{
			DoDelete("yes");
		}
	}
	else
	{
		alert("Nothing selected!");
	}
}

var ddGroup = "ddGridWithPaging" + config.tableName;

var mitem = {
	text: "Remove",
	iconCls: "icon_arrow_turn_left",
	tooltip: "Remove selected items from Category",
	handler: function ()
	{
		if (!confirm("Are you sure?"))
		{
			return;
		}
		var records = grid.getSelectionModel().getSelections();
		var arr = [];
		for (var k = 0; k < records.length; k++)
		{
			arr.push(records[k].data);
		}
		if (arr.length > 0)
		{
			config.methodRemove(store.baseParams.tableName, arr, function (count)
			{
				store.reload();
			});
		}
	}
};

var menuItems = [
		{
			text: "Edit",
			hidden: config.hideEdit,
			iconCls: "icon_page_white_edit",
			handler: function (sender, e) { EditOrAddNewRow(sender.el.dom, false, this.iconCls); }
		},
		config.hideEdit ? null : "-",
		{
			text: "New",
			hidden: config.hideNew,
			iconCls: "icon_page_white_add",
			handler: function (sender, e) { EditOrAddNewRow(sender.el.dom, true, this.iconCls); }
		},
			config.hideNew ? null : "-",
		{
			text: "Save",
			iconCls: "icon_page_save",
			handler: function () { SaveChanges(); }
		},
		"-",
		{
			text: "Delete",
			hidden: config.hideDelete,
			iconCls: "icon_page_white_delete",
			handler: function () { DeleteRows(); }
		},
			config.hideDelete ? null : "-",
		{
			text: "Reload",
			iconCls: "icon_page_refresh",
			handler: function () { store.reload(); }
		},
		config.showRemove ? "-" : null,
		config.showRemove ? mitem : null
	];

if (config.menuItemsBefore)
{
	for (var nn = config.menuItemsBefore.length; nn >= 0; nn--)
	{
		menuItems.unshift(config.menuItemsBefore[nn]);
	}
}

if (config.menuItemsAfter)
{
	for (var nn = 0; nn < config.menuItemsAfter.length; nn++)
	{
		menuItems.push(config.menuItemsAfter[nn]);
	}
}


var gridTbar = [tableNameCombo, "-"];
var popUpMenu = [];

for (var nn = 0; nn < menuItems.length; nn++)
{
	var item = menuItems[nn];
	if (item != null)
	{
		popUpMenu.push(item);
		gridTbar.push(item);
	}
}

var grid = new Ext.grid.EditorGridPanel({
	view: new Ext.grid.GridView({ forceFit: false }),
	loadMask: true,
	store: store,
	sm: new Ext.grid.RowSelectionModel({ singleSelect: false }),
	frame: false,
	border: false,
	width: 800,
	height: 500,
	width: 500,
	stripeRows: true,
	columns: columns,
	enableDragDrop: true,
	ddGroup: ddGroup,
	tbar: gridTbar,
	bbar: pager,
	listeners:
			{

				"render": function (senderGrid)
				{
					Ice.DbAdmin.MakeRowsDraggable(grid, ddGroup);

					function LoadAll()
					{
						GService.GetTablesNames(function (tables)
						{
							tableNameCombo.store.loadData(tables);
							SetTableName(tables[0]);
						});
					}

					function LoadData()
					{
						if (config.tableName)
						{
							SetTableName(config.tableName);
						}
						else
						{
							LoadAll();
						}
					}

					if (config.delayLoad == null)
					{
						LoadData();
					}
					else if (config.delayLoad >= 0)
					{
						setTimeout(LoadData, config.delayLoad);
					}
					else
					{
						// don't autoload at all
					}
				}
			}
});

var menu = new Ext.menu.Menu({
	width: 160,
	items: popUpMenu
});


grid.view.getColumnStyleBase = grid.view.getColumnStyle;
grid.view.getColumnStyle = function (col, isHeader)
{
	var gs = 43;
	var ye = 43;
	var style = grid.view.getColumnStyleBase(col, isHeader);
	style += isHeader ? (grid.colModel.config[col].style || "") : "";
	return style;
};

grid.on("contextmenu", function (e)
{
	var xy = e.xy;
	e.stopEvent();
	xy[0] = xy[0] - 10;
	xy[1] = xy[1] - 10;

	var t = Ext.lib.Event.getTarget(e);

	function ShowMenu()
	{
		// select clicked row
		var sm = grid.getSelectionModel();
		var rowIndex = grid.view.findRowIndex(t);
		if (rowIndex >= 0 && sm.isSelected(rowIndex) == false)
		{
			// select clicked row
			sm.selectRow(rowIndex);
		}

		var recordsArray = grid.getSelectionModel().getSelections();

		if (recordsArray.length > 0)
		{
			menu.showAt(xy);
		}
	}
	//setTimeout(ShowMenu, 100);
	ShowMenu();
	return false;
}, grid);

grid.Reload = function ()
{
	store.reload();
};

return grid;


};


/**************************************************************************
	MakeRowsDraggable
**************************************************************************/
Ice.DbAdmin.MakeRowsDraggable = function(grid, ddGroup){

	function IsTargetValid(e, data)
	{
		var rowIndex = data.grid.view.findRowIndex(e.target);
		return data.rowIndex != rowIndex;
	}
	
	var firstGridStore = grid.store;
	// This will make sure we only drop to the view container
	var firstGridDropTargetEl =  grid.getView().el.dom.childNodes[0].childNodes[1];
	var firstGridDropTarget = new Ext.dd.DropTarget(firstGridDropTargetEl, {
			ddGroup    : ddGroup,
			copy       : false,
			notifyOver: function(ddSource, e, data){
				return IsTargetValid(e,data) ? "x-dd-drop-ok" : "x-dd-drop-nodrop";
			},
			
			notifyDrop : function(ddSource, e, data){
				
				if( ! IsTargetValid(e, data))
				{
					return false;
				}
				
				var selections = data.selections;
				var droppedOnRowIndex = grid.view.findRowIndex(e.target);
				grid.getSelectionModel().clearSelections();					
				
				for(var n = 0; n < selections.length; n++)
				{
					grid.store.remove(selections[n]);
				}
		
				grid.store.insert(droppedOnRowIndex, selections);	
				return true;
			}
		}); 	


};

