﻿/// <reference path="../../language/en.js" />

if( ! window.Ice){Ice = {};}
if( ! window.Ice.Ext){Ice.Ext = {};}

Ice.Ext.ImageGalleryAsyncTreeNode = function(config){
	Ice.Ext.ImageGalleryAsyncTreeNode.superclass.constructor.call(this, config);

};

Ice.Ext.ImageGalleryAsyncTreeNode = Ext.extend(Ice.Ext.ImageGalleryAsyncTreeNode, Ext.tree.AsyncTreeNode, {
	enableDrop:true,
	
	ReloadChildren: function(){
			//Ext.MessageBox.ShowWaitMessage(false);
			this.ownerTree.LoadGalleries();
	},
	DeleteNodeFromDatabase: function(){
		var __this = this;
		function DoDelete(result)
		{
			if(result == "yes")
			{
				//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Deleting);
				GService.DeleteGalleryNode(__this.GalleryNode, Ice.BindContext(__this.ReloadChildren, __this));
			}
		}
		Ext.MessageBox.confirm(CartLanguage.AreYouSure, CartLanguage.CantBeUndone, DoDelete);
	},
	AddNewChild : function(){
		var __this = this;
		function DoAdd(result, name)
		{
			if(result == "ok")
			{
				//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Adding);
				GService.NewGalleryNode(__this.GalleryNode, name, Ice.BindContext(__this.ReloadChildren, __this));
			}
		}
		Ext.MessageBox.prompt(CartLanguage.Name + "?", null, DoAdd, __this, false, "NewGallery");
	},
	RenameNodeFromDatabase : function(){
		var __this = this;
		function DoRename(result, name)
		{	
			if(result == "ok" && name != __this.GalleryNode.GalleryDirectory)
			{
				__this.GalleryNode.GalleryDirectory = name;
				//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Renaming);
				GService.RenameGalleryNode(__this.GalleryNode, Ice.BindContext(__this.ReloadChildren, __this));
			}
		}
		Ext.MessageBox.prompt(CartLanguage.Name, null, DoRename, __this, false, __this.GalleryDirectory);
	},
	MoveNode : function(){
		var __this = this;
		//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Moving);
		GService.MoveGalleryNode(__this.GalleryNode, __this.parentNode.GalleryNode, Ice.BindContext(__this.ReloadChildren, __this));
	}

});

/////////////////////////////////////////////////////////////////
// CampaignsTreeLoader
Ice.Ext.ImageGalleryTreeLoader = function (config)
{
	Ice.Ext.ImageGalleryTreeLoader.superclass.constructor.call(this, config);
	var __this = this;


	this.requestData = function (parentNode, callback)
	{
		if (__this.fireEvent("beforeload", this, parentNode, callback) !== false)
		{
			function OnDataReady1(nodesArray)
			{
				handleResponse(nodesArray, parentNode, callback);
			}
			var parent1 = parentNode.GalleryNode || null;

			function LoadChildNodes()
			{
				GService.GetGalleryNodeCollection(parent1, OnDataReady1);
			}

			LoadChildNodes();
		}
		else
		{
			if (typeof callback == "function")
			{
				callback();
			}
		}
	};

	function processResponse(nodesArray, parentNode, callback)
	{
		parentNode.beginUpdate();
		for (var i = 0, len = nodesArray.length; i < len; i++)
		{
			var nodeData = nodesArray[i];

			var n = new Ice.Ext.ImageGalleryAsyncTreeNode({
				cls: 'album-node'
			});

			n.GalleryNode = nodeData;
			n.leaf = false;
			n.setText(nodeData.GalleryDirectory);
			n.GalleryDirectory = nodeData.GalleryDirectory;
			n.on("click", function (node, event)
			{
				parentNode.ownerTree.Owner.OpenTab(node.GalleryNode, node.text, true);
			}, n);

			if (parentNode.childNodes)
			{
				parentNode.appendChild(n);
				////setTimeout(Ice.BindContext(function(){this.expand.call(this);}, n), 100);
			}
		}
		parentNode.endUpdate();
		if (typeof callback == "function")
		{
			if (parentNode.childNodes)
			{
				callback(__this, parentNode);
			}
		}
	}

	function handleResponse(nodesArray, parentNode, callback)
	{
		__this.transId = false;
		processResponse(nodesArray, parentNode, callback);
		__this.fireEvent("load", __this, parent, callback);
	}
};

Ice.Ext.ImageGalleryTreeLoader = Ext.extend(Ice.Ext.ImageGalleryTreeLoader, Ext.tree.TreeLoader);

/////////////////////////////////////////////////////////////////
// ImageGalleryTree
Ice.Ext.ImageGalleryTree = function()
{
	var __this = this;
	
	var rootNode = new Ice.Ext.ImageGalleryAsyncTreeNode({
					text: CartLanguage.GalleryRoot,
					cls: 'album-node'
				});
		 
	Ice.Ext.ImageGalleryTree.superclass.constructor.call(this, {
		id:'gallery-im-tree',
		loader: new Ice.Ext.ImageGalleryTreeLoader({
			url: "WebForm1.aspx",
			OwnerTree: __this
		}),
		useArrows:false,
		lines:false,
		autoScroll:true,
		containerScroll: true,
		dropConfig:{appendOnly:true, ddGroup:"ImageGalleryDD"},
		animate:true,
		enableDD:true,
		enableDrop:true,
		containerScroll: true, 
		rootVisible:true,
		root: rootNode,
		ddGroup: 'ImageGalleryDD'
	
	});

		this.LoadRootNode = function()
		{
			function OnDataReady2(nodesArray)
			{
				var nodeData = nodesArray[0];
				var n = __this.root;
				n.GalleryNode = nodeData;
				n.leaf = false;
				n.setText(nodeData.GalleryDirectory);
				n.GalleryDirectory = nodeData.GalleryDirectory;
				n.on("click",  function(node, event)
				{
					__this.Owner.OpenTab(node.GalleryNode, node.text, true);
				}, n);
				
				if(nodeData.IsRoot)
				{
					var tab = __this.Owner.OpenTab(n.GalleryNode, n.text, false);
					setTimeout(Ice.BindContext(function () { this.expand.call(this); }, n), 200);
				}
				
			}
			
			GService.GetGalleryNodeCollection(null, OnDataReady2);
		};
		
		this.LoadGalleries = function()
		{
			// remove children first
			var child = null;
			while((child = __this.root.childNodes[0]) != null)
			{
				__this.root.removeChild(child);
			}
			
			__this.root.reload();
		};
	
	var menu = new Ext.menu.Menu({
		width:140,
		items: [
		{
			text: CartLanguage.Reload,
			handler: function()
			{
				if(__this.rightClickedNode != null)
				{
					__this.rightClickedNode.ReloadChildren.call(__this.rightClickedNode);
				}
				menu.hide();
			}
		},
		"-",
		{
			text:CartLanguage.New,
			handler: function()
			{
				if(__this.rightClickedNode != null)
				{
					__this.rightClickedNode.AddNewChild();
				}
				menu.hide();
			}
		},
		"-",
		{
			text: CartLanguage.Rename,
			handler: function()
			{
				if(__this.rightClickedNode != null)
				{
					__this.rightClickedNode.RenameNodeFromDatabase();
				}
				menu.hide();
			}
		},
		"-",
		{
			text: CartLanguage.Delete,
			handler: function()
			{
				if(__this.rightClickedNode != null)
				{
					__this.rightClickedNode.DeleteNodeFromDatabase();
				}
				menu.hide();
			}
		}]
	});

	
	var menuRoot = new Ext.menu.Menu({
		width:140,
		items: [
		{
			text:CartLanguage.Reload,
			handler: function()
			{
				if(__this.rightClickedNode != null)
				{
					__this.rightClickedNode.ReloadChildren.call( __this.rightClickedNode);
				}
				menuRoot.hide();
			}
		},
		"-",
		{
			text:CartLanguage.New,
			handler: function()
			{
				if(__this.rightClickedNode != null)
				{
					__this.rightClickedNode.AddNewChild();
				}
				menuRoot.hide();
			}
		}]
	});
	
	this.rightClickedNode = null;
	
	this.on("contextmenu", function(node, e)
	{
		var xy = e.xy;
		e.stopEvent();
		xy[0] = xy[0] - 10;
		xy[1] = xy[1] - 10;

		__this.rightClickedNode = node;
	
		function ShowMenu()
		{		
			if(node.GalleryNode.IsRoot == false)
			{
				menu.showAt(xy);
			}
			else
			{
				menuRoot.showAt(xy);
			}
		}
		setTimeout(ShowMenu, 100);
		return false;
	}, this);
	
	
	
	
	
	function OnUserRoleDone(result)
	{
		//Ext.MessageBox.ShowWaitMessage(false);
	}
	
	this.on("dragdrop", function(tree, node, dd, e){
		// get all children
		node.MoveNode();
	});

};

Ice.Ext.ImageGalleryTree = Ext.extend(Ice.Ext.ImageGalleryTree, Ext.tree.TreePanel);


