﻿/// <reference path="../language/en.js" />

Ice.ProductAttributeGroupGrid = function(productID)
{
	var __this = this;
	
	function OnDataReady(data)
	{
		__this.store.removeAll();
		var m = Ice.Ext.GetMetaData(data, __this.store);		
		__this.store.loadData(m);
	}
	
	function ReloadAttributes()
	{
		__this.store.removeAll();
		GService.GetAttributeGroupCollection(productID, OnDataReady);
	}
	
	function AddNewAttribute()
	{
		GService.NewAttributeGroup(productID, ReloadAttributes);
	}
	
	function DeleteAttribute(a, b, c, d, e)
	{
		var selected  = __this.selModel.getSelected();
		if(selected && selected.data)
		{
			GService.DeleteAttributeGroup(selected.data, ReloadAttributes);
		}
	}
	
	function SaveAttributes(reloadData, prodId)
	{
		var arr = [];
		var rec = __this.store.getRange();
		for(var n = 0; n < rec.length; n++)
		{
			if(rec[n].dirty)// if inserting new product
			{
				arr.push(rec[n].data);
			}
		}
		prodId = prodId ? prodId : productID;
		GService.SaveAttributeGroupCollection(arr, prodId, reloadData != false ? ReloadAttributes : null);
	}
	this.SaveAttributes = SaveAttributes;
	
	Ice.ProductAttributeGroupGrid.superclass.constructor.call(this, {
		width:225,
		height:120,
		border:false,
		viewConfig: {forceFit:true},
		sm: new Ext.grid.RowSelectionModel({singleSelect:true}),
		store: new Ext.data.Store({
			reader: new Ext.data.JsonReader(
			{
				root: "",
				fields:
				[
					{name: "AttributeGroupID", type: "int"}
				]
			})
		}),
		cm: new Ext.grid.ColumnModel([
			//	new Ext.grid.RowNumberer(),
				{
					header: CartLanguage.Name,
					tooltip: CartLanguage.AtributeNameExample,
					width:40, 
					sortable:true, 
					dataIndex:"Name",
					editor: new Ext.form.TextField({allowBlank: false})
				},
				{
					header: CartLanguage.Values,
					tooltip: CartLanguage.AttributeValueExample,
					//width:150, 
					sortable: true, 
					dataIndex: 'Values',
					editor: new Ext.form.TextField({allowBlank: false})
				}
			]),
		
		tbar: 
		[
			{
				//text:'Add',
				tooltip: CartLanguage.AddNew,
				iconCls:'demo-grid-add tabs',
				handler:AddNewAttribute
			},
			'-',
			{
				//text:'Delete',
				tooltip: CartLanguage.DeleteSelected,
				iconCls:'demo-grid-delete',
				handler:DeleteAttribute,
				disabled:false
			},
			"-",
			{
				//text:"Save Changes",
				tooltip: CartLanguage.SaveChanges,
				iconCls:"demo-grid-saveall",
				handler:function(){SaveAttributes(true, productID);}
			},
			"-",
			{
				//text: "Reload",
				tooltip: CartLanguage.ReloadFromDatabase,
				iconCls:"demo-grid-refresh",
				handler:ReloadAttributes
			}
		]
	});
	
	this.on("render", ReloadAttributes);
	
};

Ice.ProductAttributeGroupGrid = Ext.extend(Ice.ProductAttributeGroupGrid, Ext.grid.EditorGridPanel);