﻿/// <reference path="../language/en.js" />

//////////////////////////////////////////////////////////////////////////////////////////
// USER SETTING EDITOR

QoDesk.ProductEdit = function()
{
	var __this = this;
	
	this.name = CartLanguage.ProductEdit;
	this.windowId = "ProductEditWin";
	this.moduleType = 'demo';
    this.moduleId = 'ProductEditEditor';
	
	this.iconCls = "products-icon-small";
	this.shortcutIconCls = "product-icon-large" ;

	this.init = function(){
        __this.launcher = {
				handler : __this.createWindow,
				iconCls: "products-icon-small",
				scope: __this,
				shortcutIconCls: "products-icon-large",
				text: __this.name,
				tooltip: "<b>" + __this.name + "</b>"
			}
    };
	
    this.createWindow = function(productRecord, onSaved){
		var __this = this;
		
		QoDesk.ProductEdit.Current = this;
		
		__this.productRecord = productRecord;

        var desktop = __this.app.getDesktop();
        var win = desktop.getWindow(__this.windowId);
		
		if(win)
		{
			win.close();
			win = null;
		}
		
        if(!win)
        {			
			var ajaxRequests = 0;
			function AjaxRequestStarted(isSaving)
			{
				if(++ajaxRequests == 1)
				{
					if(isSaving == true)
					{
						//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Saving);
					}
					else
					{
						//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Loading);
					}
				}
			}
			
			function AjaxRequestEnded()
			{
				if(--ajaxRequests == 0)
				{
					//Ext.MessageBox.ShowWaitMessage(false);
				}
			}
			
			
			/*
				{name:"ProductID", type:"int"},
			//	{name:"IsActive", type:"bool"},
			// {name:"SKU", type:"string"},
			//	{name:"ManufacturerID", type:"int"},
				{name:"Ordinal", type:"int"},
			//	{name:"Notes", type:"string"},
			//	{name:"SmallImage", type:"string"},
			//	{name:"LargeImage", type:"string"},
			//	{name:"Weight", type:"float"},
			//	{name:"TaxID", type:"int"},
			//	{name:"SupplyPrice", type:"float"},
			//	{name:"OldPrice", type:"float"},
			//	{name:"SalePrice", type:"float"},
			//	{name:"StockQuantity", type:"int"},
			//	{name:"AddToStock", type:"int"},
			//	{name:"YellowAlarmQuantity", type:"int"},
			//	{name:"IsYellowAlarmWaiting", type:"bool"},
			//	{name:"RedAlarmQuantity", type:"int"},
			//	{name:"IsRedAlarmWaiting", type:"bool"},
			//	{name:"IsDownloadable", type:"bool"},
			//	{name:"FileToDownload", type:"string"},
			//	{name:"DemoFileToDownload", type:"string"},
				
				{name:"ProductInLanguageID", type:"int"},
				{name:"LanguageID", type:"int"},
			//	{name:"Name", type:"string"},
			//	{name:"ShortDescription", type:"string"},
			//	{name:"LongDescription", type:"string"},
				{name:"MetaInfoID", type:"int"}
				
				{name:"MetaInfo.MetaInfoID", type:"int"},
				{name:"MetaInfo.Title", type:"string"},
				{name:"MetaInfo.Keywords", type:"string"},
				{name:"MetaInfo.Description", type:"string"}
			*/	


			// create items
			var productData = [];
			var smallImageItem = null;
			var largeImageItem = null;
			var attributesGrid = null;
			var imagesGrid = null;
			// USER OBJECT
			function CreateProductFields(record)
			{
				// Name
				var item = new Ext.form.TextField();
				item.fieldLabel = CartLanguage.Name;
				item.value = record.data.Name;
				item.mapTo = "Name";
				productData.push(item);
				
				// IsActive
				var boolIsActive = new Ext.form.Checkbox();
				boolIsActive.isCheckbox = true;
				boolIsActive.setValue(record.data.IsActive);
				//var boolIsActive = new Ext.grid.BoolEditor(record.data.IsActive);
				boolIsActive.fieldLabel = CartLanguage.IsActive;
				boolIsActive.mapTo = "IsActive";
				boolIsActive.on("select", function(a,b,c,d){boolIsActive.value = b.data.boolValue;});
				productData.push(boolIsActive);

				// Name
				var item = new Ext.form.TextField();
				item.fieldLabel = CartLanguage.SKU;
				item.value = record.data.SKU;
				item.mapTo = "SKU";
				productData.push(item);

				// ManufacturerID
				var manufacturerItem = new QoDesk.SettingsSelectorMod("Manufacturer");
				manufacturerItem.fieldLabel = CartLanguage.Manufacturer;
				manufacturerItem.mapTo = "ManufacturerID";
				manufacturerItem.OnLoaded = function(){ manufacturerItem.SelectByID(record.data.ManufacturerID);AjaxRequestEnded();};
				manufacturerItem.on("select", function(a,b,c,d){manufacturerItem.value = b.data.ManufacturerID;});
				AjaxRequestStarted();
				manufacturerItem.LoadData();
				productData.push(manufacturerItem);

				// ShortDescription
				item = new Ext.form.TextArea({id:"textareaShortDescription"});
				item.fieldLabel = CartLanguage.ShortDescription + " <a href='#' onclick='QoDesk.ProductEdit.DescriptionEditor(\"textareaShortDescription\", \"" + CartLanguage.ShortDescription + "\");'><b>" + CartLanguage.Edit.toUpperCase() + "</b></a>";
				item.value = record.data.ShortDescription;
				item.mapTo = "ShortDescription";
				productData.push(item);
				
				// LongDescription
				item = new Ext.form.TextArea({id:"textareaLongDescription"});
				item.fieldLabel = CartLanguage.LongDescription + " <a href='#' onclick='QoDesk.ProductEdit.DescriptionEditor(\"textareaLongDescription\", \"" + CartLanguage.LongDescription + "\");'><b>" + CartLanguage.Edit.toUpperCase() + "</b></a>";
				item.value = record.data.LongDescription;
				item.mapTo = "LongDescription";
				productData.push(item);
				
				// ProductImageCollection start
				imagesGrid = {
						 xtype:'box'
						 ,isCheckbox:true
						,anchor:''
						,width:420
						,cls:"x-form-item"
						//,height:100
						,autoEl:
						{
							tag:'div', 
							style:'margin:2px 0 5px 0;',
							html: "<table border='0' cellpadding='0' cellspacing='0'" +
								"<tr><td style='vertical-align:top; width:192px; height:200px;''>Images:</td>" +
								"<td style='vertical-align:top; border:solid 1px #B5B8C8;background-color:white;'><div style='width:200px' id='tdImagesGrid' ></div></td></tr>" +
							"</table>"
						}
					};

				
				productData.push(imagesGrid);
				
				function BuildImagesGrid()
				{
					// build small and large image
					var tdAttrib = document.getElementById("tdImagesGrid");
					if(tdAttrib)
					{
						var grid = new Ice.ProductImagesGrid(record.data.ProductID);
						imagesGrid.SaveImages = grid.SaveImages;
						grid.render(tdAttrib);
						
						win.setWidth(win.getSize().width + 1); // IE 7 rendering issue fix
						
					}
					else
					{
						setTimeout(BuildImagesGrid, 100);
					}
				}
				
				BuildImagesGrid();
				// ProductImageCollection end
				
				// product attributes start					
				attributesGrid = {
						 xtype:'box'
						,anchor:''
						,isCheckbox:true
						,width:420
						,cls:"x-form-item"
						//,height:100
						,autoEl:
						{
							tag:'div', 
							style:'margin:2px 0 5px 0;',
							html: "<table border='0' cellpadding='0' cellspacing='0' style='width:100%'>" +
								"<tr><td style='vertical-align:top; width:192px; height:120px;''>" + CartLanguage.Attributes + ":</td>" +
								"<td id='tdAttributesGrid' style='vertical-align:top; border:solid 1px #B5B8C8;background-color:white;'></td></tr>" +
							"</table>"
						}
					};
				productData.push(attributesGrid);
				
				function BuildAttributesGrid()
				{
					// build small and large image
					var tdAttrib = document.getElementById("tdAttributesGrid");
					if(tdAttrib)
					{
						var grid = new Ice.ProductAttributeGroupGrid(record.data.ProductID);
						attributesGrid.SaveAttributes = grid.SaveAttributes;
						grid.render(tdAttrib);
						
						win.setWidth(win.getSize().width + 1); // IE 7 rendering issue fix
						
					}
					else
					{
						setTimeout(BuildAttributesGrid, 100);
					}
				}
				
				BuildAttributesGrid();
				// product attributes end
				
				// Weight
				item = new Ext.form.NumberField({
								allowDecimals: true,
								allowBlank:false,
								allowNegative:false,
								decimalPrecision:6}); 
				item.fieldLabel = CartLanguage.Weight + " (" + GService.WeightUnitSymbol + ")";
				item.value = record.data.Weight;
				item.mapTo = "Weight";
				productData.push(item);
				
				// SupplyPrice
				item = new Ext.form.NumberField({
								allowDecimals: true,
								allowBlank:false,
								allowNegative:false,
								decimalPrecision:2}); 
				item.fieldLabel = CartLanguage.SupplyPrice + " (" + GService.CurrencyISOCode + ")";
				item.value = record.data.SupplyPrice;
				item.mapTo = "SupplyPrice";
				productData.push(item);
				
				// SalePrice
				item = new Ext.form.NumberField({
								allowDecimals: true,
								allowBlank:false,
								allowNegative:false,
								decimalPrecision:2}); 
				item.fieldLabel = CartLanguage.SalePrice + " (" + GService.CurrencyISOCode + ")";
				item.value = record.data.SalePrice;
				item.mapTo = "SalePrice";
				productData.push(item);
								
				// StockQuantity
				item = new Ext.form.NumberField({
								//disabled:true,
								allowDecimals: false,
								allowBlank:false,
								allowNegative:false,
								decimalPrecision:-1}); 
				item.fieldLabel = CartLanguage.StockQuantity;
				item.value = record.data.StockQuantity;
				item.mapTo = "StockQuantity";
				productData.push(item);
				
////				// AddToStock
////				item = new Ext.form.NumberField({
////								disabled:false,
////								allowDecimals: false,
////								allowBlank:false,
////								allowNegative:true,
////								decimalPrecision:-1}); 
////				item.fieldLabel = CartLanguage.AddToStockPeaces;
////				item.value = record.data.AddToStock;
////				item.mapTo = "AddToStock";
////				productData.push(item);
				
				// CreationDate
				item = new Ext.form.DateTimeField();
				item.fieldLabel = CartLanguage.CreationDate;
				item.value = record.data.CreationDate;
				item.mapTo = "CreationDate";
				productData.push(item);

				// UpdateDate
				item = new Ext.form.DateTimeField();
				item.fieldLabel = CartLanguage.UpdateDate;
				item.value = record.data.UpdateDate;
				item.mapTo = "UpdateDate";
				productData.push(item);

				// YellowAlarmQuantity
				item = new Ext.form.NumberField({
								allowDecimals: false,
								allowBlank:false,
								allowNegative:false,
								decimalPrecision:-1}); 
				item.fieldLabel = CartLanguage.YellowAlarmOnQuantity;
				item.value = record.data.YellowAlarmQuantity;
				item.mapTo = "YellowAlarmQuantity";
				productData.push(item);
				
				// IsYellowAlarmWaiting
				var boolIsYellowAlarmWaiting = new Ext.form.Checkbox();
				boolIsYellowAlarmWaiting.isCheckbox = true;
				boolIsYellowAlarmWaiting.setValue(record.data.IsYellowAlarmWaiting);
				//var boolIsYellowAlarmWaiting = new Ext.grid.BoolEditor(record.data.IsYellowAlarmWaiting);
				boolIsYellowAlarmWaiting.fieldLabel = CartLanguage.IsYellowAlarmWaiting;
				boolIsYellowAlarmWaiting.mapTo = "IsYellowAlarmWaiting";
				boolIsYellowAlarmWaiting.on("select", function(a,b,c,d){boolIsYellowAlarmWaiting.value = b.data.boolValue;});
				productData.push(boolIsYellowAlarmWaiting);

				// RedAlarmQuantity
				item = new Ext.form.NumberField({
								allowDecimals: false,
								allowBlank:false,
								allowNegative:false,
								decimalPrecision:-1}); 
				item.fieldLabel = CartLanguage.RedAlarmOnQuantity;
				item.value = record.data.RedAlarmQuantity;
				item.mapTo = "RedAlarmQuantity";
				productData.push(item);
				
				// IsRedAlarmWaiting
				var boolIsRedAlarmWaiting = new Ext.form.Checkbox();
				boolIsRedAlarmWaiting.isCheckbox = true;
				boolIsRedAlarmWaiting.setValue(record.data.IsRedAlarmWaiting);
				//var boolIsRedAlarmWaiting = new Ext.grid.BoolEditor(record.data.IsRedAlarmWaiting);
				boolIsRedAlarmWaiting.fieldLabel = CartLanguage.IsRedAlarmWaiting;
				boolIsRedAlarmWaiting.mapTo = "IsRedAlarmWaiting";
				boolIsRedAlarmWaiting.on("select", function(a,b,c,d){boolIsRedAlarmWaiting.value = b.data.boolValue;});
				productData.push(boolIsRedAlarmWaiting);
				
				// IsDownloadable
				var boolIsDownloadable = new Ext.form.Checkbox();
				boolIsDownloadable.isCheckbox = true;
				boolIsDownloadable.setValue(record.data.IsDownloadable);
				//var boolIsDownloadable = new Ext.grid.BoolEditor(record.data.IsDownloadable);
				boolIsDownloadable.fieldLabel = CartLanguage.IsDownloadable;
				boolIsDownloadable.mapTo = "IsDownloadable";
				boolIsDownloadable.on("select", function(a,b,c,d){boolIsDownloadable.value = b.data.boolValue;});
				productData.push(boolIsDownloadable);

				// FileToDownload
				var item = new Ext.form.TextField();
				item.fieldLabel = CartLanguage.FileToDownload;
				item.value = record.data.FileToDownload;
				item.mapTo = "FileToDownload";
				productData.push(item);
				
				// DemoFileToDownload
				var item = new Ext.form.TextField();
				item.fieldLabel = CartLanguage.DemoFileToDownload;
				item.value = record.data.DemoFileToDownload;
				item.mapTo = "DemoFileToDownload";
				productData.push(item);		
				
				// Notes
				var item = new Ext.form.TextArea();
				item.fieldLabel = CartLanguage.Notes;
				item.value = record.data.Notes;
				item.mapTo = "Notes";
				productData.push(item);		
				
				
				// MetaTitle
				var item = new Ext.form.TextField();
				item.fieldLabel = CartLanguage.MetaTitle;
				item.value = record.data.MetaTitle;
				item.mapTo = "MetaTitle";
				productData.push(item);
				
				// MetaKeywords
				var item = new Ext.form.TextArea();
				item.fieldLabel = CartLanguage.MetaKeywords;
				item.value = record.data.MetaKeywords;
				item.mapTo =  "MetaKeywords";
				productData.push(item);
				
				// MetaDescription
				var item = new Ext.form.TextArea();
				item.fieldLabel = CartLanguage.MetaDescription;
				item.value = record.data.MetaDescription;
				item.mapTo = "MetaDescription";
				productData.push(item);
				
			}
			
			CreateProductFields(productRecord);

			function AppendArray(destArray, sourceArray)
			{
				for(var n = 0; n < sourceArray.length; n++)
				{
					var item = sourceArray[n];
					if( ! item.isCheckbox)
					{
						item.width = 230;
					}
					destArray.push(item);
				}
				return destArray;
			}
			
			function ShowWindow()
			{
				var itemsAll = [];
				AppendArray(itemsAll, productData);
				
				var formPanel = new Ext.FormPanel({
					labelWidth: 185, // label settings here cascade unless overridden
				   // frame:true,
					hideBorders: true,
					autoScroll: true,
					bodyStyle: "background-color:#ECECEC; padding-left:5px;",
					//defaults: {width: 230},
					items: itemsAll,
					defaultType: 'textfield'		
				});

				win = QoDesk.desktop.createWindow({
					//renderTo: document.body,
					id: __this.windowId,
					title: CartLanguage.ProductEditor + " - " + productRecord.data.Name,
					width:480,
					height: document.body.offsetHeight > 800 ? 800 - 40 : document.body.offsetHeight - 40, //// taskbar height = 35
					iconCls: 'products-icon-small',
					shim:false,
					animCollapse:false,
					constrainHeader:true,
					modal:true,
					taskButton:false,
					minimizable:false,
					maximizable:false,
					collapsible:false,
					resizable:true,
					layout: 'fit',
					items:  formPanel,
					buttons: [{
						text: CartLanguage.Save,
						iconCls:"icon_table_save",
						handler: function()
						{
							for(var n = 0; n < productData.length; n++)
							{
								if(typeof(productData[n].mapTo) == "object")
								{
									var tmpValue = productData[n].getValue();
									if(tmpValue != CartLanguage.Loading)
									{
										productData[n].mapTo.object[productData[n].mapTo.property] = tmpValue;
									}
								}
								else if(typeof(productData[n].mapTo) == "string")
								{
									var tmpValue = productData[n].getValue();
									if(tmpValue != CartLanguage.Loading)
									{
										productRecord.set(productData[n].mapTo, tmpValue);
									}

								}
							}
							// stock quantity
							//productRecord.set("StockQuantity", productRecord.get("StockQuantity") + productRecord.get("AddToStock"));
							
							
							SaveRecord(productRecord);
							
							//productRecord.set("AddToStock", 0);
							productRecord.commit();					
						
						}
					},{
						text: 'Cancel',
						iconCls:"icon_cancel",
						handler: function()
						{
							win.close();
						}
					}],
					taskbuttonTooltip: "<b>" + this.name + "</b>"
				});
				
				win.show();
			}
				
			function SaveRecord(record)
			{
				AjaxRequestStarted(true);
								
				var arr = [];
				arr.push(record.data);
				
				attributesGrid.SaveAttributes(false);
				imagesGrid.SaveImages(false);
				GService.UpdateRows("Product", arr, function(){
					win.close();
					onSaved();
				});

			}
			
			ShowWindow();
		}
	};
	    
    QoDesk.ProductEdit.superclass.constructor.call(this);
};

QoDesk.ProductEdit = Ext.extend(QoDesk.ProductEdit, Ext.app.Module);

QoDesk.ProductEdit.Current = null;