﻿/// <reference path="../../ice-fix-ext-before.js" />
/// <reference path="../../Ext_21/source/core/Ext.js" />
/// <reference path="../../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../../Ext_21/ext-all-debug.js" />
/// <reference path="../../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="GridWithPaging.js" />
/// <reference path="TabCloseMenu.js" />
/// <reference path="CategoriesTree.js" />


QoDesk.GetProductsMainForm = function(){

	//alert("GetCategoriesMainForm");
	
	function NodeClicked(node, e)
	{
		// find tab by CategoryID or CampaignID
		for(var n = 0; n < tabs.items.items.length; n++)
		{
			var tab = tabs.items.items[n];
			if(tab.CategoryID == node.nodeId || tab.CampaignID == node.nodeId)
			{
				tabs.setActiveTab(tab);
				return;
			}
		}
		// create new tab
		if(node.nodeData)
		{
			var tab = QoDesk.GetProductsRightPane(node.nodeData); 
			tabs.add(tab);
			tabs.show(tab);
			setTimeout(function(){tabs.setActiveTab(tab);}, 10);
		}
	}
	
	// right pane tabs
	var tabs = new Ext.TabPanel({
		resizeTabs:true,
		autoWidth:false,
		tabWidth:150,
		minTabWidth:150,
		enableTabScroll:true,
		activeTab:0,
		border:false,
		split:true,
		items:QoDesk.GetProductsRightPane(null),
		plugins: new Ext.ux.TabCloseMenu()
	});
	
	// trees tabs tab
	var treeTabs = new Ext.TabPanel({
		resizeTabs:true,
		autoWidth:false,
		tabWidth:100,
		minTabWidth:100,
		enableTabScroll:true,
		activeTab:0,
		border:false,
		items:
		[
			{
				title:"Categories",
				layout:"fit",
				items:  QoDesk.GetCategoriesTree(NodeClicked)
			},
			{
				title:"Campaigns",
				layout:"fit",
				items:  QoDesk.GetCampaignsTree(NodeClicked)
			}
		]
	});
	
	// main form
	var panel = new Ext.Panel({
		layout:"border",
		border:false,		
		items:
		[
			{
				region:"west",
				split:true,
				width:250,
				border:false,
				items: treeTabs,
				layout:"fit"
				
			},
			{
				region:"center",
				layout:"fit",
				items: tabs
			}
		]
	});

	return panel;
           
};


QoDesk.ProductsMain = function(config){
	QoDesk.ProductsMain.superclass.constructor.apply(this, arguments);
};

QoDesk.ProductsMain = Ext.extend(QoDesk.ProductsMain, Ext.app.Module, {

	name: "Products",
	windowId: "ProductsWin",
	moduleType: 'demo',
    moduleId: 'ProductsInCategoriesEditorGrid',
	autoload: true,
	iconCls : "products-icon-small",
	shortcutIconCls : "products-icon-large" ,

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls,
            scope: this,
            shortcutIconCls: this.shortcutIconCls,
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
		
		if(win)
		{
			win.show();
		}
		else
        {
			win = desktop.createWindow({
		        id: this.windowId,
                title: this.name,
                width:document.body.offsetWidth > 1200 ? 1200 - 40 : document.body.offsetWidth - 40,
                height: document.body.offsetHeight > 800 ? 800 - 40 : document.body.offsetHeight - 40,
                //closeAction:'hide',
                iconCls: this.iconCls,
                shim:false,
                animCollapse:false,
                constrainHeader:true,
				layout: 'fit',
               
                taskbuttonTooltip: "<b>" + this.name + "</b>"
			});
			
			win.show();
			
			setTimeout(function(){
				win.add(QoDesk.GetProductsMainForm());
				win.render();
			 }, 500);

        }
      
    }
 });
 
