﻿/// <reference path="../language/en.js" />


QoDesk.WebPageEdit = function(record, app, useHtmlDesigner)
{
	var windowId = "webPageEdit";
////	var desktop = app.getDesktop();
////	var win = desktop.getWindow(windowId);
////	if(win){win.close();}

	var ajaxRequests = 0;

	function AjaxRequestStarted()
	{
		ajaxRequests ++;
	}
	
	function AjaxRequestStarted(isSaving)
	{
		if(++ajaxRequests == 1)
		{
			if(isSaving == true)
			{
				//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Saving);
			}
			else
			{
				//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Loading);
			}
		}
	}
	
	function AjaxRequestEnded()
	{
		if(--ajaxRequests == 0)
		{
			//Ext.MessageBox.ShowWaitMessage(false);
		}
	}

/*
	[WebPageID] [int] IDENTITY(1,1) NOT NULL,
	[IsActive] [bit] NOT NULL,
	[IsTemplate] [bit] NOT NULL,
	[Ordinal] [int] NOT NULL,
	[Name] [nvarchar](100) NULL,
	[Notes] [nvarchar](500) NULL,
	[Content] [ntext]
	[AscxModulePath][nvarchar](500) NULL

*/

	// Name
	var nameItem = new Ext.form.TextField({anchor:'95%'});
	nameItem.fieldLabel = CartLanguage.Name;
	nameItem.value = record.data.Name;
	nameItem.mapTo = "Name";
	nameItem.anchor = "95%";

	// IsActive
	var isActiveItem = new Ext.grid.BoolEditor(record.data.IsActive);
	isActiveItem.fieldLabel = CartLanguage.Active;
	isActiveItem.mapTo = "IsActive";
	isActiveItem.on("select", function(a,b,c,d){isActiveItem.value = b.data.boolValue;});
	isActiveItem.anchor = "95%";
	
//////	// SystemActionID
//////	var webActionItem = new QoDesk.SettingsSelectorMod("SystemActionValues");
//////	webActionItem.fieldLabel = "System Action";
//////	webActionItem.mapTo = "SystemActionID";
//////	webActionItem.anchor = "95%";
//////	webActionItem.OnLoaded = function(){webActionItem.SelectByID(record.data.SystemActionID); AjaxRequestEnded();};
//////	webActionItem.on("select", function(a, b, c, d){webActionItem.value = b.data.SystemActionValuesID;});
//////	AjaxRequestStarted();
//////	webActionItem.LoadData();

	// Notes
	var notesItem = new Ext.form.TextArea({anchor:'100%'});
	notesItem.fieldLabel = CartLanguage.Notes;
	notesItem.value = record.data.Notes;
	notesItem.mapTo = "Notes";
	notesItem.anchor = "95%";

	// AscxModulePath
	var ascxModulePathItem = new Ext.form.TextField({anchor:'95%'});
	ascxModulePathItem.fieldLabel = CartLanguage.AscxModulePath;
	ascxModulePathItem.value = record.data.AscxModulePath;
	ascxModulePathItem.mapTo = "AscxModulePath";
	ascxModulePathItem.anchor = "95%";

	var metaFields = [];
	// MetaTitle
	var metaTitle = new Ext.form.TextField();
	metaTitle.fieldLabel = CartLanguage.MetaTitle + " (*)";
	metaTitle.value = record.data.MetaTitle;
	metaTitle.anchor = "95%";
	metaFields.push(metaTitle);
	
	// MetaKeywords
	var metaKeywords = new Ext.form.TextArea();
	metaKeywords.fieldLabel = CartLanguage.MetaKeywords + " (*)";
	metaKeywords.value = record.data.MetaKeywords;
	metaKeywords.anchor = "95%";
	metaFields.push(metaKeywords);
	
	// MetaDescription
	var metaDescription = new Ext.form.TextArea();
	metaDescription.fieldLabel = CartLanguage.MetaDescription + " (*)";
	metaDescription.value = record.data.MetaDescription;
	metaDescription.anchor = "95%";
	metaFields.push(metaDescription);

	var htmlEditor = null;
	
	if(useHtmlDesigner)
	{
		var htmlEditor = {
			 xtype:'box'
			,anchor:"100%"
			//,width:420
			//,cls:"x-form-item"
			//,height:100
			,autoEl:
			{
				tag:'div', 
				//style:'margin:0px 0 0px 0;',
				html: "<iframe id='webEditorIframe' src='../Editor.aspx?c=webpage' style='width:100%; height:100px;' frameborder='0'></iframe>"
			}
		};
	}
	else
	{
		htmlEditor = new Ext.form.TextArea();
		htmlEditor.on("render", function(){	htmlEditor.setValue(record.data.Content);});
		htmlEditor.fieldLabel = CartLanguage.HTMLContent + " (*)";
		htmlEditor.anchor = "100%";
	}
	
	var labelNote = new Ext.form.Label({text: "(*) " + CartLanguage.inCurrentlySelectedLanguage});

	function ResizeEditor()
	{
		var width = win.getInnerWidth();
		var height = win.getInnerHeight();
		
		if(useHtmlDesigner)
		{
			var ifr = document.getElementById("webEditorIframe");
			ifr.style.height = (height - 50) + "px";
			// resize CuteEditor
			if(ifr.contentWindow && ifr.contentWindow.CuteEditor)
			{
				ifr.contentWindow.CuteEditor.DoResize = true;
			}
		}
		else
		{
			htmlEditor.setHeight(height - 280);
		}
	}
	
	var formItems = null;

	if(useHtmlDesigner)
	{
		formItems = [
			htmlEditor
			];
	}
	else
	{
		formItems = [
			{
				layout:'column',
				border:false,
				items:[{
					columnWidth:.5,
					layout: 'form',
					border:false,
					items: [nameItem, isActiveItem, notesItem, ascxModulePathItem] // , webActionItem] // hide SystemAction field
				},{
					columnWidth:.5,
					layout: 'form',
					border:false,
					items: metaFields
				}]
			},
			htmlEditor,
			labelNote
		];
	}
	
	var btnTitle = CartLanguage.SaveHtmlWithoutConversion;
	if(useHtmlDesigner)
	{
		btnTitle = CartLanguage.ConvertAbsoluteLinksEditor;
	}
	
	
	var formPanel = new Ext.FormPanel({
		labelAlign: 'top',
		autoScroll: false,
		bodyStyle: "background-color:#ECECEC; padding:5px;",
		width: 600,
		height:600,
		//layout:"fit",
		border:false,
		items:  formItems,
		buttons: [
		{
            text: 'Save',
            iconCls:"icon_table_save",
            tooltip:btnTitle,
            handler: function()
            {
				SaveHandler(true);
			}
////        },{
////            text: 'Save Absolute',
////            tooltip:"NOT RECOMMENDED! Save absolute links as-is and all other links as-is without any conversion.",
////            handler: function()
////            {
////				SaveHandler(false);
////			}
        },{
            text: CartLanguage.Cancel,
            iconCls:"icon_cancel",
            handler: function()
            {
				win.close();
			}
        }]
	});
	
	var allowSave = false;

	win = new Ext.Window({// QoDesk.desktop.createWindow({
		renderTo: document.body,
		id: windowId,
		autoscroll:false,
		taskButton:false,
		minimizable:false,
		maximizable:true,
		title: CartLanguage.WebPageEditor + " - " + record.data.Name,
		width:1030,
		height: document.body.offsetHeight > 1000 ? 1000 - 40 : document.body.offsetHeight - 40,
		iconCls: "template-icon-small",
		shim:false,
		frame:true,
		animCollapse:true,
		constrainHeader:true,
		modal:true,
		resizable:true,
		collapsible:false,
		layout: 'fit',
		items:  formPanel,
		taskbuttonTooltip: "<b>" + this.name + "</b>"
	});
	
	win.on("resize", ResizeEditor);
	win.on("show", ResizeEditor);
	win.show();
	
	var initalHtmLoaded = false;
	
	if(useHtmlDesigner)
	{
		function SetInitHtml()
		{
			var ifr = document.getElementById("webEditorIframe");
			if(ifr != null && ifr.contentWindow && ifr.contentWindow.CuteEditor && ifr.contentWindow.CuteEditor.IsReady == true)
			{
				ifr.contentWindow.CuteEditor.SetHtml(record.data.Content);
				initalHtmLoaded = true;
				//win.maximize(); // maximize window
//				var pos = win.getPosition();
//				alert(pos[0] + "   " +  pos[1]);
//				win.setPosition(pos[0], 0);
//				win.setHeight(document.body.offsetHeight);
//				
			}
			else
			{
				setTimeout(SetInitHtml, 100);
			}
		}
		SetInitHtml();
	}
	else
	{
		initalHtmLoaded = true;
	}
	
	function SaveHandler(relativeLinks)
	{
		if(initalHtmLoaded)
		{
			if(useHtmlDesigner)
			{
				var ifr = document.getElementById("webEditorIframe");
				var html = ifr.contentWindow.CuteEditor.GetHtml(relativeLinks);
				record.set("Content", html);
			}
			else
			{
				record.set("Name", nameItem.getValue());
				record.set("IsActive", isActiveItem.getValue());
				////record.set("SystemActionID", webActionItem.getValue());
				record.set("AscxModulePath", ascxModulePathItem.getValue());
				record.set("Notes", notesItem.getValue());
				record.set("Content", htmlEditor.getValue());
				record.data.MetaTitle = metaTitle.getValue();
				record.data.MetaKeywords = metaKeywords.getValue();
				record.data.MetaDescription = metaDescription.getValue();
			}
			record.commit();
			
			//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Saving);
			//GService.SaveWebPageWithLinksResolving(record.data, false, OnSaved); // relative links conversion is already made at cute editor!!!
			GService.UpdateRows("WebPage", [record.data], function(newDataArray){
				OnSaved(newDataArray[0]);
			});
		}
		else
		{
			alert(CartLanguage.NotLoadedYet);
		}
	}
	
	function OnSaved(webPageObject)
	{
		// update record with Content value from server
		record.set("Content", webPageObject.Content);
		record.set("WebPageID", webPageObject.WebPageID);
		record.commit();
		
		//Ext.MessageBox.ShowWaitMessage(false);
		win.close();		
	}
	
};

