﻿/// <reference path="../language/en.js" />

//////////////////////////////////////////////////////////////////////////////////////////
// USER SETTING EDITOR

QoDesk.UserEdit = function(userRecord)
{
	var ajaxRequests = 0;
	function AjaxRequestStarted(isSaving)
	{
		if(++ajaxRequests == 1)
		{
			if(isSaving == true)
			{
				//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Saving);
			}
			else
			{
				//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Loading);
			}
		}
	}
	
	function AjaxRequestEnded()
	{
		if(--ajaxRequests == 0)
		{
			//Ext.MessageBox.ShowWaitMessage(false);
		}
	}

	// create items
	var userData = [];

	// USER OBJECT
	function CreateUserFields(record)
	{
		var item = new Ext.form.Label({html: "<div style='padding:10px 0 5px 0'><b>" + CartLanguage.AccountInformation + "</b></div>"});
		userData.push(item);

		// Username
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.Username;
		item.value = record.data.Username;
		item.mapTo = "Username";
		userData.push(item);
		
		// Password
		item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.Password;
		item.value = record.data.Password;
		item.mapTo = "Password";
		userData.push(item);
		
		// Email
		item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.Email;
		item.value = record.data.Email;
		item.mapTo = "Email";
		userData.push(item);

		// IsActive
		var boolItem = new Ext.form.Checkbox();// new Ext.grid.BoolEditor(record.data.IsActive);
		boolItem.isCheckbox = true;
		boolItem.setValue(record.data.IsActive);
		boolItem.fieldLabel = CartLanguage.IsActive;
		boolItem.mapTo = "IsActive";
		boolItem.on("select", function(a,b,c,d){boolItem.value = b.data.boolValue;});
		userData.push(boolItem);

		// CreationDate
		item = new Ext.form.DateTimeField();
		item.fieldLabel = CartLanguage.CreationDate;
		item.value = record.data.CreationDate;
		item.mapTo = "CreationDate";
		userData.push(item);

		// LastLoginDate
		item = new Ext.form.DateTimeField();
		item.fieldLabel = CartLanguage.LastLoginDate;
		item.value = record.data.LastLoginDate;
		item.mapTo = "LastLoginDate";
		userData.push(item);

		// Newsletter
		var boolItem = new Ext.form.Checkbox();// new Ext.grid.BoolEditor(record.data.Newsletter);
		boolItem.isCheckbox = true;
		boolItem.setValue(record.data.Newsletter);
		boolItem.fieldLabel = CartLanguage.Newsletter;
		boolItem.mapTo = "Newsletter";
		boolItem.on("select", function(a,b,c,d){boolItem.value = b.data.boolValue;});
		userData.push(boolItem);
	}
	
	CreateUserFields(userRecord);

	var addressData = [];
	
	function CreateAddressFields(record)
	{
		var item = new Ext.form.Label({html: "<div style='padding:10px 0 5px 0'><b>" + CartLanguage.BillingAddressInformation + "</b></div>"});
		addressData.push(item);

		// CountryID
		var countryItem = new QoDesk.SettingsSelectorMod("Country");
		countryItem.fieldLabel = CartLanguage.Country;
		countryItem.mapTo = "CountryID";
		countryItem.OnLoaded = function()
		{
			countryItem.SelectByID(record.data.CountryID);
			// load states by country
			stateItem.LoadByCountryID(record.data.CountryID);
			AjaxRequestEnded();
		};
		countryItem.on("select", function(a,b,c,d)
		{
			countryItem.value = b.data.CountryID;
			// load States by country
			stateItem.LoadByCountryID(countryItem.value);
		});
		addressData.push(countryItem);		
		// load states first
		//////		AjaxRequestStarted();
		//////		countryItem.LoadData();

		// StateID
		var stateItem = new QoDesk.SettingsSelectorMod("State");
		stateItem.emptyText = "- " + CartLanguage.NotApplicable + " -";
		stateItem.fieldLabel = CartLanguage.State;
		stateItem.mapTo = "StateID";
		stateItem.OnLoaded = function()
		{
			var found = stateItem.SelectByID(record.data.StateID);
			if(!found)
			{
				var count = stateItem.store.getCount();
				if(count > 0)
				{
					var rec = stateItem.store.getAt(0);
					stateItem.SelectByID(rec.data.StateID);
				}
				else
				{
					stateItem.setValue(stateItem.emptyText);
				}
			}
			AjaxRequestEnded();
		};
		stateItem.on("select", function(a,b,c,d){stateItem.value = b.data.StateID;});
		stateItem.LoadByCountryID = function(countryID)
		{
			AjaxRequestStarted();
			var method = "Get" + "State" + "CollectionByCountryID";
			GService[method](countryID, true, stateItem.OnDataReceived);
		};
		addressData.push(stateItem);
		
		// states created, load countries
		AjaxRequestStarted();
		countryItem.LoadData();


////		// LanguageID
////		var langItem = new QoDesk.LanguageSelectorMod();
////		langItem.fieldLabel = CartLanguage.Language;
////		langItem.mapTo = "LanguageID";
////		langItem.OnLoaded = function(){
////			langItem.SelectLanguageID(record.data.LanguageID); AjaxRequestEnded();};
////		langItem.on("select", function(a, b, c, d){
////			langItem.value = b.data.LanguageID;});
////		AjaxRequestStarted();
////		langItem.LoadData();
////		addressData.push(langItem);

		// CurrencyID
		var currencyItem = new QoDesk.SettingsSelectorMod("Currency");
		currencyItem.fieldLabel = CartLanguage.Currency;
		currencyItem.mapTo = "CurrencyID";
		currencyItem.OnLoaded = function(){ currencyItem.SelectByID(record.data.CurrencyID);AjaxRequestEnded();};
		currencyItem.on("select", function(a,b,c,d){currencyItem.value = b.data.CurrencyID;});
		AjaxRequestStarted();
		currencyItem.LoadData();
		addressData.push(currencyItem);

		// FirstName,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.FirstName;
		item.value = record.data.FirstName;
		item.mapTo = "FirstName";
		addressData.push(item);

		// LastName,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.LastName;
		item.value = record.data.LastName;
		item.mapTo = "LastName";
		addressData.push(item);

		// Email,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.Email;
		item.value = record.data.Email;
		item.mapTo = "Email";
		addressData.push(item);

		// Address1,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.Address1;
		item.value = record.data.Address1;
		item.mapTo = "Address1";
		addressData.push(item);

		// Address2,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.Address2;
		item.value = record.data.Address2;
		item.mapTo = "Address2";
		addressData.push(item);

		// City,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.City;
		item.value = record.data.City;
		item.mapTo = "City";
		addressData.push(item);

		// Zip,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.Zip;
		item.value = record.data.Address2;
		item.mapTo = "Zip";
		addressData.push(item);

		// PhoneNo,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.PhoneNo;
		item.value = record.data.PhoneNo;
		item.mapTo = "PhoneNo";
		addressData.push(item);

		// MobileNo,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.MobileNo;
		item.value = record.data.MobileNo;
		item.mapTo = "MobileNo";
		addressData.push(item);

		// FaxNo,
		var item = new Ext.form.TextField();
		item.fieldLabel = CartLanguage.FaxNo;
		item.value = record.data.FaxNo;
		item.mapTo = "FaxNo";
		addressData.push(item);

		// Notes,
		var item = new Ext.form.TextArea();
		item.fieldLabel = CartLanguage.Notes;
		item.value = record.data.Notes;
		item.mapTo = "Notes";
		addressData.push(item);
		
		var item = new Ext.form.Label({html: "&nbsp;"});
		addressData.push(item);

	}


	// ADDRESS STORE
	var addressStore = new Ext.data.Store({
		reader: new Ext.data.JsonReader(
		{
			root: "",
			fields:
			[
				{name: "AddressID", type:"int"}
			]
		})
	});
	
	// load address data
	function OnAddressLoaded(addressData)
	{
		if(addressData)
		{
			addressStore.removeAll();
			var m = Ice.Ext.GetMetaData([addressData], addressStore);		
			addressStore.loadData(m);
			CreateAddressFields(addressStore.getAt(0));
			//Ext.MessageBox.ShowWaitMessage(false);
		}
		ShowWindow();
	}
				
	function LoadAddressData(addressID)
	{
		if(addressID > 0)
		{
			//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Loading);
			GService.GetAddress(addressID, OnAddressLoaded);
		}
		else
		{
			OnAddressLoaded();
		}
	}
	
	var win;
	
	function AppendArray(destArray, sourceArray)
	{
		for(var n = 0; n < sourceArray.length; n++)
		{
			var item = sourceArray[n];
			if( ! item.isCheckbox)
			{
				item.width = 230;
			}
			destArray.push(item);
		}
		return destArray;
	}
	
	function ShowWindow()
	{
		var itemsAll = [];
		AppendArray(itemsAll, userData);
		AppendArray(itemsAll, addressData);
		
		var formPanel = new Ext.FormPanel({
			labelWidth: 185, // label settings here cascade unless overridden
			hideBorders: true,
			autoScroll: true,
			bodyStyle: "background-color:#ECECEC; padding-left:5px;",
			//defaults: {width: 230},
			items: itemsAll,
			defaultType: 'textfield'		
		});

		win = new Ext.Window({// QoDesk.desktop.createWindow({
			renderTo: document.body,
			id: "userEditor",
			title: CartLanguage.UserEditor + " - " + userRecord.data.Username,
			width:470,
			height: document.body.offsetHeight > 700 ? 700 - 40 : document.body.offsetHeight - 40,
			iconCls: 'users-icon-small',
			shim:false,
			animCollapse:true,
			constrainHeader:true,
			modal:true,
			resizable:true,
			taskButton:false,
			minimizable:false,
			maximizable:false,
			collapsible:false,
			layout: 'fit',
			items:  formPanel,
			buttons: [{
				text: CartLanguage.Save,
				iconCls:"icon_table_save",
				handler: function()
				{
					SaveAddressRecord();
				}
			},{
				text: CartLanguage.Cancel,
				iconCls:"icon_cancel",
				handler: function()
				{
					win.close();
				}
			}],
			taskbuttonTooltip: "<b>" + this.name + "</b>"
		});
		
		win.on("show", function(){win.setWidth(win.getSize().width + 1);});  // IE 7 rendering issue fix
		
		win.show();
	}
		
	function SaveUserRecord(addressObject)
	{
		userRecord.data.AddressID = addressObject.AddressID;
		userRecord.commit();
		
		var arr = [];
		arr.push(userRecord.data);
		GService.SaveUserCollection(arr, OnDataSaved);
	}
	
	function SaveAddressRecord()
	{
		AjaxRequestStarted(true);	
		// user data
		for(var n = 0; n < userData.length; n++)
		{
			if(userData[n].mapTo)
			{
				var tmpValue = userData[n].getValue();
				if(tmpValue != CartLanguage.Loading)
				{
					userRecord.set(userData[n].mapTo, tmpValue);
				}
			}
		}
		// address data
		var record = addressStore.getAt(0);
		if(record)
		{
			for(var n = 0; n < addressData.length; n ++)
			{
				if(addressData[n].mapTo)
				{
					var tmpValue = addressData[n].getValue();
					if(tmpValue != CartLanguage.Loading)
					{
						record.set(addressData[n].mapTo, tmpValue);
					}
				}
			}
			////// use email from User object
			////record.set("Email", userRecord.data.Email);
			record.commit();
			GService.SaveAddress(record.data, SaveUserRecord);
		}
		else
		{
			SaveUserRecord({});
		}
	}
	
	function OnDataSaved()
	{
		AjaxRequestEnded();
		win.close();
	}

	// load address data	
	LoadAddressData(userRecord.data.AddressID);

};