﻿/// <reference path="../../ice-fix-ext-before.js" />
/// <reference path="../../Ext_21/source/core/Ext.js" />
/// <reference path="../../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../../Ext_21/ext-all-debug.js" />
/// <reference path="../../ice-fix-ext-after.js" />
/// <reference path="../../IceExtExtensions.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />

QoDesk.GetRolesTree = function(onNodeClick){
	//alert("GetCategoriesTree");
	
	function EditOrAddNewRow(sender, forceInsert, iconCls)
	{
		var node = tree.selModel.selNode || tree.root;
		var parentId = node ? node.nodeId : null;
		var record = null;
		
		if(forceInsert)
		{
			record = 
			{
				data:
				{
					Name: node.nodeData ? (node.nodeData.Name)  : null,
					ClicksCount: 0,
					Ordinal:0
				}
			};
		}
		else
		{	
			record = {data:node.nodeData};
		}
		
		if(!forceInsert && ! tree.selModel.selNode)
		{
			alert("Nothing selected!");
			return;
		}
		
		var method;
		if(forceInsert)
		{
			method = node.reload.createDelegate(node);
		}
		else if (node.parentNode)
		{
			method = node.parentNode.reload.createDelegate(node.parentNode);
		}
		else
		{
			return; // editing root node!!!
		}
		
		var cfg = {
			tableName: "Role",
			hideSchemaInfo:true,
			animateTarget: node.ui.textNode,
			onSaved: method,
			record: record,
			forceInsert: forceInsert,
			iconCls : iconCls,
			multiline: true // use TextArea editor instead of TextField
		};

		Ice.DbAdmin.ShowFormAddNew(cfg);
	}
	
	function DeleteNode()
	{
		var node = tree.selModel.selNode;
		
		function DoDelete(result)
		{
			if(result == "yes")
			{
				GService.DeleteRows("Role", [node.nodeData], function(count){
						if(count > 0)
						{
							tree.selModel.selNode.remove();
						}
					});
			}
		}
		
		if(node != null && node.isLoaded() && node.childNodes.length == 0)
		{
			//Ext.MessageBox.confirm("Please confirm!", "Are you sure?", DoDelete);
			if(confirm("Are you sure?"))
			{
				DoDelete("yes");
			}
		}
		else
		{
			//Ext.MessageBox.alert("Can't delete!", "Expand & delete children first!");
			alert("Expand & delete children first!");
		}
	}
	
	function ReloadChildren()
	{
		var node = tree.selModel.selNode ? tree.selModel.selNode : tree.root;
		node.reload();
	}
	
    var tree = new Ext.tree.TreePanel({
       // el:'tree-div',
        useArrows:false,
        autoScroll:true,
        animate:true,
        enableDD:true,
        containerScroll: true,
        //lines:false,
        rootVisible:true,
        border:true,
		tbar:
		[
			{
				text: "Edit",
				iconCls:"icon_page_white_edit",
				handler: function(sender, e){EditOrAddNewRow(sender.el.dom, false, this.iconCls);}
			},
			"-",
			{
				text: "New",
				iconCls:"icon_page_white_add",
				handler: function(sender, e){EditOrAddNewRow(sender.el.dom, true, this.iconCls);}
			},
			"-", 
			{
				text: "Delete",
				iconCls:"icon_page_white_delete",
				handler: DeleteNode
			},
			"-",
			{
				text: "Reload",
				iconCls:"icon_page_refresh",
				handler: ReloadChildren
			}

		],
        

        root: new Ext.tree.AsyncTreeNode({
            text: 'All',
            draggable:false,
            expanded:true
            //,allowDrop:false
        }),
        
        loader: new Ext.tree.GTreeLoader({
			url: GService.GetRoleCollectionTreeNodes, // web service method
			
			applySingleState: function(letter, isActive, titleActive, titleNotActive){
				if(isActive)
				{
					return "<span title='" + titleActive + "' style='background-color:#00CC00;'>" + letter + "</span>";
				}
				else
				{
					return "<span title='" + titleNotActive + "' style='background-color:#FF0000;'>" + letter + "</span>";
				}
			},
			applyState : function(data){
				
				var prefix = "";
				prefix += this.applySingleState("A", data.IsActive, "Active", "NotActive");
//				prefix += this.applySingleState("P", data.IsPublished, "Published", "NotPublished");
//				prefix += this.applySingleState("M", data.IsInMap, "IncludeInSiteMap", "ExcludeFromSiteMap");
//				prefix += this.applySingleState("T", data.IsInTree, "IncludeInTreeMenu", "ExcludeFromTreeMenu");

				if(prefix.length > 0)
				{
					prefix += "&nbsp;";
				}
				
				var text = prefix + data.Name;
//				if(this.CategoryObject && this.ownerTree.ShowClicks)
//				{
//					text += "&nbsp;<span title='clicks: " + this.CategoryObject.ClicksCount + "' style='background-color:yellow;'>" + this.CategoryObject.ClicksCount + "</span>";
//				}
//				this.IsNodeActive = isActive;
//				this.setText(text);
				return text;				
			},
			createNode: function(data){
				var node = new Ext.tree.AsyncTreeNode();
				node.text = this.applyState(data);
				node.nodeId = data.RoleID;
				node.nodeData = data;
				return node;
			
			}
		})
		
    });
    
    tree.root.nodeId = ""; // root category id: null
    
    tree.on("click", onNodeClick);
    
    tree.on("dragdrop", function(tree, node, dd, e){
		
		var count = node.parentNode.childNodes.length;
		var arr = [];
		for(var n  = 0; n < count ; n++)
		{
			var tnode = node.parentNode.childNodes[n];
			var data = tnode.nodeData;
			data.ParentCategoryID = node.parentNode.nodeId;
			data.Ordinal = count - n;
			arr.push(data);
		}
		if(arr.length > 0)
		{
			GService.UpdateRows("Role", arr, function(newRows){
				//node.parentNode.reload(); // not needed
			});
		}
    });
    
    
    tree.afterRenderBase = tree.afterRender;
    tree.afterRender = function(o){
    
		tree.afterRenderBase(o);
		
		tree.dropZone.onNodeDropBase = tree.dropZone.onNodeDrop;
		tree.dropZone.onNodeOverBase = tree.dropZone.onNodeOver;
			
    	tree.dropZone.addToGroup("ddGridWithPagingUser");
		
		tree.dropZone.onNodeDrop = function(n, dd, e, data){
			if(data.node)
			{
				return tree.dropZone.onNodeDropBase.apply(tree.dropZone, arguments);
			}
			var point = this.getDropPoint(e, n, dd);
			var targetNode = n.node;
			targetNode.ui.startDrop();
			if(!this.isValidDropPoint(n, point, dd, e, data)){
				targetNode.ui.endDrop();
				return false;
			}
			targetNode.ui.endDrop();
			
			if(!targetNode.nodeId)
			{
				return false;
			}
			var arr = [];
			for(var index = 0; index < data.selections.length; index ++)
			{
				arr.push(data.selections[index].data.UserID);
			}
	        
			GService.UsersInRoles([targetNode.nodeId], arr, true, function(count){
				if(count == 0)
				{
					alert("Already added to category.");
				}
				else
				{
					alert("Added " + count + " item(s).");
				}
			});
			return false;
		};
     
		tree.dropZone.onNodeOver = function(n, dd, e, data){
			if(data.node)
			{
				return tree.dropZone.onNodeOverBase.apply(tree.dropZone, arguments);
			}

			var pt = this.getDropPoint(e, n, dd);
			var node = n.node;
	        
			if(!this.expandProcId && node.hasChildNodes() && !n.node.isExpanded())
			{
				this.queueExpand(node);
			}
			var returnCls = this.dropNotAllowed;
			if(this.isValidDropPoint(n, pt, dd, e, data)){
			   if(pt)
			   {
				   var el = n.ddel;
				   var cls;
	               
					returnCls = "x-tree-drop-ok-append";
					cls = "x-tree-drag-append";
	              
				   if(this.lastInsertClass != cls)
				   {
						//  Ext.fly(el).replaceClass(this.lastInsertClass, cls);
					   this.lastInsertClass = cls;
				   }
			   }
		   }
		   return returnCls;
		};
		
    };
    
    var menu = new Ext.menu.Menu({
		width:160,
		items: 
		[
			{
				text: "Edit",
				iconCls:"icon_page_white_edit",
				handler: function(sender, e){EditOrAddNewRow(sender.el.dom, false, this.iconCls);}
			},
			"-",
			{
				text: "New",
				iconCls:"icon_page_white_add",
				handler: function(sender, e){EditOrAddNewRow(sender.el.dom, true, this.iconCls);}
			},
			"-", 
			{
				text: "Delete",
				iconCls:"icon_page_white_delete",
				handler: DeleteNode
			},
			"-",
			{
				text: "Reload",
				iconCls:"icon_page_refresh",
				handler: ReloadChildren
			}

		]
	});
	
	
	tree.on("contextmenu", function(node, e){
		var xy = e.xy;
		e.stopEvent();
		node.select();		
		xy[0] = xy[0] - 10;
		xy[1] = xy[1] - 10;
		menu.showAt(xy);
		return false;
	}, tree);
    
    return tree;
    
};

